/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Liste_Sous_Reseau.h"
#include "Debug.h"
#include "Declaration_Constante.h"
#include "Thread_Scanne_Plage.h"
#include "Scan_Arp.h"
#include "Mem.h"
#ifdef         __WINDOWS_ENABLE  
#include "Win32.h"  
#endif  


void Scanne_Tous_Sous_Reseau ()
{
	struct Struct_Liste_Reseau *Reseau = NULL;
	gint      Nb_Objet_Liste, i;
	
	PROTECT_GLIST_LISTE_SOUS_RESEAU();
	Nb_Objet_Liste = g_list_length (GList_Sous_Reseau);
	DEPROTECT_GLIST_LISTE_SOUS_RESEAU();
	for (i = 0; i < Nb_Objet_Liste; i++) {
		PROTECT_GLIST_LISTE_SOUS_RESEAU();
		Reseau = g_list_nth_data (GList_Sous_Reseau, i);
		DEPROTECT_GLIST_LISTE_SOUS_RESEAU();
		Scanner_Plage(Reseau,TRUE);
	}
}
void Scanne_Liste_Sous_Reseau_Restaurer (gint Nb_Sous_Reseau_Restorer)
{
	struct Struct_Liste_Reseau *Reseau = NULL;
	gint      i;

	for (i = 0; i < Nb_Sous_Reseau_Restorer; i++) {
		PROTECT_GLIST_LISTE_SOUS_RESEAU();
		Reseau = g_list_nth_data (GList_Sous_Reseau, i);
		DEPROTECT_GLIST_LISTE_SOUS_RESEAU();
		Start_Thread (*Thread_Scanner_Plage, (gpointer *) Reseau);
	}
}

gint Recherche_Index_Sous_Reseau (gchar * Sous_Reseau)
{
	struct Struct_Liste_Reseau *Reseau = NULL;
	gint      Nb_Objet_Liste, i;

	ERROR_if (Sous_Reseau == NULL);
	PROTECT_GLIST_LISTE_SOUS_RESEAU();
	Nb_Objet_Liste = g_list_length (GList_Sous_Reseau);
	DEPROTECT_GLIST_LISTE_SOUS_RESEAU();
	for (i = 0; i < Nb_Objet_Liste; i++) {
		PROTECT_GLIST_LISTE_SOUS_RESEAU();
		Reseau = g_list_nth_data (GList_Sous_Reseau, i);
		DEPROTECT_GLIST_LISTE_SOUS_RESEAU();
		if (memcmp (Reseau->Sous_Reseau, Sous_Reseau, 3) == 0) {
			return i;
		}
	}
	return -1;
}

void Ajout_Sous_Reseau (gchar * Sous_Reseau, gboolean Scanne_Plage, gboolean MaPlage)
{
	struct Struct_Liste_Reseau *Reseau = NULL;

	PROTECT_GLIST_LISTE_SOUS_RESEAU();
	ERROR_if (Sous_Reseau == NULL);
	MALLOC(Reseau,sizeof (struct Struct_Liste_Reseau));
	memcpy (Reseau->Sous_Reseau, Sous_Reseau, IP_ADDR_LEN - 1);
	Reseau->Deja_Scanner = FALSE;
	if (MaPlage){
		Reseau->Ma_Plage = TRUE;
		Reseau->Speed_Scan = FALSE;
		DEBUG_INFO("Nouveau Sous-Reseau (Ma Plage): %d.%d.%d", Reseau->Sous_Reseau[0], Reseau->Sous_Reseau[1], Reseau->Sous_Reseau[2]);
	}
	else 
		DEBUG_INFO("Nouveau Sous-Reseau : %d.%d.%d", Reseau->Sous_Reseau[0], Reseau->Sous_Reseau[1], Reseau->Sous_Reseau[2]);
	G_LIST_APPEND (GList_Sous_Reseau, Reseau);
	DEPROTECT_GLIST_LISTE_SOUS_RESEAU();
	if (Scanne_Plage)
		Start_Thread (*Thread_Scanner_Plage, (gpointer *) Reseau);
}


void Initialisation_Liste_Sous_Reseau (void)
{
	GList_Sous_Reseau = NULL;
}
