/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Log.h"
#include "Debug.h"
#include "Mem.h"
#include "BackTrace.h"
#include "Configuration.h"
#include "Tools.h"

#ifdef __LOG_ENABLE

struct Struct_Categorie Liste_Categorie[] = {
	{CATEG_MAIN, "Main"																						, "main_daemon"					, NULL,-1,0,FALSE,FALSE},
	{CATEG_THREAD_DETECT, "Thread Detect"														, "thread_detect"					, NULL,-1,0,FALSE,FALSE},
	{CATEG_THREAD_SCAN, "Thread Scan equipement"											, "equipement"				, NULL,-1,0,FALSE,FALSE},
	{CATEG_THREAD_NOTIF_PORT, "Thread Notification Port"									, "thread_notif_port"				, NULL,-1,0,FALSE,FALSE},
	{CATEG_THREAD_NOTIF_EQU, "Thread Notification équipement"						, "thread_notif_equi"				, NULL,-1,0,FALSE,FALSE},
	{CATEG_BOUCLE_COMMUNIC, "Thread Boucle Communication"							, "thread_boucle_comm"		, NULL,-1,0,FALSE,FALSE},
	{CATEG_RAFFRAICHIR_EQU, "Thread Rafraichir Tout Equipement"						, "thread_rafrai_equ"			, NULL,-1,0,FALSE,FALSE},
	{CATEG_THREAD_SNMP_LISTE_ALL, "CATEG_THREAD_SNMP_LISTE_ALL"			, "thread_snmp_liste_all"		, NULL,-1,0,FALSE,TRUE},
	{CATEG_THREAD_SNMP_LISTE, "CATEG_THREAD_SNMP_LISTE"							, "thread_snmp_liste"			, NULL,-1,0,FALSE,TRUE},
	{CATEG_BOUCLE_SCAN, "CATEG_BOUCLE_SCAN"												, "thread_boucle_scan"			, NULL,-1,0,FALSE,FALSE},
	{CATEG_INFO_AGENT, "CATEG_INFO_AGENT"													, "thread_info_agent"			, NULL,-1,0,FALSE,FALSE},
	{CATEG_PING_DETECT, "CATEG_PING_DETECT"													, "thread_ping_detect"			, NULL,-1,0,FALSE,TRUE},
	{CATEG_SCAN_PLAGE, "CATEG_SCAN_PLAGE"													, "thread_scan_plage"			, NULL,-1,0,FALSE,FALSE},
	{CATEG_THREAD_ETAT_EQUIPEMENT, "CATEG_THREAD_ETAT_EQUIPEMENT"		, "thread_etat_equi"				, NULL,-1,0,FALSE,FALSE},
	{CATEG_THREAD_WAKEUP, "CATEG_THREAD_WAKEUP"										, "thread_wakeup"				, NULL,-1,0,FALSE,FALSE},
	{CATEG_IP_DYNAMIC, "CATEG_IP_DYNAMIC"														, "thread_ip_dyn"					, NULL,-1,0,FALSE,FALSE},
	{CATEG_THREAD_SNMP_SCALAIRE, "CATEG_THREAD_SNMP_SCALAIRE"				, "thread_snmp_scalaire"		, NULL,-1,0,FALSE,TRUE},
	{CATEG_COMM_SEND, "CATEG_COMM_SEND"													, "send"							, NULL,-1,0,FALSE,FALSE},
	{CATEG_COMM_RECV, "CATEG_COMM_RECV"														, "recv"							, NULL,-1,0,FALSE,FALSE},
	{CATEG_REFRESH_TOUT_EQU, "Thread Rafraichir Tout Info Equipement"			, "thread_refresh_tout_equ"	, NULL,-1,0,FALSE,FALSE},
	{CATEG_ARP_DETECT_EQU, "Thread Scan Arp Detect Nouveau Equipement"		, "thread_arp_detect_equ"	, NULL,-1,0,FALSE,FALSE}
};



void create_cle_privee (void)
{
	if (pthread_key_create (&Cle_privee_thread, NULL) == -1)
		 DEBUG_ERROR("pthread_key_create");
}

void Message_Erreur_Critique (struct struct_Cle_Privee *pCle, gint Type_message)
{
	struct Struct_Liste_Equipement *Equipement = NULL;
	struct struct_Retour_Erreur_Critique Message_Critique;
	gchar    *line[TAILLE_INFO_ERREUR_CRITIQUE], *chemin=NULL;
	gint      Taille_Fichier = 0,A_Lire = 0;
	FILE *fd = NULL;
	
	if (Demarrage_Complet_Agent) {
	
		bzero (&Message_Critique, sizeof (struct struct_Retour_Erreur_Critique));
		Message_Critique.ID_Reseau = Info_Demarrage.ID_Reseau;
		Message_Critique.Type_message = Type_message;
		if (pCle == NULL) {
			strcpy (Message_Critique.Thread, "??");
			strcpy (Message_Critique.Objet, "??");
			strcpy (Message_Critique.Info, "??");
		}
		else {
			strcpy (Message_Critique.Thread, Liste_Categorie[pCle->Categorie].Info);
			strcpy (Message_Critique.Objet, "none");
			switch (pCle->Categorie) {
			    case CATEG_THREAD_SCAN:
				    Equipement = pCle->Pointeur_Data;
				    strcpy ((char *)Message_Critique.Objet, (char *)Equipement->Adresse_Ip_Char);
				    break;
			    case CATEG_THREAD_SNMP_LISTE_ALL:
				    Equipement = pCle->Pointeur_Data;
				    strcpy ((char *)Message_Critique.Objet, (char *)Equipement->Adresse_Ip_Char);
				    break;
			    case CATEG_THREAD_SNMP_LISTE:
				    Equipement = pCle->Pointeur_Data;
				    strcpy ((char *)Message_Critique.Objet, (char *)Equipement->Adresse_Ip_Char);
				    break;
				case CATEG_THREAD_SNMP_SCALAIRE:
				    Equipement = pCle->Pointeur_Data;
				    strcpy ((char *)Message_Critique.Objet, (char *)Equipement->Adresse_Ip_Char);
				    break;
			}
			
		
			if (pCle->Categorie != CATEG_THREAD_SCAN){
				if (Liste_Categorie[pCle->Categorie].Chemin_Fichier_Log == NULL)
					return;
				chemin =g_strdup( Liste_Categorie[pCle->Categorie].Chemin_Fichier_Log);
			}
			else
				chemin = g_strdup(Equipement->Fichier_Log);
		
		
			if ((fd=fopen(chemin,"r+")) == NULL){
				printf("Impossible d'ouvrir le fichier log : %s\n",chemin);
				strcat (Message_Critique.Info, "Impossible d'ouvrir le fichier log : ");
				strcat (Message_Critique.Info, chemin);
				Communication_Envoie_Donnee (RETOUR_ERREUR_CRITIQUE, (gpointer *) & Message_Critique, sizeof (Message_Critique));
				return;
			}
		
			fseek(fd,0,SEEK_END);
		
			Taille_Fichier = ftell(fd);
			if (Taille_Fichier<=TAILLE_INFO_ERREUR_CRITIQUE){
				fseek(fd,0,SEEK_SET);
				A_Lire = Taille_Fichier;
			}
			else {
				fseek(fd,Taille_Fichier-TAILLE_INFO_ERREUR_CRITIQUE+1,SEEK_SET);
				A_Lire = TAILLE_INFO_ERREUR_CRITIQUE - 1;
			}
			while ((A_Lire>1)&&(fgets((char *)line, A_Lire, fd) != NULL)){
				strcat ((char *)Message_Critique.Info,(char *)line);
				A_Lire = A_Lire - strlen((char *)line);
			}
			fclose(fd);
			MYFREE(chemin);
		}
		NONBLOCK_SOCKET(client_id,SOCKET_NON_BLOQUANT);
		Communication_Envoie_Donnee (RETOUR_ERREUR_CRITIQUE, (gpointer *) & Message_Critique, sizeof (Message_Critique));
	}
}


void Log (struct struct_Cle_Privee *Donnee_Cle,gchar *Log){
#ifdef __LOG_ENABLE
	struct struct_Retour_Info_Debug Message;
	struct Struct_Liste_Equipement* Equipement = NULL;
	gint Taille_Chaine = 0;
	ERROR_if (Donnee_Cle == NULL);
	ERROR_if (Log == NULL);

	PROTECT_CODE(Semaphore_Log_File);
	if (Donnee_Cle->ID_Fichier_Log > 0){
		Taille_Chaine = strlen(Log);
		if (Taille_Chaine!=write(Donnee_Cle->ID_Fichier_Log,Log,Taille_Chaine)){
			printf("ERROR : Create log  (write) : [%s] --> [%s]\n",Liste_Categorie[Donnee_Cle->Categorie].Info,Log);
		}
	}
	DEPROTECT_CODE(Semaphore_Log_File);
/*	if (Donnee_Cle->Categorie==CATEG_THREAD_SCAN){
		Equipement = Donnee_Cle->Pointeur_Data;
		bzero (&Message, sizeof (struct struct_Retour_Info_Debug));
		Message.ID_Reseau = Info_Demarrage.ID_Reseau;
		memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Message.Niveau_Info = 0;
		if (strlen (Log) >= TAILLE_RETOUR_INFO_DEBUG){
			strncpy (Message.Info, Log,TAILLE_RETOUR_INFO_DEBUG-1);
			Message.Info[TAILLE_MAX_MESSAGE_DEBUG] = 0;
		}
		else
			strcpy (Message.Info, Log);
	
		if (strlen (Message.Info) > 1)
				Message.Info[strlen (Message.Info)-1] = 0;
		Communication_Envoie_Donnee (RETOUR_INFO_DEBUG, (gpointer *) & Message, sizeof (Message));
	}*/
#endif	
}


struct struct_Cle_Privee *Create_Log (gint Categorie,gchar *name,void *Data,gboolean Attache_Thread){
#ifdef __LOG_ENABLE
	PROTECT_CODE(Semaphore_Log_File);	
	struct struct_Cle_Privee *Donnee_Cle = NULL;
	gchar	*Fichier_Log = NULL;
	gboolean re_use = FALSE;
	
	if (Attache_Thread)
		pthread_once(&once_cle_privee,create_cle_privee);
	MALLOC(Donnee_Cle,sizeof(struct struct_Cle_Privee));
	Donnee_Cle->Categorie = Categorie;
	Donnee_Cle->Pointeur_Data = Data;


	if ((Liste_Categorie[Categorie].used==0)  || ( Categorie == CATEG_THREAD_SCAN) || (name!=NULL)) {
		if (name!=NULL){
			if (Config_Path_Logs == NULL)
				STRDUP_PRINTF(Fichier_Log,"/var/log/autoscan-network/%s_%s",Liste_Categorie[Categorie].Fichier_Log,name);
			else
				STRDUP_PRINTF(Fichier_Log,"%s/%s_%s",Config_Path_Logs,Liste_Categorie[Categorie].Fichier_Log,name);
		}
		else	{
			if (Liste_Categorie[Categorie].Chemin_Fichier_Log == NULL) {
					if (Config_Path_Logs == NULL)
						STRDUP_PRINTF(Fichier_Log, "/var/log/autoscan-network/%s",Liste_Categorie[Categorie].Fichier_Log);
					else
						STRDUP_PRINTF(Fichier_Log, "%s/%s",Config_Path_Logs, Liste_Categorie[Categorie].Fichier_Log);
					Liste_Categorie[Categorie].Chemin_Fichier_Log = g_strdup(Fichier_Log);
			}
			else
				Fichier_Log = g_strdup(Liste_Categorie[Categorie].Chemin_Fichier_Log);
		}
		printf("{%s}\n",Fichier_Log);
		
		if (Liste_Categorie[Categorie].deja_ouvert)
			Donnee_Cle->ID_Fichier_Log = open(Fichier_Log, O_WRONLY | O_CREAT | O_APPEND , 0644);
		else
			Donnee_Cle->ID_Fichier_Log = open(Fichier_Log, O_WRONLY | O_CREAT | O_TRUNC , 0644);
		if (Donnee_Cle->ID_Fichier_Log<0){
			printf("ERROR : Create log  (open)  %s\n",Liste_Categorie[Categorie].Fichier_Log);
			DEPROTECT_CODE(Semaphore_Log_File);
			return NULL;
		}
		if (name == NULL)
			Liste_Categorie[Categorie].deja_ouvert = TRUE; 
		MYFREE(Fichier_Log);
		re_use = FALSE;
		Liste_Categorie[Categorie].ID_Fichier_Log = Donnee_Cle->ID_Fichier_Log;
	}
	else {
		Donnee_Cle->ID_Fichier_Log = Liste_Categorie[Categorie].ID_Fichier_Log;
		re_use = TRUE;
	}

	if (name == NULL)
		Liste_Categorie[Categorie].used++;
	
	if (Attache_Thread)
		pthread_setspecific(Cle_privee_thread,Donnee_Cle);
	DEPROTECT_CODE(Semaphore_Log_File);

	if (name == NULL){
		if (re_use)
			LOG_PRINTF(Donnee_Cle,"*************** Re_use [%s]  used(%d)\n",Liste_Categorie[Categorie].Info,Liste_Categorie[Categorie].used); 
		else
			LOG_PRINTF(Donnee_Cle,"*************** Open [%s]  used(%d)\n",Liste_Categorie[Categorie].Info,Liste_Categorie[Categorie].used);
	}
	
	LOG_PRINTF(Donnee_Cle,"---------------------------------------\n------- %s ------\n---------------------------------------\n\n\n",Liste_Categorie[Categorie].Info);
	return Donnee_Cle;
#endif
}


void Close_Log_Thread (struct struct_Cle_Privee *Donnee_Cle){
#ifdef __LOG_ENABLE

	ERROR_if(Donnee_Cle == NULL);
	ERROR_if(Liste_Categorie[Donnee_Cle->Categorie].used <= 0);
	if (!Liste_Categorie[Donnee_Cle->Categorie].reste_ouvert){
	
		switch (Donnee_Cle->Categorie) {
			case CATEG_THREAD_SCAN :
				LOG_PRINTF(Donnee_Cle,"*************** Close Thread Scan Equipment [%s]  used(%d)\n",Liste_Categorie[Donnee_Cle->Categorie].Info,Liste_Categorie[Donnee_Cle->Categorie].used);
				break;
			default :
				if (Liste_Categorie[Donnee_Cle->Categorie].used == 1)
					LOG_PRINTF(Donnee_Cle,"*************** Close log : [%s]  used(%d)\n",Liste_Categorie[Donnee_Cle->Categorie].Info,Liste_Categorie[Donnee_Cle->Categorie].used);
				else
					LOG_PRINTF(Donnee_Cle,"*************** NoClose log : [%s] used(%d)\n",Liste_Categorie[Donnee_Cle->Categorie].Info,Liste_Categorie[Donnee_Cle->Categorie].used);
		}
	
		PROTECT_CODE(Semaphore_Log_File);
		switch (Donnee_Cle->Categorie) {
			case CATEG_THREAD_SCAN :// toujours fermer le fichier si c'est le thread du scan d'equipement
					
					if (Donnee_Cle->ID_Fichier_Log<=0) {
						printf("Error : close (%s)\n",Liste_Categorie[Donnee_Cle->Categorie].Fichier_Log);
						DEPROTECT_CODE(Semaphore_Log_File);
						return;
					}
					close(Donnee_Cle->ID_Fichier_Log);
					Donnee_Cle->ID_Fichier_Log = 0;
					Liste_Categorie[Donnee_Cle->Categorie].used--;
					break;
			default :
					if (Liste_Categorie[Donnee_Cle->Categorie].used == 1) { 
						
						if (Donnee_Cle->ID_Fichier_Log<=0) {
							printf("Error : close (%s)\n",Liste_Categorie[Donnee_Cle->Categorie].Fichier_Log);
							DEPROTECT_CODE(Semaphore_Log_File);
							return;
						}
						close(Donnee_Cle->ID_Fichier_Log);
						Donnee_Cle->ID_Fichier_Log = 0;
						Liste_Categorie[Donnee_Cle->Categorie].ID_Fichier_Log = -1;
					}
					Liste_Categorie[Donnee_Cle->Categorie].used--;					
		}
		DEPROTECT_CODE(Semaphore_Log_File);
	}
	else {
		if (Liste_Categorie[Donnee_Cle->Categorie].used != 1)
		Liste_Categorie[Donnee_Cle->Categorie].used--;
		LOG_PRINTF(Donnee_Cle,"*************** NoClose_	: [%s]  used(%d)\n",Liste_Categorie[Donnee_Cle->Categorie].Info,Liste_Categorie[Donnee_Cle->Categorie].used);
	}
#endif
}




void Create_Log_Equipement (struct Struct_Liste_Equipement *Equipement){
#ifdef __LOG_ENABLE
	ERROR_if(Equipement == NULL);
	PROTECT_CODE(Semaphore_Log_File);
	
	
	if (Equipement->Fichier_Log == NULL){ 
		if (Config_Path_Logs == NULL)
			STRDUP_PRINTF(Equipement->Fichier_Log,"/var/log/autoscan-network/scan/%s_%s",Liste_Categorie[CATEG_THREAD_SCAN].Fichier_Log,Equipement->Adresse_MAC_Char);
		else
			STRDUP_PRINTF(Equipement->Fichier_Log,"%s/scan/%s_%s",Config_Path_Logs,Liste_Categorie[CATEG_THREAD_SCAN].Fichier_Log,Equipement->Adresse_MAC_Char);
		str_remplace(Equipement->Fichier_Log,':','_');
		printf("{%s}\n",Equipement->Fichier_Log);
		Equipement->ID_Fichier_Log = open(Equipement->Fichier_Log, O_WRONLY | O_CREAT | O_TRUNC , 0644);
	}
	else {
		Equipement->ID_Fichier_Log = open(Equipement->Fichier_Log, O_WRONLY | O_CREAT | O_APPEND , 0644);
	}
	if (Equipement->ID_Fichier_Log < 0){
		printf("ERROR : Create log  (open)  %s\n",Equipement->Fichier_Log);
		DEPROTECT_CODE(Semaphore_Log_File);
		return;
	}
	Liste_Categorie[CATEG_THREAD_SCAN].used++;
	DEPROTECT_CODE(Semaphore_Log_File);
	
	Log_Equipement(Equipement,"--------------------------------\n");
	Log_Equipement(Equipement,(gchar *)Equipement->Adresse_Ip_Char);
	Log_Equipement(Equipement,"\n");
	Log_Equipement(Equipement,(gchar *)Equipement->Adresse_MAC_Char);
	Log_Equipement(Equipement,"\n--------------------------------\n");
#endif
}


void Log_Equipement (struct Struct_Liste_Equipement *Equipement, gchar * Log)
{
#ifdef __LOG_ENABLE
	ERROR_if(Equipement == NULL);
	ERROR_if(Log == NULL);
	PROTECT_CODE(Semaphore_Log_File);
	gint Taille_Chaine = 0;
	
	if (Equipement->ID_Fichier_Log > 0){
		Taille_Chaine = strlen(Log);
		if (Taille_Chaine!=write(Equipement->ID_Fichier_Log,Log,Taille_Chaine)){
			printf("ERROR : Log_Equipement  (write)\n");
			DEPROTECT_CODE(Semaphore_Log_File);
			exit (-1);
		}
	}
	DEPROTECT_CODE(Semaphore_Log_File);
#endif
}



void Ckeck_Fermeture_Log (){
#ifdef __LOG_ENABLE
	gint i = 0;
	
	for (i=0;i<NB_CATEGORIE_DEBUG;i++)
		if ((!Liste_Categorie[i].reste_ouvert) && (Liste_Categorie[i].used!=0))
				printf("ERROR : Close log [%s]\n",Liste_Categorie[i].Info);
#endif
}


void Close_Log_Main(){
#ifdef __LOG_ENABLE
	Close_Log_Thread(Donnee_Cle_Main);
#endif
}


void Initialisation_Repertoire_Log(){
#ifdef __LOG_ENABLE

	if (Config_Path_Logs == NULL){ 
		Create_Dir("/var/log/autoscan-network/",0766);
		Create_Dir("/var/log/autoscan-network/scan/",0766);
	}
#endif
}


void Initialisation_Log (void)
{
	#ifdef         __DEBUG_MEM
	Initialisation_Mem();
	#endif

	init_backtrace();
	once_cle_privee = PTHREAD_ONCE_INIT;

	Donnee_Cle_Main = Create_Log(CATEG_MAIN,NULL,NULL,TRUE);
}
#endif  


void Envoie_Log_Equipement (gpointer * Donnee)
{
	ERROR_if (Donnee == NULL);
#ifdef __LOG_ENABLE
	struct struct_Demande_Log_Equipement *Message = (struct struct_Demande_Log_Equipement *) Donnee;
	struct struct_Retour_Log_Equipement Message_Retour;
	struct Struct_Liste_Equipement *Equipement = NULL;
	gint      ID_Equipement = 0, Taille_Fichier = 0,A_Lire = 0,Taille_Envoie = 0;
	FILE 	 *fd = NULL;
	gchar    *line[BUFSIZ];
	
	Recherche_Index_Equipement (Message->ID_Equipement, FALSE, &ID_Equipement);
	Retour_Pointeur_Equipement (&Equipement,ID_Equipement);
	ERROR_if (Equipement == NULL);

	bzero (&Message_Retour, sizeof (struct struct_Retour_Log_Equipement));
	Message_Retour.ID_Reseau = Info_Demarrage.ID_Reseau;
	memcpy (Message_Retour.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
	strcpy (Message_Retour.Info, "");

	if ((fd=fopen(Equipement->Fichier_Log,"r+")) == NULL){
		strcat (Message_Retour.Info, "Impossible d'ouvrir le fichier log de l'equipement\n");
		Communication_Envoie_Donnee (RETOUR_LOG_EQUIPEMENT, (gpointer *) & Message_Retour, sizeof (Message_Retour));
		return;
	}

	fseek(fd,0,SEEK_END);

	Taille_Fichier = ftell(fd);

	if (Taille_Fichier<=(TAILLE_INFO_LOG_EQUIPEMENT-1)){
		fseek(fd,0,SEEK_SET);
		A_Lire = Taille_Fichier;
	}
	else {
		fseek(fd,Taille_Fichier-TAILLE_INFO_LOG_EQUIPEMENT+1,SEEK_SET);
		A_Lire = (TAILLE_INFO_LOG_EQUIPEMENT-1);
	}
	Taille_Envoie = 0;
	while (fgets((char *)line,A_Lire,fd) != NULL){  
		Taille_Envoie = Taille_Envoie + strlen((char *)line);
		if (Taille_Envoie>=TAILLE_INFO_LOG_EQUIPEMENT){
			printf("Oops : Le fichier est plus long que prévu\n");
			break;
		}
		else
			strcat (Message_Retour.Info, (char *)line);
	}
	fclose(fd);
	Communication_Envoie_Donnee (RETOUR_LOG_EQUIPEMENT, (gpointer *) & Message_Retour, sizeof (Message_Retour));
#endif
}
