/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifndef         __RESEAU
#define         __RESEAU

#include <sys/types.h>
#include "Socket.h"

#ifndef         __WINDOWS_ENABLE   
    #include <sys/socket.h>
    #include <netdb.h>
	#include <sys/ioctl.h>
	#include <sys/socket.h>
	#include <net/if.h>
	#include <netinet/if_ether.h>
	#include <netinet/in.h>
	#include <arpa/inet.h>
	#ifdef  __LINUX_ENABLE
		#include <linux/sockios.h>
		#include <linux/if_packet.h>
	#endif
	#include  <netdb.h>
#else  

#endif  

#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <glib.h>
#include "Socket.h"


#define TRAME_IP	0x0800
#define IP_ADDR_LEN	4
#define IP_VERSION4	0x4
#define MAC_ADDR_LEN 6

#define TRAME_ARP	0x0806

#define UDP		0x11

#define TCP 	0x06

#define ICMP	0x01
#define DESTINATION_UNREACHABLE 3
#define PORT_UNREACHABLE 3
#define ECHO_PING_REPLY 0
#define TIMESTAMP_REPLY 14
#define ICMP_CODE_0 0

#define NETBIOS		0x89
#define REGISTRATION_GROUP 1
#define REGISTRATION_UNIQUE 2
#define NBNS		0x89
#define BROWSE		0x8a

#define MASTER_ANNONCE	0x0f
#define HOST_ANNONCE	0x01
#define PORT_FTP 21
#define PORT_HTTP 80
#define PORT_IMAP 143
#define PORT_SSH 22
#define PORT_SMTP 25
#define PORT_TELNET 23
#define PORT_NETBIOS 139
#define PORT_SIP 5060
#define PORT_POP3 110
#define PORT_VNC0 5900
#define PORT_VNC1 5901
#define PORT_RTSP 554
#define PORT_IPP 631
#define PORT_VNC_HTTP 5800


#ifdef         __WINDOWS_ENABLE
#define ETH_ALEN	6
#endif


#define  DONNEE_PRET 1
#define  ATTENDRE    2
#define  ERREUR_SOCK 3	

unsigned char Mon_Adresse_MAC[MAC_ADDR_LEN + 1];
unsigned char Mon_Adresse_Ip[IP_ADDR_LEN + 1];

struct struct_Cle_Privee *Log_Send;
struct struct_Cle_Privee *Log_Recv;

struct struct_trame {
	unsigned char Dest_MAC[6];
	unsigned char Source_MAC[6];
	unsigned short Proto;
	unsigned char Datagramme[10000];
	int       Taille_Trame;
};

void      Get_My_MAC (void);
void      Get_My_Ip (void);
unsigned short ckecksum (char *donnee, int longueur, int valeur);

gboolean  attendre_Sock (int sock);
gint      create_tcp_server (int port, int Nb_Max_Client);
#endif
