/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifndef         __NOTIFICATION_EQUIPEMENT
#define         __NOTIFICATION_EQUIPEMENT

#include <glib.h>
#include <time.h>
#include "Reseau.h"
#include "Liste_Equipement.h"
#include "Debug.h"
#include "Scan_Arp.h"
#include "Semaphore.h"
#include "Initialisation_Com.h"
#include "Commun.h"
#include "Thread.h"
#include "Mem.h"
#include "Ping.h"

#define TEMP_NOTIFICATION_EQUIPEMENT_CRITIQUE 20


struct Struct_Liste_Notification_Equipement {
	struct Struct_Liste_Equipement *Equipement;
};

GList    *GList_Notification_Equipement; 


void      Thread_Notification_Equipement (void);
void      Ajout_Notification_Equipement (gpointer * Donnee);
void      Enlever_Notification_Equipement (gpointer * Donnee);
void      Affiche_Debug_Liste_Notification_Equipement ();
gint      Recherche_Index_Notification_Equipement_Non_Securiser (struct Struct_Liste_Equipement *Equipement);
void      Ajout_Notification_Equipement_Glist (struct Struct_Liste_Equipement *Equipement);
void      Enlever_Notification_Equipement_Glist (struct Struct_Liste_Equipement *Equipement);
void      Initialisation_Notification_Equipement (void);
void      Thread_Rafraichir_Tout_Equipement (void);

#define PROTECT_GLIST_NOTIFICATION_EQUIPEMENT()	G_STMT_START{ PROTECT_CODE(Sem_GList_Notification_Equipement); }G_STMT_END	
#define DEPROTECT_GLIST_NOTIFICATION_EQUIPEMENT()	G_STMT_START{ DEPROTECT_CODE(Sem_GList_Notification_Equipement); }G_STMT_END	

#endif
