/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifndef         __NOTIFICATION_PORT
#define         __NOTIFICATION_PORT

#include <glib.h>
#include <time.h>
#include "Reseau.h"
#include "Liste_Equipement.h"
#include "Semaphore.h"

#define TEMP_NOTIFICATION_PORT_CRITIQUE 20

struct Struct_Liste_Notification_Port {
	struct Struct_Liste_Equipement *Equipement;
	struct Struct_Port *Port;
	gint      Num_Port;
};

GList    *GList_Notification_Port;


void      Ajout_Notification_Port (gpointer * Donnee);
void      Enlever_Notification_Port (gpointer * Donnee);
void      Affiche_Debug_Liste_Notification_port (void);
gint      Recherche_Index_Notification_Port_Non_Securiser (struct Struct_Liste_Equipement *Equipement, gint Num_Port);
void      Enlever_Notification_Port_Glist (struct Struct_Liste_Equipement *Equipement, gint Num_Port);
void      Ajout_Notification_Port_Glist (struct Struct_Liste_Equipement *Equipement, gint Num_Port);
void      Initialisation_Notification_Port (void);

#define PROTECT_GLIST_NOTIFICATION_PORT()	G_STMT_START{ PROTECT_CODE(Sem_GList_Notification_Port); }G_STMT_END	
#define DEPROTECT_GLIST_NOTIFICATION_PORT()	G_STMT_START{ DEPROTECT_CODE(Sem_GList_Notification_Port); }G_STMT_END	
#endif
