/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifndef         __PORT_TCP
#define         __PORT_TCP

#include <glib.h>
#include <time.h>
#include "Reseau.h"
#include "Liste_Equipement.h"

#define NB_TENTATIVE_MAX_SCAN_PORT_TCP 6

enum enum_Notification_Port {
	NOTIFICATION_STANDARD = 0,
	NOTIFICATION_PORT_SERVEUR,
	NOTIFICATION_PORT_CRITIQUE
};

enum enum_Etat_Port {
	FIREWALLED = 0,	
	OUVERT,
	FERMER,
	UNKOWN 
};

struct Struct_Port {
	gint      Num_Port;
	gboolean  Notification;
	gint      Compteur_Notification;
	gint      Niveau_Notification;
	gint      Etat_Port;
	gint	  Ancien_Etat_Port; 
	unsigned char Flags;
	time_t64  Derniere_Modification_Etat_Port;
	gboolean  Alerte_Port_Active;

	unsigned short Port_Scan[NB_TENTATIVE_MAX_SCAN_PORT_TCP];
	unsigned int MonNumSeq_Scan[NB_TENTATIVE_MAX_SCAN_PORT_TCP];
};

struct struct_Liste_Port {
	gint      Num_Port;
	gboolean  Serveur;
};

GList    *GList_Port; 

gboolean Cherche_Si_Port_Ouvert (struct Struct_Liste_Equipement * Equipement, gint Num_Port);
void Cherche_Un_Port_Avec_Etat (struct Struct_Liste_Equipement * Equip, gint Etat, gint *resultat);
struct Struct_Port *Recupere_Pointeur_Port_Glist (struct Struct_Liste_Equipement *Equipement, gint Num_Port);
void Copie_Ancien_Etat_Liste_Port_TCP_Equipement (struct Struct_Liste_Equipement *Equip);
void Compare_Ancien_Etat_Liste_Port_Tcp_Equipement (struct Struct_Liste_Equipement *Equip);
void Initialisation_Liste_Port_TCP_Equipement (struct Struct_Liste_Equipement *Equip);
gboolean Test_Retour_Port_Equipement (struct Struct_Liste_Equipement *Equip);
void Creer_Liste_Port_Equipement (struct Struct_Liste_Equipement *Equipement);
void Ajout_Un_Port (gpointer * Donnee);
void Initialisation_Liste_port (void);
void Set_Etat_Port(struct Struct_Port *Port_Equipement,gint Etat);
gint Get_Etat_Port(struct Struct_Port *Port_Equipement);
gint Get_Num_Port(struct Struct_Port *Port_Equipement);


#define PROTECT_GLIST_PORT()	G_STMT_START{ PROTECT_CODE(Sem_GList_Port); }G_STMT_END	
#define DEPROTECT_GLIST_PORT()	G_STMT_START{ DEPROTECT_CODE(Sem_GList_Port); }G_STMT_END	

#define PROTECT_STRUCT_PORT_EQUIPEMENT()	G_STMT_START{ PROTECT_CODE(Sem_Struct_Port_Equipement); }G_STMT_END	
#define DEPROTECT_STRUCT_PORT_EQUIPEMENT()	G_STMT_START{ DEPROTECT_CODE(Sem_Struct_Port_Equipement); }G_STMT_END	
#endif
