/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifdef __LOG_ENABLE
#include <errno.h>
#include <stdlib.h>
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#ifndef         __WINDOWS_ENABLE
#include <dirent.h>  
#endif
#endif
#include "Quit.h"
#include "Info.h"
#include "Debug.h"
#include "Thread_Detect.h"
#include "Thread.h"
#include "Declaration_Constante.h"
#include "Initialisation_Com.h"
#include "Liste_Equipement.h"
#include "Notification_Equipement.h"
#include "Notification_Port.h"
#include "Scan_Signature.h"
#include "Communication.h"
#include "Scan_Port_TCP.h"
#include "Snmp.h"
#include "Liste_Sous_Reseau.h"
#include "Notification_Equipement.h"
#include "Scan_Equipement.h"
#include "Thread_Ip_Dynamic.h"
#include "Snmp.h"
#include "Semaphore.h"
#include "Mem.h"
#ifdef         __WINDOWS_ENABLE  
#include "Win32.h"  
#endif  

extern struct Struct_Categorie Liste_Categorie[];

struct Struct_Niveau_Arret Liste_Niveau_Arret[] = {
	{A_START, 								"----  Start  ----"},
	{A_STOP_DEBUG_THREAD, 		"----  Debug Thread  ----"},
	{A_STOP_BACKTRACE, 				"----  BatckTrace  ----"},
	{A_STOP_DEBUG_MEM, 			"----  Debug Memory  ----"},
	{A_STOP_CLOSE_SOCKET,			"----  Close Socket  ----"},
	{A_STOP_IMMEDIAT, 				"----  Stop Immediat  ----"}
};


void Change_Niveau_Arret(int Niveau){
	if (Niveau == A_START){
		Niveau = A_START;
		return;
	}
	if (Niveau_Arret>Niveau)
			Arret_Immediat();
	Niveau_Arret = Niveau;
	printf("########### %s\n",Liste_Niveau_Arret[Niveau_Arret].Info);
}

void Arret_Immediat(){
	printf("Daemon : Arret_Immediat : FAILED\n");
	exit(-1);
}



void Exit(){
	Close_Communication_Interface();
#ifdef __LOG_ENABLE
	#ifdef         __DEBUG_MEM
	Log_Info_Allocation(FALSE);
	#endif
	Close_Log_Main();	
	Ckeck_Fermeture_Log(); 
#endif
	printf ("Stopping %s (http://autoscan-network.com)\n", VERSION_AGENT);
	exit(EXIT_SUCCESS);
}

#ifdef  __SIGNAL_ENABLE
void Transmet_Thread_Main( int signum, siginfo_t *info, void *secret){
	printf("######### Thread Main ##########\n");
	Arret_Demande(NULL);
}
#endif


void Arret_Demande (gpointer * Message)
{
#ifdef  __SIGNAL_ENABLE
	struct struct_Demande_Arret_Agent *Demande_Arret = (struct struct_Demande_Arret_Agent *)Message;
	struct struct_Cle_Privee *pCle = NULL;
	int timeout = 0;

	CHANGE_NIVEAU_ARRET(A_STOP_DEBUG_THREAD);
	signal (SIGSEGV, Arret_Immediat);
	if ((Demande_Arret != NULL) && (Demande_Arret->ID_Reseau!=Info_Demarrage.ID_Reseau))
		printf("Warning Id_Reseau : %d\n",Demande_Arret->ID_Reseau);

	if ((pCle = pthread_getspecific (Cle_privee_thread)) == NULL)
		pCle = Donnee_Cle_Main;
	if(!pthread_equal( pthread_self(), mainThreadId )){
		pthread_kill(mainThreadId,SIGUSR2); 
		printf("Pause ...(%s)\n", Liste_Categorie[pCle->Categorie].Info);
		sleep(1);
	
	
	
		printf("__1(%s)\n", Liste_Categorie[pCle->Categorie].Info);
		sleep(1);
		printf("__2(%s)\n", Liste_Categorie[pCle->Categorie].Info);
		sleep(1);
		printf("__3(%s)\n", "%s", Liste_Categorie[pCle->Categorie].Info);
		sleep(1);
		printf("On ne devrait jamais arriver ici\n");
		exit(-1);
	}

	printf("******** Stopping Thread *************\n");
	envoie_Signal_All_Thread(SIGUSR1);
	while ((Get_Nb_Thread()!=0) && (timeout != 4)){
		sleep(1);
		timeout++;
	}
	if (timeout == 4) {
		printf("************ Failed Timeout ***************\n");
		exit(-1);
	}
	else
		printf("***************************************\n");
#endif
	Exit();
}
