/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <errno.h>
#include "Scan_Port_TCP.h"
#include "Debug.h"
#include "Info.h"
#include "Initialisation_Com.h"
#include "Mem.h"
#include "Reseau.h"
#include "Thread_Rafraichir_Info_Equipement.h"
#ifdef         __WINDOWS_ENABLE  
#include "Win32.h"  
#endif  

char      Syn[]     = { 0x45, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x02, 0x1F, 0xFE, 0x00, 0x00, 0x00, 0x00 };
char      Syn_mss[] = { 0x45, 0x00, 0x00, 0x2C, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x02, 0x1F, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x02, 0x04, 0x05, 0xb4};

extern void ckecksum_r (struct Struct_Liste_Equipement *Equip,unsigned char *donnee, int longueur, int valeur);

#ifndef  __PCAP_ENABLE
void Envoie_Trame_Scan_Port (struct Struct_Liste_Equipement *Equip, gint Num_Port, gint Socket, struct sockaddr *sock,struct Struct_Port *Port_Equipement,gboolean mss, gint Tentative)
#else
void Envoie_Trame_Scan_Port (struct Struct_Liste_Equipement *Equip, gint Num_Port, pcap_t * captureHandle,struct Struct_Port *Port_Equipement,gboolean mss, gint Tentative)
#endif
{
	struct struct_trame PacketScan;
	gint size_trame = 0;
	unsigned short Id_Ip = 0,Port = 0;
	unsigned int MonNumSeq = 0;
	
	ERROR_if (Equip == NULL);
#ifndef  __PCAP_ENABLE
	ERROR_if (sock == NULL);
#else
	ERROR_if (captureHandle == NULL);
#endif
	bzero (&PacketScan, sizeof (struct struct_trame));
	usleep (SURCHARGE_EQUIPEMENT/10);	
	Id_Ip = (unsigned short) rand_r(&graine_rand_r);
	MonNumSeq = (int)  rand_r(&graine_rand_r);
	Port = ((unsigned short)  rand_r(&graine_rand_r));
	Port = (Port & 0x0FFF) + 0xF000;
	MonNumSeq = htonl (MonNumSeq);

	if (Port_Equipement!=NULL){
		PROTECT_STRUCT_PORT_EQUIPEMENT();  
	
	
		Port_Equipement->Port_Scan[Tentative] =  Port; 
		Port_Equipement->MonNumSeq_Scan[Tentative] = MonNumSeq;
		DEPROTECT_STRUCT_PORT_EQUIPEMENT();
	}
	memcpy (&PacketScan.Dest_MAC, &Equip->Adresse_MAC, ETH_ALEN);
	memcpy (&PacketScan.Source_MAC, Mon_Adresse_MAC, ETH_ALEN);
	PacketScan.Proto = htons (TRAME_IP);
	if (!mss)
		memcpy (PacketScan.Datagramme, Syn, 40);
	else
		memcpy (PacketScan.Datagramme, Syn_mss, 44);
	PacketScan.Datagramme[4] = (Id_Ip >> 8) & 0xFF;
	PacketScan.Datagramme[5] = Id_Ip & 0xFF;
	memcpy (&PacketScan.Datagramme[12], &Mon_Adresse_Ip, IP_ADDR_LEN);
	memcpy (&PacketScan.Datagramme[16], &Equip->Adresse_Ip, IP_ADDR_LEN);
	ckecksum_r(Equip,&PacketScan.Datagramme[0], 20, 0);
	Equip->CheckSum_Calc = htons (Equip->CheckSum_Calc);
	memcpy (&PacketScan.Datagramme[10], &Equip->CheckSum_Calc, 2);
	PacketScan.Datagramme[20] = (Port >> 8) & 0xFF;
	PacketScan.Datagramme[21] = Port & 0xFF;
	PacketScan.Datagramme[22] = (Num_Port >> 8) & 0xFF;
	PacketScan.Datagramme[23] = Num_Port & 0xFF;
	memcpy (&PacketScan.Datagramme[24], &MonNumSeq, 4);
	if (!mss)
		ckecksum_r(Equip,&PacketScan.Datagramme[12], 24, 26);
	else
		ckecksum_r(Equip,&PacketScan.Datagramme[12], 32, 30);
	Equip->CheckSum_Calc = htons (Equip->CheckSum_Calc);
	memcpy (&PacketScan.Datagramme[36], &Equip->CheckSum_Calc, 2);
	if (!mss)
		size_trame = 54;
	else
		size_trame = 58;
#ifndef  __PCAP_ENABLE
	_SENDTO(Socket, &PacketScan, size_trame, 0, sock, sizeof (struct sockaddr));
#else
	SENDTO_PCAP(captureHandle,(u_char *) &PacketScan, size_trame);
 #endif
}	


void Traitement_Port_TCP (struct Struct_Liste_Equipement *Equipement, gint Num_Port,gint Num_Port_D, gint Nouvelle_Etat,unsigned int Ip_MonNum,unsigned char Flags)
{
	struct Struct_Port *Port_Equipement = NULL;
	struct struct_Retour_Rachaichir_Liste_Ports Message;
	gboolean Send_message = FALSE;
	gint      Nb_Objet_Liste = 0, i = 0, Tentative = 0;
#ifdef __LOG_ENABLE
	gchar *cEtat = NULL, *Texte = NULL;
#endif
	
	ERROR_if (Equipement == NULL);
	i = 0;
	PROTECT_GLIST_PORT();
	PROTECT_STRUCT_PORT_EQUIPEMENT();
	Nb_Objet_Liste = g_list_length (Equipement->GList_Port);
	while (i < Nb_Objet_Liste) {
		Port_Equipement = g_list_nth_data (Equipement->GList_Port, i);
		if (Port_Equipement->Num_Port == Num_Port) {
		
			if (Sem_Get_Boolean(&Equipement->Scan_Port_En_Cours)) { 
			
				Tentative = 0;
				while ((Tentative<NB_TENTATIVE_MAX_SCAN_PORT_TCP) && (Num_Port_D != Port_Equipement->Port_Scan[Tentative]) 		
						&& (htonl(Ip_MonNum) != htonl(Port_Equipement->MonNumSeq_Scan[Tentative])+1)){
					Tentative++;
				}	
				
				if ((Num_Port_D == Port_Equipement->Port_Scan[Tentative]) 		
						&& (htonl(Ip_MonNum) == htonl(Port_Equipement->MonNumSeq_Scan[Tentative])+1)){
				
#ifdef __LOG_ENABLE
					switch (Nouvelle_Etat){
							case OUVERT :
									cEtat = "OUVERT";
									break;
							case FERMER :
									cEtat = "FERMER";
									break;
							default :
									cEtat = "UNKOWN";
					}
					if (((Nouvelle_Etat == OUVERT) && (Port_Equipement->Etat_Port !=OUVERT)) 
						|| ((Nouvelle_Etat == FERMER) &&   (Port_Equipement->Etat_Port == OUVERT)))				
						STRDUP_PRINTF(Texte,"[LOG] [%s](%s:%d): CHANGEMENT Etat du port %d = [%s]   Ack_number[0x%08X]  Flags[0x%02X] Tentative [%d] MonNumSeq[0x%08X]\n",__FILE__, __PRETTY_FUNCTION__, __LINE__,Num_Port,cEtat,htonl(Ip_MonNum),Flags,Tentative,Port_Equipement->MonNumSeq_Scan[Tentative]);
					else
						STRDUP_PRINTF(Texte,"[LOG] [%s](%s:%d): --- Etat du port %d = [%s]   Ack_number[0x%08X]  Flags[0x%02X] Tentative [%d] MonNumSeq[0x%08X]\n",__FILE__, __PRETTY_FUNCTION__, __LINE__,Num_Port,cEtat,htonl(Ip_MonNum),Flags,Tentative,Port_Equipement->MonNumSeq_Scan[Tentative]);
				
					if (!Equipement->Scan_Port_En_Cours_Refresh)
						Log_Equipement(Equipement,Texte);
					MYFREE(Texte);
#endif
					Port_Equipement->Etat_Port = Nouvelle_Etat;
					Port_Equipement->Flags = Flags;
				}
			}
		
			if ((!Sem_Get_Boolean(&Equipement->Scan_Port_En_Cours)) && (Nouvelle_Etat == OUVERT)) {
				Port_Equipement->Etat_Port = Nouvelle_Etat;
				Port_Equipement->Compteur_Notification = 0;
				if (Port_Equipement->Alerte_Port_Active) {
					bzero (&Message, sizeof (struct struct_Retour_Rachaichir_Liste_Ports));
					Message.ID_Reseau = Info_Demarrage.ID_Reseau;
					memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
					Message.Num_Port = Num_Port;
					Message.Etat_Port = TRUE;
					time ((time_t *)&Port_Equipement->Derniere_Modification_Etat_Port);
					Message.Derniere_Modification_Etat_Port = Port_Equipement->Derniere_Modification_Etat_Port;
					Send_message = TRUE;
					Port_Equipement->Alerte_Port_Active = FALSE;
				}
			}
			DEPROTECT_STRUCT_PORT_EQUIPEMENT();
			DEPROTECT_GLIST_PORT();
			if (Send_message) 
					Communication_Envoie_Donnee (RETOUR_RAFRAICHIR_LISTE_PORTS, (gpointer *) & Message, sizeof (Message));
			return;
		}
		i++;
	}
	DEPROTECT_STRUCT_PORT_EQUIPEMENT();
	DEPROTECT_GLIST_PORT();
}

void Scanne_Local_Equipement (struct Struct_Liste_Equipement *Equipement)
{
	struct Struct_Port *Port_Equipement = NULL;
	gint Nb_Objet = 0, i = 0, Socket = 0;
	
	ERROR_if (Equipement == NULL);
	Initialisation_Liste_Port_TCP_Equipement (Equipement);
	Nb_Objet = g_list_length (Equipement->GList_Port);
	for (i = 0; i < Nb_Objet; i++) {
		Port_Equipement = g_list_nth_data (Equipement->GList_Port, i);
#ifndef         __WINDOWS_ENABLE
		if ((Socket = Connection_Equipement ((unsigned char *)"127.0.0.1", Port_Equipement->Num_Port, 1, TRUE,0)) != SOCK_ERROR) {
#else
		if ((Socket = Connection_Equipement ((unsigned char *)"127.0.0.1", Port_Equipement->Num_Port, 1, FALSE, 0)) != SOCK_ERROR) {
#endif
			Port_Equipement->Etat_Port = OUVERT;
			CLOSE_SOCKET(Socket);
		}
		else
			Port_Equipement->Etat_Port = FERMER;
	}
}

gboolean Scanne_Toutes_Les_Ports_TCP (struct Struct_Liste_Equipement *Equipement,gboolean mss,gboolean Refresh_Port_Ouvert){
	struct Struct_Port *Port_Equipement = NULL;
	gint pas_reponse = 0, Tentative = 0, Nb_Objet = 0, i= 0;
#ifdef  __PCAP_ENABLE
	pcap_t    * captureHandle;
	char errbuf[PCAP_ERRBUF_SIZE];
#endif

	ERROR_if (Equipement == NULL);
	if (memcmp (Equipement->ID_Equipement, Mon_Adresse_MAC, MAC_ADDR_LEN) == 0) {
		Scanne_Local_Equipement (Equipement);
		return FALSE;
	}

	Initialisation_Liste_Port_TCP_Equipement (Equipement);	
#ifndef  __PCAP_ENABLE
	int       Socket;
	struct sockaddr sock;
	OPEN_SOCKET(Socket,sock,Info_Demarrage,AF_INET,SOCK_PACKET,htons (ETH_P_ALL));
#else
	OPEN_SOCKET_PCAP(captureHandle,Info_Demarrage,errbuf) ;
#endif
	Tentative = 0;	
	do {
		DEBUG_INFO("Tentative %d",Tentative);
		Nb_Objet = g_list_length (Equipement->GList_Port);
		for (i = 0; i < Nb_Objet; i++) {
			Port_Equipement = g_list_nth_data (Equipement->GList_Port, i);
			if (Get_Etat_Port(Port_Equipement) == FIREWALLED)
#ifndef  __PCAP_ENABLE
				Envoie_Trame_Scan_Port (Equipement, Port_Equipement->Num_Port, Socket, &sock,Port_Equipement,mss,Tentative);
#else
				Envoie_Trame_Scan_Port (Equipement, Port_Equipement->Num_Port, captureHandle,Port_Equipement,mss,Tentative);
#endif
		}		
		
		if (Refresh_Port_Ouvert){
			Retour_Info_Scan(20 + (Tentative * 8),"TCP/IP",Equipement);
			ETAPE_SUIVANTE_INFO_EQUIPEMENT(Equipement);
		}
		else
			Retour_Info_Scan(2 + (Tentative * 4) ,"TCP/IP",Equipement);
		switch (Tentative) {
		    case 0:
			    sleep (1);
			    break;
		    case 1:
			    sleep (1);
			    break;
		    case 2:
			    sleep (2);
			    break;
		    case 3:
			    sleep (3);
			    break;
		    case 4:
			    sleep (4);
			    break;
		    case 5:
			    DEBUG_INFO("Attend reponse");
			    sleep (4);
			    break;
		}
		Tentative++;
	}
	while (!(Test_Retour_Port_Equipement (Equipement)) && (Tentative != NB_TENTATIVE_MAX_SCAN_PORT_TCP));

	pas_reponse = 0;
	PROTECT_GLIST_PORT();
	PROTECT_STRUCT_PORT_EQUIPEMENT();
	Nb_Objet = g_list_length (Equipement->GList_Port);
	for (i = 0; i < Nb_Objet; i++){
			Port_Equipement = g_list_nth_data (Equipement->GList_Port, i);
			if (Port_Equipement->Etat_Port == FIREWALLED)
				pas_reponse++;
	}
	DEPROTECT_STRUCT_PORT_EQUIPEMENT();	
	DEPROTECT_GLIST_PORT();
	DEBUG_INFO("Scanne port fini  total[%d]  nb port firewalled[%d]",Nb_Objet,pas_reponse);
#ifndef  __PCAP_ENABLE
	CLOSE_SOCKET(Socket);
#else
	CLOSE_SOCKET_PCAP(captureHandle);
#endif
	return (Nb_Objet == pas_reponse);
}
