/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifndef         __SIGNATURE
#define         __SIGNATURE

#include <glib.h>
#include "Reseau.h"
#include "Liste_Equipement.h"
#include "Socket.h"
#include "Reseau.h"

#ifdef	__WINDOWS_ENABLE
#include <remote-ext.h>
#endif

enum enum_trame {
	TRAME_SYN_NORMAL_OUVERT = 0,
	TRAME_SYN_NULL_OUVERT,
	TRAME_SYN_ECN_OUVERT,
	TRAME_SYN_FIN_URG_PSH_OUVERT,
	TRAME_ACK_OUVERT,
	TRAME_FIN_OUVERT,
	TRAME_SYN_NORMAL_FERMER,
	TRAME_SYN_NULL_FERMER,
	TRAME_SYN_ECN_FERMER,
	TRAME_SYN_FIN_URG_PSH_FERMER,
	TRAME_ACK_FERMER,
	TRAME_FIN_FERMER,
	TRAME_PING_31,
	TRAME_ICMP_TIMESTAMP,
	TRAME_UDP_30,
	NB_TYPE_TRAME
};

struct Struct_Liste_Type_Trame {
	gint      Id_Trame;
	gchar   *Info;
};

gboolean  Traitement_ScanOS_ICMP (struct Struct_Liste_Equipement *Equipement, struct struct_trame *Packet, unsigned char Taille_Trame, unsigned short Taille_Ip, unsigned char Type_ICMP, unsigned char Code_ICMP);
gboolean  Traitement_ScanOS_TCP (struct Struct_Liste_Equipement *Equipement, struct struct_trame *Packet, unsigned char Taille_Trame, unsigned short Taille_Ip, gint Port_Source, gint Port_Destination);
void      Envoie_Trames_Scanne_Os (struct Struct_Liste_Equipement *Equipement, gint Port_Ouvert, gint Port_Fermer);

#ifndef		__PCAP_ENABLE
void      Envoyer_Donnee_TCP_Detect_Passerelle_Routeur (struct Struct_Liste_Equipement *Equipement, gint Socket, struct sockaddr *sock);
#else
void      Envoyer_Donnee_TCP_Detect_Passerelle_Routeur (struct Struct_Liste_Equipement *Equipement, pcap_t * captureHandle);
#endif

#define PROTECT_LISTE_SCAN_OS()	G_STMT_START{ PROTECT_CODE(Sem_Liste_Scan_OS); }G_STMT_END
#define DEPROTECT_LISTE_SCAN_OS()	G_STMT_START{ DEPROTECT_CODE(Sem_Liste_Scan_OS); }G_STMT_END

#endif
