/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifndef         __SEMAPHORE
#define         __SEMAPHORE

#include <sys/types.h>
#include "Declaration_Constante.h"
#include "Win32.h"

#ifdef         __SEMAPHORE_ENABLE
	#include 	"/usr/include/semaphore.h"
#endif

#ifdef __MUTEX_ENABLE
	typedef struct {
	    pthread_mutex_t mutex;
	    pthread_cond_t cond;
	    int value;
	} sem_t;
#endif

#ifndef         __WINDOWS_ENABLE
sem_t     Semaphore_Nouveau_Equipement;
sem_t     Sem_GList_Liste_Thread_Scan;
sem_t     Semaphore_Info;
sem_t     Semaphore_Control_Usage_Socket;
sem_t     Semaphore_Debug;
sem_t     Semaphore_Snmp;
sem_t     Semaphore_Communication;
sem_t     Semaphore_DNS;
sem_t     Semaphore_Mem;
sem_t     Semaphore_WakeUp;
sem_t     Semaphore_Ping_Equipement;
sem_t     Semaphore_Etat_Thread;
sem_t     Semaphore_Fonction_Externe;
sem_t     Semaphore_BackTrace;
sem_t 	   Semaphore_Niveau_Arret;
sem_t     Semaphore_Log_File;
sem_t     Semaphore_Boolean;
sem_t     Semaphore_Int;
sem_t     Semaphore_Pointer;
sem_t     Semaphore_Scan_Arp_Sous_Reseau;
sem_t     Sem_GList_Equipement;
sem_t     Sem_GList_Notification_Equipement;
sem_t     Sem_GList_Notification_Port;
sem_t     Sem_GList_Scan_Arp_Detect_Nouveau_Equipement;
sem_t     Sem_GList_Liste_Thread;
sem_t     Sem_GList_Port;
sem_t     Sem_GList_Liste_Sous_Reseau;
sem_t     Sem_Liste_Etat_Udp;
sem_t     Sem_Liste_Scan_OS;
sem_t     Sem_Struct_Port_Equipement;

void      Attendre_Semaphore (sem_t * sem);
void      Liberation_Semaphore (sem_t * sem);
void      Initialisation_Semaphore_Gestion_Thread (void);
void      Initialisation_Semaphore (void);
int       Valeur_Semaphore (sem_t * sem);
#else
#include <windows.h>

HANDLE    Semaphore_Nouveau_Equipement;
HANDLE    Sem_GList_Liste_Thread_Scan;
HANDLE    Semaphore_Compteur;
int       Compteur_Nouveau_Equipement;
int       Compteur_Thread_Scan;
HANDLE    Semaphore_Info;
HANDLE    Sem_GList_Equipement;
HANDLE    Semaphore_Control_Usage_Socket;
HANDLE    Semaphore_Debug;
HANDLE    Sem_GList_Notification_Equipement;
HANDLE    Sem_GList_Notification_Port;
HANDLE    Semaphore_Snmp;
HANDLE    Semaphore_Communication;
HANDLE    Semaphore_DNS;
HANDLE    Semaphore_WakeUp;
HANDLE    Semaphore_Mem;
HANDLE    Semaphore_Ping_Equipement;
HANDLE    Semaphore_Etat_Thread;
HANDLE    Sem_GList_Liste_Thread;
HANDLE    Semaphore_Scan_Arp_Sous_Reseau;
HANDLE    Semaphore_Fonction_Externe;
HANDLE    Semaphore_BackTrace;
HANDLE    Semaphore_Log_File;
HANDLE    Sem_GList_Scan_Arp_Detect_Nouveau_Equipement;
HANDLE    Semaphore_Boolean;
HANDLE    Semaphore_Int;
HANDLE    Semaphore_Pointer;
HANDLE   Sem_GList_Port;
HANDLE   Semaphore_Niveau_Arret;
HANDLE     Sem_Liste_Etat_Udp;
HANDLE     Sem_Liste_Scan_OS;
HANDLE     Sem_Struct_Port_Equipement;
HANDLE     Sem_GList_Liste_Sous_Reseau;

void      Attendre_Semaphore (HANDLE sem);
void      Liberation_Semaphore (HANDLE sem);
void      Initialisation_Semaphore_Gestion_Thread (void);
void      Initialisation_Semaphore (void);
int       Valeur_Semaphore (HANDLE * sem);
#endif



#ifndef         __WINDOWS_ENABLE
#define PROTECT_CODE(sem)	G_STMT_START{ Attendre_Semaphore (&sem); }G_STMT_END
#else
#define PROTECT_CODE(sem)	G_STMT_START{ Attendre_Semaphore (sem); }G_STMT_END
#endif


#ifndef         __WINDOWS_ENABLE
#define DEPROTECT_CODE(sem)	G_STMT_START{ Liberation_Semaphore (&sem); }G_STMT_END
#else
#define DEPROTECT_CODE(sem)	G_STMT_START{ Liberation_Semaphore (sem); }G_STMT_END
#endif


gboolean Sem_Get_Boolean(gboolean *valeur);
void Sem_Set_Boolean(gboolean *variable,gboolean valeur);
void Sem_Incr_Int(int *variable);
void Sem_Decr_Int(int *variable);
void Sem_Set_Int(int *variable,int valeur);
int Sem_Get_Int(int *valeur);
void Sem_Set_uInt(unsigned int *variable,unsigned int valeur);
unsigned int Sem_Get_uInt(unsigned int *valeur);
void Sem_Set_ushort(unsigned short *variable,unsigned short valeur);
unsigned short Sem_Get_ushort(unsigned short *valeur);
void Sem_Set_Pointer(gpointer *variable,gpointer valeur);
gpointer * Sem_Get_Pointer(gpointer *valeur);
#endif
