/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifndef         __THREAD
#define         __THREAD

#include <glib.h>
#include <pthread.h>
#include <sys/types.h>
#include <unistd.h>
#include <limits.h>
#include <signal.h>
#include "config.h"
#ifndef         __WINDOWS_ENABLE
#include <sys/resource.h>
#endif
#include "Semaphore.h"

GList    *GList_Liste_Thread;
gint      Id_Thread,Nb_Thread;	
pthread_t mainThreadId;
pthread_attr_t Thread_Attr;

struct Struct_Liste_Thread {
	gint      Id_Thread;
	pthread_t pThread;
};

void      Start_Thread (void *thread, gpointer * pointeur);
void      Stop_Thread (void *retval);
void Stack_Size_Thread();
gint Get_Nb_Thread();

#ifdef         __SIGNAL_ENABLE
void 	  Pause_Thread( int signum, siginfo_t *info, void *secret);
void      envoie_Signal_All_Thread (int signum);
#endif

#define PROTECT_GLIST_LISTE_THREAD()	G_STMT_START{ PROTECT_CODE(Sem_GList_Liste_Thread); }G_STMT_END
#define DEPROTECT_GLIST_LISTE_THREAD()	G_STMT_START{ DEPROTECT_CODE(Sem_GList_Liste_Thread); }G_STMT_END
#endif
