/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Thread_Notification_Equipement.h"
#include "Win32.h"

void Thread_Notification_Equipement (void)
{
	struct Struct_Liste_Equipement *Equipement = NULL;
	struct Struct_Liste_Notification_Equipement *Notification_Equipement = NULL;
	struct struct_Retour_Notification_Changement_Etat_Equipement Message;
	gint      Nb_Objet_Liste, i;

#ifdef __LOG_ENABLE
	Create_Log(CATEG_THREAD_NOTIF_EQU,NULL,NULL,TRUE);
#endif
	while (TRUE) {
		i = 0;
		PROTECT_GLIST_NOTIFICATION_EQUIPEMENT();
		Nb_Objet_Liste = g_list_length (GList_Notification_Equipement);
		DEPROTECT_GLIST_NOTIFICATION_EQUIPEMENT();
		while (i < Nb_Objet_Liste) {
			PROTECT_GLIST_NOTIFICATION_EQUIPEMENT();
			Nb_Objet_Liste = g_list_length (GList_Notification_Equipement);
			if (i < Nb_Objet_Liste) {
				Notification_Equipement = g_list_nth_data (GList_Notification_Equipement, i);
				Equipement = Notification_Equipement->Equipement;
				if ((!Sem_Get_Boolean(&Equipement->Rafraichissement_Etat_En_Cours)) && (Equipement->ID_Equipement[6] != 0)) {
				
					if (Sem_Get_Int(&Equipement->Compteur_Notification) == TEMP_NOTIFICATION_EQUIPEMENT_CRITIQUE) {
						Sem_Set_Int(&Equipement->Compteur_Notification,0);
						Sem_Set_Boolean(&Equipement->Equipement_Allumer, FALSE);
						if (!Equipement->Alerte_Equipement_Active) {
							bzero (&Message, sizeof (struct struct_Retour_Notification_Changement_Etat_Equipement));
							Message.ID_Reseau = Info_Demarrage.ID_Reseau;
							memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
							Communication_Envoie_Donnee (RETOUR_NOTIFICATION_CHANGEMENT_ETAT_EQUIPEMENT, (gpointer *) & Message, sizeof (Message));
						}
						Equipement->Alerte_Equipement_Active = TRUE;
					}
					else {
					
						if (Sem_Get_Int(&Equipement->Compteur_Notification) >= TEMP_NOTIFICATION_EQUIPEMENT_CRITIQUE / 2)
							Envoie_Arp_Equipement (Equipement, 4);
					
						Sem_Incr_Int(&Equipement->Compteur_Notification);
					}					
				}
			}
			DEPROTECT_GLIST_NOTIFICATION_EQUIPEMENT();
			i++;
		}
		sleep (1);
	}
}
