/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Thread_Notification_Port.h"
#include "Win32.h"

void Thread_Notification_Port (void)
{
	struct Struct_Port *Port = NULL;
	struct Struct_Liste_Equipement *Equipement = NULL;
	struct Struct_Liste_Notification_Port *Notification_Port = NULL;
	struct struct_Retour_Notification_Changement_Etat_Port Message;
	gint      Nb_Objet_Liste, i;
#ifdef  __PCAP_ENABLE
	pcap_t    * captureHandle;
	char errbuf[PCAP_ERRBUF_SIZE];
#endif

#ifdef __LOG_ENABLE
	Create_Log(CATEG_THREAD_NOTIF_PORT,NULL,NULL,TRUE);
#endif
#ifndef  __PCAP_ENABLE
	int       Socket;
	struct sockaddr sock;
	OPEN_SOCKET(Socket,sock,Info_Demarrage,AF_INET,SOCK_PACKET,htons (ETH_P_ALL));
#else
	OPEN_SOCKET_PCAP(captureHandle,Info_Demarrage,errbuf) ;
#endif
	while (TRUE) {
		i = 0;
		Nb_Objet_Liste = g_list_length (GList_Notification_Port);
		while (i < Nb_Objet_Liste) {
		
			PROTECT_GLIST_NOTIFICATION_PORT();
			Nb_Objet_Liste = g_list_length (GList_Notification_Port);
			if (i < Nb_Objet_Liste) {
				Notification_Port = g_list_nth_data (GList_Notification_Port, i);
				Equipement = Notification_Port->Equipement;
				Port = Notification_Port->Port;
				if ((!Sem_Get_Boolean(&Equipement->Scan_Port_En_Cours))&& (Equipement->ID_Equipement[6] != 0)) { 
					if (Port->Compteur_Notification < TEMP_NOTIFICATION_PORT_CRITIQUE) {
						if (Port->Compteur_Notification >= TEMP_NOTIFICATION_PORT_CRITIQUE / 2)
#ifndef __PCAP_ENABLE
							Envoie_Trame_Scan_Port (Equipement, Port->Num_Port, Socket, &sock,NULL,Equipement->mss,0);
#else
							Envoie_Trame_Scan_Port (Equipement, Port->Num_Port, captureHandle,NULL,Equipement->mss,0);
#endif
						Port->Compteur_Notification++;
					}
					if (Port->Compteur_Notification == TEMP_NOTIFICATION_PORT_CRITIQUE) {
						Port->Compteur_Notification = 0;
						Port->Etat_Port = FERMER;
						if (!Port->Alerte_Port_Active) {
							bzero (&Message, sizeof (struct struct_Retour_Notification_Changement_Etat_Port));
							Message.ID_Reseau = Info_Demarrage.ID_Reseau;
							memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
							Message.Num_Port = Port->Num_Port;
							Communication_Envoie_Donnee (RETOUR_NOTIFICATION_CHANGEMENT_ETAT_PORT, (gpointer *) & Message, sizeof (Message));
						}
						Port->Alerte_Port_Active = TRUE;
					}
				}
			}
			DEPROTECT_GLIST_NOTIFICATION_PORT();
			i++;
		}
		sleep (1);
	}
}
