/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <errno.h>
#include "Thread_Ping_All.h"
#include "Log.h"
#include "Socket.h"
#include "Semaphore.h"
#include "Debug.h"
#include "Win32.h"

char      Trame_Ping_All[] = { 0x45, 0x00, 0x00, 0x3B, 0x00, 0x01, 0x40, 0x00, 0x01,	0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x00, 0x00, 0x01, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x3e, 0x01, 0xF0, 0xDB, 0x44, 0x6A, 0x7C, 0x9F, 0x0C, 0x8D, 0x1F, 0x5d, 0xE3, 0x55, 0x4F, 0x59, 0xA4, 0x15, 0xC3, 0xEF, 0xC7, 0xB1, 0xFF, 0x1c, 0x63, 0x28, 0x88, 0x73, 0x90, 0xD3, 0xBB };

void Thread_Ping_All (void)
{
	unsigned short Icmp_Id = 0, Icmp_Seq = 0;
	struct struct_trame PacketOs;
	unsigned short CheckSum_Calc = 0;
#ifdef  __PCAP_ENABLE
	pcap_t    * captureHandle;
	char errbuf[PCAP_ERRBUF_SIZE];
#endif

#ifdef __LOG_ENABLE
	Create_Log(CATEG_PING_DETECT,NULL,NULL,TRUE);
#endif
#ifndef  __PCAP_ENABLE	
	struct sockaddr sock;
	int       Socket;
	OPEN_SOCKET(Socket,sock,Info_Demarrage,AF_INET,SOCK_PACKET,htons (ETH_P_ALL));
#else
	OPEN_SOCKET_PCAP(captureHandle,Info_Demarrage,errbuf) ;
#endif
	bzero (&PacketOs, sizeof (struct struct_trame));
	Icmp_Id = (unsigned short) rand_r(&graine_rand_r);
	Icmp_Seq = 1;
	PacketOs.Dest_MAC[0] = 0x01;
	PacketOs.Dest_MAC[1] = 0x00;
	PacketOs.Dest_MAC[2] = 0x5E;
	PacketOs.Dest_MAC[3] = 0x00;
	PacketOs.Dest_MAC[4] = 0x00;
	PacketOs.Dest_MAC[5] = 0x01;
	memcpy (&PacketOs.Source_MAC, Mon_Adresse_MAC, ETH_ALEN);
	PacketOs.Proto = htons (TRAME_IP);
	memcpy (&PacketOs.Datagramme, Trame_Ping_All, 59);
	memcpy (&PacketOs.Datagramme[12], &Mon_Adresse_Ip, IP_ADDR_LEN);
	CheckSum_Calc = htons (ckecksum ((char *)&PacketOs.Datagramme[0], 20, 0));
	memcpy (&PacketOs.Datagramme[10], &CheckSum_Calc, 2);
	PacketOs.Datagramme[24] = (Icmp_Id >> 8) & 0xFF;
	PacketOs.Datagramme[25] = Icmp_Id & 0xFF;
	PacketOs.Datagramme[26] = (Icmp_Seq >> 8) & 0xFF;
	PacketOs.Datagramme[27] = Icmp_Seq & 0xFF;
	CheckSum_Calc = ckecksum ((char *)&PacketOs.Datagramme[20], 39, 0);
	CheckSum_Calc = htons (CheckSum_Calc);
	memcpy (&PacketOs.Datagramme[22], &CheckSum_Calc, 2);
#ifndef   __PCAP_ENABLE
	SENDTO(Socket, &PacketOs, 73, 0, &sock, sizeof (struct sockaddr));
	CLOSE_SOCKET(Socket);
#else
	SENDTO_PCAP(captureHandle,(u_char *) &PacketOs, 73);
	CLOSE_SOCKET_PCAP(captureHandle);
 #endif
	Stop_Thread (NULL);
}
