/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Thread_Rafraichir_Info_Equipement.h"
#include "Win32.h"

void Thread_Rafraichir_Info_Equipement (struct Struct_Liste_Equipement *Equipement)
{ 
	struct struct_Retour_Agent_Fin_Raffraichir_Tout_Port Message;
	char HostName_Copie[16 + 1];
	
	ERROR_if (Equipement == NULL);
#ifdef __LOG_ENABLE		
	Create_Log(CATEG_REFRESH_TOUT_EQU,NULL,NULL,TRUE);
#endif
	ETAPE_SUIVANTE_INFO_EQUIPEMENT(Equipement);

	Retour_Info_Scan(0,"Ping",Equipement);

	if (!Check_Etat_Arp_Ping_Equipement(Equipement,TRUE)){
		Retour_Info_Scan(99,"__ DOWN __",Equipement);
		sleep(3);
		Retour_Info_Scan(100,"",Equipement);
		Stop_Thread (NULL);
	}	
	ETAPE_SUIVANTE_INFO_EQUIPEMENT(Equipement);

	Retour_Info_Scan(20,"TCP/IP",Equipement);
	Copie_Ancien_Etat_Liste_Port_TCP_Equipement(Equipement);
	Sem_Set_Boolean(&Equipement->Scan_Port_En_Cours,TRUE);
	Sem_Set_Boolean(&Equipement->Scan_Port_En_Cours_Refresh,TRUE);
	Scanne_Toutes_Les_Ports_TCP(Equipement,Equipement->mss,TRUE);
	Sem_Set_Boolean(&Equipement->Scan_Port_En_Cours_Refresh,FALSE);
	Sem_Set_Boolean(&Equipement->Scan_Port_En_Cours,FALSE);
	Compare_Ancien_Etat_Liste_Port_Tcp_Equipement(Equipement);
	ETAPE_SUIVANTE_INFO_EQUIPEMENT(Equipement);

	bzero (&Message, sizeof (struct struct_Retour_Agent_Fin_Raffraichir_Tout_Port));
	Message.ID_Reseau = Info_Demarrage.ID_Reseau;
	memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
	Communication_Envoie_Donnee (RETOUR_AGENT_FIN_RAFFRAICHIR_TOUT_PORT, (gpointer *) & Message, sizeof (Message));
	ETAPE_SUIVANTE_INFO_EQUIPEMENT(Equipement);

	if (Cherche_Si_Port_Ouvert (Equipement, PORT_NETBIOS)) {
		Retour_Info_Scan(45,"Netbios",Equipement);
		strcpy ((char *)HostName_Copie,(char *)Equipement->Smb.HostName);
		Demande_NetBios (Equipement, 1);
		if (strcmp((char *) Equipement->Smb.HostName,HostName_Copie)!=0)
			Change_HostName_Netbios(Equipement,Equipement->Smb.HostName);
	}	
#ifdef        __SNMP_ENABLE  
		ETAPE_SUIVANTE_INFO_EQUIPEMENT(Equipement);
#endif	
#ifdef        __SNMP_ENABLE
	ETAPE_SUIVANTE_INFO_EQUIPEMENT(Equipement);
	Retour_Info_Scan(60,"Snmp",Equipement);
	check_liste_smnp_all(Equipement,TRUE);
#endif	
	Retour_Info_Scan(100,"",Equipement);
	PROTECT_CODE (Semaphore_Pointer);
	if (Equipement_En_Cours_Raffraichi_Info==Equipement)
		Equipement_En_Cours_Raffraichi_Info =  NULL;
	DEPROTECT_CODE (Semaphore_Pointer);
	Stop_Thread (NULL);
}

void Rafraichir_Info_Equipement (gpointer * Donnee)
{
	struct struct_Demande_Agent_Raffraichir_Tout_Equipement *Message = (struct struct_Demande_Agent_Raffraichir_Tout_Equipement *) Donnee;
	struct Struct_Liste_Equipement *Equipement = NULL;
	gint      ID_Equipement = 0;

	ERROR_if (Donnee == NULL);
	if (Message->ID_Reseau == -1){
		Sem_Set_Pointer((gpointer *) &Equipement_En_Cours_Raffraichi_Info, NULL);
		return;
	}
	Recherche_Index_Equipement (Message->ID_Equipement, TRUE, &ID_Equipement);
	if (ID_Equipement == EQUIPEMENT_UNKNOWN) {
		DEBUG_WARNING("Refresh state (Equipment unknown)");
		return;	
	}
	if (ID_Equipement == EQUIPEMENT_NO_IP) {
		DEBUG_WARNING("Refresh state (no IP)");
		return;	
	}
	Retour_Pointeur_Equipement (&Equipement,ID_Equipement);
	ERROR_if (Equipement == NULL);
	Sem_Set_Pointer((gpointer *) &Equipement_En_Cours_Raffraichi_Info, Equipement);
	Start_Thread (&Thread_Rafraichir_Info_Equipement, (gpointer *) Equipement); 
}


gboolean Rafraichir_Info_Equipement_Actuel(struct Struct_Liste_Equipement *Equipement){
	if (((struct Struct_Liste_Equipement *)Sem_Get_Pointer((gpointer *) &Equipement_En_Cours_Raffraichi_Info)) != Equipement){
			Sem_Set_Boolean(&Equipement->Scan_Port_En_Cours_Refresh,FALSE);	
			Sem_Set_Boolean(&Equipement->Scan_Port_En_Cours,FALSE);
			Retour_Info_Scan(99,"__ Stop __",Equipement);
			sleep(2);
			Retour_Info_Scan(101,"",Equipement); 
			return FALSE;
	}
	return TRUE;
}
