/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Thread_Rafraichir_Tout_Equipement.h"
#include "Win32.h"


void Thread_Rafraichir_Tout_Equipement (void)
{
	struct Struct_Liste_Equipement *Equipement = NULL;
	struct struct_Retour_Rachaichir_Etat_Equipement Message;
	struct	struct_Retour_Debut_Rafraichir_Tout_Equipement MessageDebut;
	struct struct_Retour_Fin_Rafraichir_Tout_Equipement MessageFin;
	gboolean  Sauve_Etat;
	gint      i,Timeout,tempPause;

	Rafraichir_Tout_Equipement_En_Cours = FALSE;
#ifdef __LOG_ENABLE
	Create_Log(CATEG_RAFFRAICHIR_EQU,NULL,NULL,TRUE);
#endif

	tempPause = 0;
	while ((tempPause<MAX_TEMP_RAFRAICHIR_TOUT_EQUIPEMENT) && (!Rafraichir_Tout_Equipement_En_Cours)){
		sleep (1);
		tempPause++;
	}
	DEBUG_INFO("Start");
	while (1) {
		i = 0;		
	
		bzero (&MessageDebut, sizeof (struct struct_Retour_Debut_Rafraichir_Tout_Equipement));
		MessageDebut.ID_Reseau = Info_Demarrage.ID_Reseau;
		Communication_Envoie_Donnee (RETOUR_DEBUT_RAFRAICHIR_TOUT_EQUIPEMENT, (gpointer *) & MessageDebut, sizeof (MessageDebut));
	
		Retour_Pointeur_Equipement (&Equipement,i);
		while (Equipement != NULL) {
			if ((!Equipement->Agent_AutoScan) && (!Sem_Get_Boolean(&Equipement->Notification_Equipement)) 
				&& (!Sem_Get_Boolean(&Equipement->Rafraichissement_Etat_En_Cours)) 
				&& ((Equipement->ID_Equipement[6] != 0))) {
				Sauve_Etat = Sem_Get_Boolean(&Equipement->Equipement_Allumer);
				Sem_Set_Int(&Equipement->Compteur_Notification,0);
				Sem_Set_Boolean(&Equipement->Equipement_Allumer, FALSE);
				Sem_Set_Boolean(&Equipement->Rafraichissement_Etat_En_Cours, TRUE);
			
				Timeout = 5;
				while ((Timeout!=0) && (!Sem_Get_Boolean(&Equipement->Equipement_Allumer))){
				
					Envoie_Arp_Equipement (Equipement, 4);
				
					Ping_equipement(Equipement);
					sleep (1);
					Timeout--;
				}
				Sem_Set_Boolean(&Equipement->Rafraichissement_Etat_En_Cours, FALSE);
				if (Sauve_Etat != Sem_Get_Boolean(&Equipement->Equipement_Allumer)) {
					bzero (&Message, sizeof (struct struct_Retour_Rachaichir_Etat_Equipement));
					Message.ID_Reseau = Info_Demarrage.ID_Reseau;
					memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
					Message.Equipement_Allumer = Equipement->Equipement_Allumer;
					Message.Derniere_Modification_Etat_Equipement = Equipement->Derniere_Modification_Etat_Equipement;
					Communication_Envoie_Donnee (RETOUR_RAFRAICHIR_ETAT_EQUIMEMENT, (gpointer *) & Message, sizeof (Message));
				}
			}
			i++;
			sleep (1);
			Retour_Pointeur_Equipement (&Equipement,i);
		}
	
		Scanne_Tous_Sous_Reseau();

	
		bzero (&MessageFin, sizeof (struct struct_Retour_Fin_Rafraichir_Tout_Equipement));
		MessageFin.ID_Reseau = Info_Demarrage.ID_Reseau;
		Communication_Envoie_Donnee (RETOUR_FIN_RAFRAICHIR_TOUT_EQUIPEMENT, (gpointer *) & MessageFin, sizeof (MessageFin));
	
		Rafraichir_Tout_Equipement_En_Cours = FALSE;
	
		tempPause = 0;
		while ((tempPause<MAX_TEMP_RAFRAICHIR_TOUT_EQUIPEMENT) && (!Rafraichir_Tout_Equipement_En_Cours)){
			sleep (1);
			tempPause++;
		}
	}
}


void Demande_Refresh_Tout_Equipement (gpointer * Donnee)
{
	struct struct_Demande_Rafraichir_Tout_Equipement *Message = (struct struct_Demande_Rafraichir_Tout_Equipement *) Donnee;
	
	ERROR_if (Donnee == NULL);
	Rafraichir_Tout_Equipement_En_Cours = TRUE;
}
