/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <errno.h>
#include "Thread_Scan_Arp_Detect_Nouveau_Equipement.h"
#include "Thread.h"
#include "Debug.h"
#include "Semaphore.h"
#include "Mem.h"
#include "Win32.h"


void Thread_Scan_Arp_Detect_Nouveau_Equipement (void)
{
	struct Struct_Liste_Equipement *Equipement = NULL;
	unsigned char *ID_Equipement = NULL;
	gint Nb_Tentative = 0,Etat_Equipement = 0,Nb_Objet_Liste = 0;
		
#ifdef __LOG_ENABLE		
	Create_Log(CATEG_ARP_DETECT_EQU,NULL,NULL,TRUE);
#endif
	Nb_Objet_Liste = 0;
	while (TRUE) {
	
		PROTECT_GLIST_SCAN_ARP_DETECT_NOUVEAU_EQUIPEMENT();
		if ((Nb_Objet_Liste=g_list_length (GList_Scan_Arp_Detect_Nouveau_Equipement))!=0){
			ID_Equipement = g_list_nth_data (GList_Scan_Arp_Detect_Nouveau_Equipement, 0);
			G_LIST_REMOVE(GList_Scan_Arp_Detect_Nouveau_Equipement,ID_Equipement);
			DEPROTECT_GLIST_SCAN_ARP_DETECT_NOUVEAU_EQUIPEMENT();
			DEBUG_INFO("(%d)New %02X:%02X:%02X:%02X:%02X:%02X",Nb_Objet_Liste,ID_Equipement[0], ID_Equipement[1], ID_Equipement[2], ID_Equipement[3], ID_Equipement[4], ID_Equipement[5]);
			Nb_Tentative = 0;
			while ((Nb_Tentative != 10) && ((Etat_Equipement = Recherche_Equipement(ID_Equipement,&Equipement)) == EQUIPEMENT_UNKNOWN)){
				Envoie_Arp (ID_Equipement + 6, 4, 1, TRUE);
				sleep(5);
				Nb_Tentative++;
			}
			if (Etat_Equipement != EQUIPEMENT_UNKNOWN)
				DEBUG_INFO("Ok Tentative(%d)",Nb_Tentative);
			else
				DEBUG_INFO("ERROR Tentative(%d)",Nb_Tentative);
			MYFREE(ID_Equipement);
		}
		else
			DEPROTECT_GLIST_SCAN_ARP_DETECT_NOUVEAU_EQUIPEMENT();
		if (Nb_Objet_Liste>1) 
			usleep(400000);
		else
			sleep(1);
	}
	Stop_Thread (NULL);
}
