/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <errno.h>
#include "Thread_Scanne_Plage.h"
#include "Win32.h"

void Thread_Scanner_Plage (struct Struct_Liste_Reseau *Reseau)
{
#ifdef __LOG_ENABLE
	Create_Log(CATEG_SCAN_PLAGE,NULL,g_strdup_printf("%d.%d.%d.%d",Reseau->Sous_Reseau[0],Reseau->Sous_Reseau[1],Reseau->Sous_Reseau[2],Reseau->Sous_Reseau[3]),TRUE);
#endif	
	Scanner_Plage(Reseau,FALSE);
	Stop_Thread (NULL);
}


void Scanner_Plage (struct Struct_Liste_Reseau *Reseau, gboolean Scan_unique)
{
	ERROR_if (Reseau == NULL);




	

	PROTECT_CODE(Semaphore_Scan_Arp_Sous_Reseau);
	if ((Reseau->Ma_Plage) && (!Reseau->Speed_Scan)){
		DEBUG_INFO("Scanne Speed plage : %d.%d.%d", Reseau->Sous_Reseau[0], Reseau->Sous_Reseau[1], Reseau->Sous_Reseau[2]);
		Envoie_Arp (Reseau->Sous_Reseau, 3, 255,FALSE);
		sleep(2);
		Envoie_Arp (Reseau->Sous_Reseau, 3, 255,FALSE);
		Reseau->Speed_Scan = TRUE;
	}
	else {
		DEBUG_INFO("Scanne plage : %d.%d.%d", Reseau->Sous_Reseau[0], Reseau->Sous_Reseau[1], Reseau->Sous_Reseau[2]);
		Envoie_Arp (Reseau->Sous_Reseau, 3, 255,TRUE);
	}
	DEPROTECT_CODE(Semaphore_Scan_Arp_Sous_Reseau);
	if (Scan_unique)
		return;
	PROTECT_GLIST_LISTE_SOUS_RESEAU();
	sleep(60*g_list_length (GList_Sous_Reseau));
	DEPROTECT_GLIST_LISTE_SOUS_RESEAU();
	PROTECT_CODE(Semaphore_Scan_Arp_Sous_Reseau);
	Envoie_Arp (Reseau->Sous_Reseau, 3, 255,TRUE);
	DEPROTECT_CODE(Semaphore_Scan_Arp_Sous_Reseau);
	Reseau->Deja_Scanner = TRUE;
}
