/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <errno.h>
#include "Thread_Wake-up.h"
#include "Thread.h"
#include "Debug.h"
#include "Semaphore.h"

void Envoie_WakeUp (struct Struct_Liste_Equipement *Equipement)
{ 
	char unsigned WakeUp_Trame[6 + 16*MAC_ADDR_LEN], *pTrame = NULL;
	struct sockaddr_in sock;
	int Socket = 0,i = 0,j = 0;

#ifdef __LOG_ENABLE		
	Create_Log(CATEG_THREAD_WAKEUP,NULL,NULL,TRUE);
#endif
	ERROR_if (Equipement == NULL);
	PROTECT_CODE(Semaphore_WakeUp);
	CREATE_SOCKET(Socket, Mon_Adresse_Ip, 9, sock,PF_INET,SOCK_DGRAM,0);
	BROADCAST_SOCKET(Socket);
	pTrame = WakeUp_Trame;
    for (i=0; i < 6; i++)
		*pTrame++ = 0xFF;
    for (i=0; i < 16; i++)
		for (j=0; j < MAC_ADDR_LEN; j++)
	   		*pTrame++ = Equipement->Adresse_MAC[j];
	SENDTO(Socket,WakeUp_Trame, sizeof (WakeUp_Trame), 0, &sock, sizeof(struct sockaddr_in));
	CLOSE_SOCKET(Socket); 
	DEPROTECT_CODE(Semaphore_WakeUp); 
	Stop_Thread (NULL);
}

void Demande_WakeUp (gpointer * Donnee)
{
	struct struct_Demande_WakeUp *Message = (struct struct_Demande_WakeUp *) Donnee;
	struct Struct_Liste_Equipement *Equipement = NULL;
	gint      ID_Equipement=0;

	ERROR_if (Donnee == NULL);
	Recherche_Index_Equipement (Message->ID_Equipement,FALSE, &ID_Equipement);
	Retour_Pointeur_Equipement (&Equipement,ID_Equipement);
	ERROR_if (Equipement == NULL);
	Start_Thread (&Envoie_WakeUp, (gpointer *) Equipement);
}
