/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <stdlib.h>
#include <glib.h>
#include "config.h"
#ifndef         __WINDOWS_ENABLE
#include <sys/wait.h>
#endif
#ifdef         __WINDOWS_ENABLE  
#include <windows.h>  
#include "Win32.h"  
#endif  
#include "Reseau.h"
#include "Declaration_Constante.h"
#include "BackTrace.h"
#include "Debug.h"
#include "Semaphore.h"
#include "Mem.h"
#include "Communication.h"
#include "Commun.h"
#include "Initialisation_Com.h"
#include "Gestion_Signal.h"
#include "Quit.h"
#include "Scan_Port_TCP.h"
#include "Scan_Signature.h"
#include "Sous_Reseau_Autorise.h"
#include "Liste_Sous_Reseau.h"
#include "Liste_Equipement.h"
#include "Notification_Equipement.h"
#include "Notification_Port.h"
#include "Thread_Detect.h"
#include "Thread.h"
#include "Intrus.h"
#include "Info.h"
#include "Snmp.h"
#include "Configuration.h"
#include "Gestion_Signal.h"
#ifndef         __WINDOWS_ENABLE
#include <dlfcn.h>
#endif
gboolean daemonize = FALSE,stop_daemon = FALSE;

void buffer_overflow ( )
{
        long int        i;
        char            str[29];

        for ( i = 0; i < 50; i++) {
                str [i] = '\0';
        }
        printf ( "####################  buffer_overflow\n");
}

static GOptionEntry entries[] =
{
#ifdef	__LINUX_ENABLE
   { "stop", 's', 0, G_OPTION_ARG_NONE, &stop_daemon, "stop service", NULL },
#endif
  { "daemonize", 'd', 0, G_OPTION_ARG_NONE, &daemonize, "daemonize", NULL },
  { "port", 'p', 0, G_OPTION_ARG_INT, &port_ecoute, "Specifies the port on which the server listens for connections (default 4555).", "N" },
  { NULL }
};



void Instance_Agent(void){
	Demarrage_Complet_Agent = FALSE;
	Show_Info_Log = 1;
	GList_Liste_Thread = NULL;
	Id_Thread = 0;
	Nb_Thread = 0;
	client_id = -1;
	pid_Instance = 0;
	Change_Niveau_Arret(A_START);
	mainThreadId = pthread_self ();
	graine_rand_r= 0xabcdef;
	
	Nb_Socket_Ouverte = 0;
	client_id = -1; 

#ifdef         __SIGNAL_ENABLE
	Initialisation_Signal_Erreur ();
#endif
	
	Initialisation_Semaphore ();
	Initialisation_Debug ();
	Initialisation_Info ();
	Read_Config();
#ifdef __LOG_ENABLE
	Initialisation_Repertoire_Log();
	Initialisation_Log();
#endif
#ifdef        __SNMP_ENABLE
	Initialisation_Snmp();
#endif
	Initialisation_Liste_port ();
	Initialisation_Liste_Sous_Reseau_Autorise ();
	Initialisation_Liste_Sous_Reseau ();
	Initialisation_Liste_Equipement ();
	Initialisation_Notification_Equipement ();
	Initialisation_Notification_Port ();
	Initialise_Alerte_intrusion();
	Communication_Initialisation ();
	Envoie_Version_Agent ();

	while (1) {
#ifndef         __WINDOWS_ENABLE
		pause ();
#else
		sleep(100);
#endif
	}
	exit(EXIT_SUCCESS);
}

/*#define assert(expr)                                                    \
  ((expr)                                                               \
   ? __ASSERT_VOID_CAST (0)                                             \
   : __assert_fail (__STRING(expr), __FILE__, __LINE__, __ASSERT_FUNCTION))*/


int main (int argc, char *argv[])
{
	GError *error = NULL;
  	GOptionContext *context = NULL;
	gchar *cPid = NULL;
	int pid = 0,status = 0,ID_Fichier_Pid = 0,taille = 0;

	port_ecoute = -1;  
#ifdef __BACKTRACE_ENABLE
	binary_name = g_strdup(argv[0]);
#endif
	printf("Starting %s (http://autoscan-network.com)\n", VERSION_AGENT);

	context = g_option_context_new ("");
  	g_option_context_add_main_entries (context, entries, NULL);
  	if (!g_option_context_parse (context, &argc, &argv, &error)) {
		g_print ("option parsing failed: %s\n", error->message);
      	exit (1);
    }


#ifndef         __WINDOWS_ENABLE
#endif


#ifdef         __LINUX_ENABLE
	gchar tPid[15];
	FILE *fd = NULL;
	gchar *ctemp = NULL;

	if (stop_daemon){
		if ((fd=fopen("/var/run/autoscan-network.pid","r+")) == NULL){
			printf("ERROR : Read /var/run/autoscan-network.pid\n");
			exit(-1);
		}
		fseek(fd,0,SEEK_SET);
		ctemp = fgets(tPid,sizeof(tPid),fd);
		pid = atoi (tPid);
		printf("Pid : %d\n",pid);
		Kill_Term(pid);
		exit(0);
	}
#endif

#ifndef         __WINDOWS_ENABLE
	if (daemonize){
	
		pid=fork();
		if(pid<0)  {
			printf("Fork : Error\n");
			exit(255);
		}
		if (pid)
			exit(EXIT_SUCCESS);
	
		ID_Fichier_Pid = open("/var/run/autoscan-network.pid", O_WRONLY | O_CREAT | O_TRUNC , 0644);
		cPid = g_strdup_printf("%d",getpid());
		taille = strlen(cPid);
		if (taille!=write(ID_Fichier_Pid,cPid,taille)){
			printf("ERROR : Create /var/run/autoscan-network.pid\n");
		}
		g_free(cPid);
		close(ID_Fichier_Pid);
	
		#ifdef         __SIGNAL_ENABLE
		Signal_Arret_Service();
		#endif
	
		while (1) {
	      switch ((pid_Instance=fork())) {
       		case -1:  
	         	printf("Fork : Error\n");
         		exit(EXIT_FAILURE);
       		case 0:  
	         	Instance_Agent();
         		exit(EXIT_FAILURE);
       		default:  
	         	wait(&status);
	   	 		if (WEXITSTATUS(status) == ARRET_GENERALE)
					exit(-1);					
				sleep(1);
      		}
      	
   		}
   		exit(EXIT_SUCCESS);
	}
	else
#endif
	    Instance_Agent();
	return 0;
}
