/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gtk/gtk.h>
#include "Debug.h"
#include "Configuration.h"
#include "Mem.h"

GdkPixbuf * Load_Pixbuf (gchar *filename){
	GdkPixbuf * Image = NULL;
	gchar *File = NULL;
	
	STRDUP_PRINTF(File,"%s/%s",Config_Path_Icon,filename);
	Image = gdk_pixbuf_new_from_file(File,NULL);	
	MYFREE(File);
	return Image;
}

GtkWidget* Load_Pixmap (gchar *filename){
	GtkWidget	*Image = NULL;
	gchar *File = NULL;
	
	STRDUP_PRINTF(File,"%s/%s",Config_Path_Icon,filename);
	Image = gtk_image_new_from_file(File);	
	MYFREE(File);
	return Image;
}


GdkPixbuf *Chargement_Image (char *Chemin_Icone, gfloat saturation)
{
	GdkPixbuf *icone = NULL;
	GError   *error = NULL;
	gchar *File = NULL;
	
	ERROR_if (Chemin_Icone == NULL);	
	STRDUP_PRINTF(File,"%s/%s",Config_Path_Icon,Chemin_Icone);
	icone = gdk_pixbuf_new_from_file (File, &error);
	MYFREE(File);
	if (error) {
		DEBUG_WARNING("Could not load icon [%s] %s", Chemin_Icone ,error->message);
		g_error_free (error);
		return NULL;
	}
	gdk_pixbuf_saturate_and_pixelate (icone, icone, saturation, FALSE);
	return icone;
}
