/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gtk/gtk.h>
#ifdef         __SCRIPT_ENABLE
#include <sys/msg.h>
#endif

#ifdef         __WINDOWS_ENABLE
#include <windows.h>
#include "Win32.h"
#endif


#include "Communication.h"
#include "Commun.h"
#include "Reseau.h"
#include "Debug.h"
#include "Initialisation_Com.h"
#include "Equipement.h"
#include "Equipement_Port.h"
#include "Script.h"
#include "Root_Interface.h"
#include "Snmp.h"
#include "Wizard_Interface_Add_Network.h"
#include "Demarrage_Interface.h"
#include "Animation.h"
#include "Declaration_Constante.h"
#include "Contribution.h"
#include "Maemo.h"
#include "Mem.h"
#include "Log.h"
#include "Objet_Liste.h"
#include "Configuration.h"
#include "Socket.h"

struct Struct_Modele_Communication Liste_Communication[] = {
	{AGENT_VERSION, &Reception_Version_Agent,"AGENT_VERSION",sizeof(struct struct_Agent_Version)},
	{AJOUT_PORT, NULL,"AJOUT_PORT",0},
	{AJOUT_SIGNATURE, NULL,"AJOUT_SIGNATURE",0},
	{RESTAURATION_MACHINE, NULL,"RESTAURATION_MACHINE",0},
	{AJOUT_RESEAU_PRIVEE, NULL,"AJOUT_RESEAU_PRIVEE",0},
	{DEMANDE_LISTE_INTERFACE, NULL,"DEMANDE_LISTE_INTERFACE",0},
	{NOUVELLE_INTERFACE, &Recuperation_Nouvelle_Interface,"NOUVELLE_INTERFACE",sizeof(struct struct_Nouvelle_Interface)},
	{FIN_LISTE_INTERFACE, &Recuperation_Liste_Interface_Fini,"FIN_LISTE_INTERFACE",sizeof(struct struct_Fin_Liste_Interface)},
	{DEMARRAGE_AGENT, NULL,"DEMARRAGE_AGENT",0},
	{DEMANDE_ARRET_AGENT, NULL,"DEMANDE_ARRET_AGENT",0},
	{RETOUR_MESSAGE, &Recuperation_Message_Agent,"RETOUR_MESSAGE",sizeof(struct struct_Retour_Message)},
	{RETOUR_ERREUR_CRITIQUE, &Recuperation_Retour_Critique_Agent,"RETOUR_ERREUR_CRITIQUE",sizeof(struct struct_Retour_Erreur_Critique)},
	{INFO_AGENT, &Retour_Info,"INFO_AGENT",sizeof(struct struct_Info_Agent)},
	{NOUVEAU_EQUIPEMENT, &Recuperation_Nouveau_Equipement,"NOUVEAU_EQUIPEMENT",sizeof(struct struct_Nouveau_Equipement)},
	{DEMANDE_NESSUS, NULL,"DEMANDE_NESSUS",0},
	{DEMARRAGE_NESSUS, NULL,"DEMARRAGE_NESSUS",sizeof(struct struct_Demarrage_Nessus)},
	{RETOUR_NESSUS_INFO, NULL,"RETOUR_NESSUS_INFO",sizeof(struct struct_Retour_Nessus_Info)},
	{RETOUR_NESSUS_DONNEE, NULL,"RETOUR_NESSUS_DONNEE",sizeof(struct struct_Retour_Nessus_Donnee)},
	{RETOUR_NESSUS_FIN, NULL,"RETOUR_NESSUS_FIN",sizeof(struct struct_Retour_Nessus_Fin)},
	{DEMANDE_RAFRAICHIR_ETAT_EQUIMEMENT, NULL,"DEMANDE_RAFRAICHIR_ETAT_EQUIMEMENT",0},
	{RETOUR_RAFRAICHIR_ETAT_EQUIMEMENT, &Retour_Modification_Etat_Equipement,"RETOUR_RAFRAICHIR_ETAT_EQUIMEMENT",sizeof(struct struct_Retour_Rachaichir_Etat_Equipement)},
	{DEMANDE_RAFRAICHIR_LISTE_PORTS, NULL,"DEMANDE_RAFRAICHIR_LISTE_PORTS",0},
	{RETOUR_RAFRAICHIR_LISTE_PORTS, &Retour_Modification_Etat_Port,"RETOUR_RAFRAICHIR_LISTE_PORTS",sizeof(struct struct_Retour_Rachaichir_Liste_Ports)},
	{DEMANDE_RAFRAICHIR_ENREGISTREMENT_SAMBA, NULL,"DEMANDE_RAFRAICHIR_ENREGISTREMENT_SAMBA",0},
	{RETOUR_RAFRAICHIR_ENREGISTREMENT_SAMBA, NULL,"RETOUR_RAFRAICHIR_ENREGISTREMENT_SAMBA",0},
	{DEMANDE_RAFRAICHIR_SIGNATURE, NULL,"DEMANDE_RAFRAICHIR_SIGNATURE",0},
	{RETOUR_RAFRAICHIR_SIGNATURE, NULL,"RETOUR_RAFRAICHIR_SIGNATURE",0},
	{DEMANDE_NOTIFICATION_WARNING_ETAT_EQUIPEMENT, NULL,"DEMANDE_NOTIFICATION_WARNING_ETAT_EQUIPEMENT",0},
	{DEMANDE_NOTIFICATION_WARNING_ETAT_PORT, NULL,"DEMANDE_NOTIFICATION_WARNING_ETAT_PORT",0},
	{DEMANDE_NOTIFICATION_CRITIQUE_ETAT_EQUIPEMENT, NULL,"DEMANDE_NOTIFICATION_CRITIQUE_ETAT_EQUIPEMENT",0},
	{DEMANDE_NOTIFICATION_CRITIQUE_ETAT_PORT, NULL,"DEMANDE_NOTIFICATION_CRITIQUE_ETAT_PORT",0},
	{RETOUR_NOTIFICATION_CHANGEMENT_ETAT_EQUIPEMENT, &Retour_Notification_Equipement,"RETOUR_NOTIFICATION_CHANGEMENT_ETAT_EQUIPEMENT",sizeof(struct struct_Retour_Notification_Changement_Etat_Equipement)},
	{RETOUR_NOTIFICATION_CHANGEMENT_ETAT_PORT, &Retour_Notification_Port,"RETOUR_NOTIFICATION_CHANGEMENT_ETAT_PORT",sizeof(struct struct_Retour_Notification_Changement_Etat_Port)},
	{ANNULATION_NOTIFICATION_ETAT_EQUIPEMENT, NULL,"ANNULATION_NOTIFICATION_ETAT_EQUIPEMENT",0},
	{ANNULATION_NOTIFICATION_ETAT_PORT, NULL,"ANNULATION_NOTIFICATION_ETAT_PORT",0},
	{ACTIVE_ALERTE_INTRUS, NULL,"ACTIVE_ALERTE_INTRUS",0},
	{DESACTIVE_ALERTE_INTRUS, NULL,"DESACTIVE_ALERTE_INTRUS",0},
	{ALERTE_INTRUS, &Retour_Alerte_Intrusion,"ALERTE_INTRUS",sizeof(struct struct_Alerte_Intrus)},
	{DEMANDE_MODIFIE_NIVEAU_DEBUG, NULL,"DEMANDE_MODIFIE_NIVEAU_DEBUG",0},
	{RETOUR_LISTE_SNMP, &Recuperation_Liste_Snmp,"RETOUR_LISTE_SNMP",sizeof(struct struct_Retour_Liste_SNMP)},
	{DEMANDE_LANCEMENT_SCRIPT, NULL,"DEMANDE_LANCEMENT_SCRIPT",0},
	{RETOUR_SCRIPT, &Retour_Script,"RETOUR_SCRIPT",sizeof(struct struct_Retour_Script)},
	{RETOUR_SCRIPT_TERMINER, &Retour_Script_Terminer,"RETOUR_SCRIPT_TERMINER",sizeof(struct struct_Retour_Script_Terminer)},
	{DEMANDE_RAFRAICHIR_EQUIPEMENT, NULL,"DEMANDE_RAFRAICHIR_EQUIPEMENT",0},
	{RETOUR_RAFRAICHIR_EQUIPEMENT, &Retour_Rafraichir_Equipement,"RETOUR_RAFRAICHIR_EQUIPEMENT",sizeof(struct struct_Retour_Rafraichir_Equipement)},
	{IP_RETROUVER, &Equipement_Ip_Retrouver,"IP_RETROUVER",sizeof(struct struct_Ip_Retrouver )},
	{IP_PERDU, &Equipement_Ip_Perdu,"IP_PERDU",sizeof(struct struct_Ip_Perdu)},
	{IP_MODIFIER, &Equipement_Ip_Modifier,"IP_MODIFIER",sizeof(struct struct_Ip_Modifier)},
	{DEMANDE_LISTE_SNMP, NULL,"DEMANDE_LISTE_SNMP",0},
	{DEL_GLIST_SNMP, &Retour_Efface_Liste_Snmp,"DEL_GLIST_SNMP",sizeof(struct struct_Del_Glist_SNMP)},
	{DEMANDE_LISTE_SNMP_ALL, NULL,"DEMANDE_LISTE_SNMP_ALL",0},
	{DEMANDE_WAKE_UP, NULL ,"DEMANDE_WAKE_UP",0},
	{DEMANDE_LOG_EQUIPEMENT, NULL ,"DEMANDE_LOG_EQUIPEMENT",0},
	{RETOUR_LOG_EQUIPEMENT, &Recuperation_Log_Equipement ,"RETOUR_LOG_EQUIPEMENT",sizeof(struct struct_Retour_Log_Equipement)},
	{RETOUR_RAFRAICHIR_NOM_UTILISATEUR, &Retour_Rafraichir_Nom_Utilisateur ,"RETOUR_RAFRAICHIR_NOM_UTILISATEUR",sizeof(struct struct_Retour_Rafraichir_Nom_Utilisateur)},
	{AFFICHE_NOUVEAU_EQUIPEMENT, &Affiche_Nouveau_Equipement ,"AFFICHE_NOUVEAU_EQUIPEMENT",sizeof(struct struct_Retour_Affiche_Nouveau_Equipement)},
	{DEMANDE_SNMP_SCALAIRE, NULL,"DEMANDE_SNMP_SCALAIRE",0},
	{RETOUR_SNMP_SCALAIRE, &Retour_Liste_Snmp_Scalaire,"DEMANDE_LISTE_SCALAIRE",sizeof(struct struct_Retour_SNMP_Scalaire)},
	{RETOUR_ETAT_SCAN, &Affiche_Etat_Scan ,"RETOUR_ETAT_SCAN",sizeof(struct struct_Retour_Etat_Scan)},
	{RETOUR_POST_NOUVEAU_EQUIPEMENT, &Post_Nouveau_Equipement,"RETOUR_POST_NOUVEAU_EQUIPEMENT",sizeof(struct struct_Post_Nouveau_Equipement)},
	{DEMANDE_AGENT_RAFFRAICHIR_TOUT_EQUIPEMENT, NULL,"DEMANDE_AGENT_RAFFRAICHIR_TOUT_EQUIPEMENT",0},
	{RETOUR_AGENT_AJOUT_NOUVEAU_PORT_OUVERT, &Raffraichissement_Liste_port_Port_Ouvert,"RETOUR_AGENT_AJOUT_NOUVEAU_PORT_OUVERT",sizeof(struct struct_Retour_Agent_Ajout_Nouveau_Port_Ouvert)},
	{RETOUR_AGENT_AJOUT_NOUVEAU_PORT_FERMER, &Raffraichissement_Liste_port_Port_Fermer,"RETOUR_AGENT_AJOUT_NOUVEAU_PORT_FERMER",sizeof(struct struct_Retour_Agent_Ajout_Nouveau_Port_Fermer)},
	{RETOUR_AGENT_FIN_RAFFRAICHIR_TOUT_PORT, &Fin_Raffraichissement_Liste_port,"RETOUR_AGENT_FIN_RAFFRAICHIR_TOUT_PORT",sizeof(struct struct_Retour_Agent_Fin_Raffraichir_Tout_Port)},
	{RETOUR_RAFRAICHIR_NOM_NETBIOS, &Retour_Rafraichir_Nom_Netbios,"RETOUR_RAFRAICHIR_NOM_NETBIOS",sizeof(struct struct_Retour_Rafraichir_Nom_Netbios)},
	{RETOUR_INFO_DEBUG, &Retour_Info_Debug,"RETOUR_INFO_DEBUG",sizeof(struct struct_Retour_Info_Debug)},
	{DEMANDE_RAFRAICHIR_TOUT_EQUIPEMENT, NULL,"DEMANDE_RAFRAICHIR_TOUT_EQUIPEMENT",0},
	{RETOUR_DEBUT_RAFRAICHIR_TOUT_EQUIPEMENT,&Retour_Debut_Rafraichir_Reseau,"RETOUR_DEBUT_RAFRAICHIR_TOUT_EQUIPEMENT",sizeof(struct struct_Retour_Debut_Rafraichir_Tout_Equipement)},
	{RETOUR_FIN_RAFRAICHIR_TOUT_EQUIPEMENT, &Retour_Fin_Rafraichir_Reseau,"RETOUR_FIN_RAFRAICHIR_TOUT_EQUIPEMENT",sizeof(struct struct_Retour_Fin_Rafraichir_Tout_Equipement)}
};


void Log_Reception_Transmission(struct Struct_Liste_Reseau *Reseau,gchar *Texte_Log){
	if (Reseau!=NULL)
		Log(Reseau->Log_Recv,Texte_Log);
	MYFREE(Texte_Log);
}


void Recuperation_Nb_Octet_Recu (gint Nb_Octet, struct Struct_Liste_Reseau *Reseau)
{
	if (Reseau != NULL)
		Reseau->Octet_Recu_Agent = Reseau->Octet_Recu_Agent + Nb_Octet;
}

gboolean Check_Etat_Connection (void)
{
	struct Struct_Liste_Reseau *Reseau = NULL;
	GtkTreeModel *model = NULL;
	gchar    *Text = NULL,*Text_recu = NULL,*Text_envoye = NULL;
	guint     Nb_Objet_Liste, i;

	Nb_Objet_Liste = g_list_length (GList_Liste_Reseau);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Reseau = g_list_nth_data (GList_Liste_Reseau, i);
		if (Reseau->Etat_Connection != ETAT_CONNECTED)
			continue;
		if (Reseau->Compteur_Activite_Agent > 1)
			DEBUG_WARNING("Pas Info Agent [%s] depuis %d secondes", Reseau->Nom_Reseau,Reseau->Compteur_Activite_Agent);
		if (Reseau->Compteur_Activite_Agent == 10)
			Change_Etat_Connection_Reseau(Reseau,ETAT_DISCONNECTED);
		Reseau->Compteur_Activite_Agent++;
	}
	return TRUE;
}


gboolean Communication_Reception_Donnee_Boucle (void)
{
#ifdef         __SCRIPT_ENABLE
	struct struct_Info Donnee;
#endif
	struct struct_Info_Entete Entete;
	struct Struct_Liste_Reseau *Reseau = NULL;
	guint     Nb_Objet_Liste, i, Tentative;
	gint      Taille_Donnee_Recue,Taille_Donnee_Recue_Part,Ckecksum;
	gchar     Donnee_Brut[TAILLE_MAX_DONNEE_BRUT],*pEntete = NULL;

	if (Nouvelle_Version_Telechargable){
	
	
		Nouvelle_Version_Telechargable = FALSE;
	}
	if (Connecter_Agent){
	
		Taille_Donnee_Recue = 0;
		pEntete = (gchar *)&Entete; 
		do {  
		
			Taille_Donnee_Recue = recvfrom (Socket_Agent_Init, &Entete, sizeof (struct struct_Info_Entete), 0, NULL, 0);
			if (Taille_Donnee_Recue > 0){
			
				Tentative = 0;
				while ((sizeof (struct struct_Info_Entete)!=Taille_Donnee_Recue)&&(Tentative!=10)){
					Tentative++;
					if (Waiting_Read_Socket(Socket_Agent_Init,TIMEOUT_SOCKET_AGENT) != SOCK_OK) 
						DEBUG_WARNING("No data : (Tentative : %d)", Tentative);
					Taille_Donnee_Recue_Part = recvfrom (Socket_Agent_Init, &pEntete[Taille_Donnee_Recue], sizeof (struct struct_Info_Entete)-Taille_Donnee_Recue, 0, NULL, 0);
					if (Taille_Donnee_Recue_Part == -1){
						DEBUG_WARNING("Taille_Donnee_Recue_Part == -1   %s  Socket (%d)", strerror (errno),Socket_Agent_Init);
						if (!(errno == EINTR || errno == EAGAIN))
							DEBUG_ERROR("%s Socket (%d)", strerror (errno),Socket_Agent_Init);
						usleep(400000);
					}
					else {
						if (Taille_Donnee_Recue_Part==0)
							DEBUG_WARNING("Taille_Donnee_Recue_Part == 0   %s  Socket (%d)", strerror (errno),Socket_Agent_Init);
						Taille_Donnee_Recue = Taille_Donnee_Recue + Taille_Donnee_Recue_Part;
					}
				}
			
				if (sizeof (struct struct_Info_Entete) != Taille_Donnee_Recue)
					DEBUG_ERROR("[%s]  [%d]!=[%d]", Liste_Communication[Entete.ID_Info].Debug,sizeof (struct struct_Info_Entete), Taille_Donnee_Recue);
			
				if (Entete.Taille_Donnee != Liste_Communication[Entete.ID_Info].Taille_Structure)
					DEBUG_ERROR("[%s]  [%d]!=[%d]", Liste_Communication[Entete.ID_Info].Debug,Liste_Communication[Entete.ID_Info].Taille_Structure, Entete.Taille_Donnee);
				if (Entete.Taille_Donnee > TAILLE_MAX_DONNEE_BRUT)
					DEBUG_ERROR("[%s]  Taille:[%d]", Liste_Communication[Entete.ID_Info].Debug, Entete.Taille_Donnee);
			
				Tentative = 0;
				Taille_Donnee_Recue = 0; 
				do{
					Tentative++;
					if (Waiting_Read_Socket(Socket_Agent_Init,TIMEOUT_SOCKET_AGENT) != SOCK_OK)
						DEBUG_WARNING("No data : (Tentative : %d)", Tentative);
					Taille_Donnee_Recue_Part = recvfrom (Socket_Agent_Init, &Donnee_Brut[Taille_Donnee_Recue], Entete.Taille_Donnee-Taille_Donnee_Recue, 0, NULL, 0);
					if (Taille_Donnee_Recue_Part == -1){
						DEBUG_WARNING("Taille_Donnee_Recue_Part == -1   %s  Socket (%d)", strerror (errno),Socket_Agent_Init);
						if (!(errno == EINTR || errno == EAGAIN))
							DEBUG_ERROR("%s  Socket (%d)", strerror (errno),Socket_Agent_Init);
						usleep(400000);
					}
					else {
						if (Taille_Donnee_Recue_Part==0)
							DEBUG_WARNING("Taille_Donnee_Recue_Part == 0   %s  Socket (%d)", strerror (errno),Socket_Agent_Init);
						Taille_Donnee_Recue = Taille_Donnee_Recue + Taille_Donnee_Recue_Part;
					}
				}while ((Entete.Taille_Donnee!=Taille_Donnee_Recue)&&(Tentative!=10));
			
				if ((Taille_Donnee_Recue == -1)||(Taille_Donnee_Recue == 0))
					DEBUG_ERROR("[%s]", strerror (errno));
				if (Entete.Taille_Donnee!=Taille_Donnee_Recue)
					DEBUG_ERROR("Entete.Taille_Donnee!=Taille_Donnee_Recue [%d!=%d] Tentative(%d)", Entete.Taille_Donnee,Taille_Donnee_Recue,Tentative);
			
				Ckecksum = Calculer_Ckecksum((gint *)Donnee_Brut,Taille_Donnee_Recue);
				if (Ckecksum!=Entete.Ckecksum)
					DEBUG_ERROR("Ckecksum!=Entete.Ckecksum [%08X!=%08X]    Nb Tentative : (%d)  Taille_Donnee(%d)  TailleRecu(%d)", Ckecksum, Entete.Ckecksum,Tentative,Entete.Taille_Donnee,Taille_Donnee_Recue);
			
				if (Liste_Communication[Entete.ID_Info].Gestion_Communication != NULL)
					(*Liste_Communication[Entete.ID_Info].Gestion_Communication) ((gpointer *) &Donnee_Brut);
				else
					debug_printf (D_INFO_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Reception Message sans action defini   [%s] Taille=[%d]", Liste_Communication[Entete.ID_Info].Debug,Taille_Donnee_Recue);
			}
		}
		while (Taille_Donnee_Recue>0);
	}


	Taille_Donnee_Recue = 0;
	Nb_Objet_Liste = g_list_length (GList_Liste_Reseau);
	pEntete = (gchar *)&Entete; 
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Reseau = g_list_nth_data (GList_Liste_Reseau, i);
		if  (Reseau->Etat_Connection == ETAT_CONNECTED){
			do {
			
				Taille_Donnee_Recue = recvfrom (Reseau->Socket_Agent, &Entete, sizeof (struct struct_Info_Entete), 0, NULL, 0);
				if (Taille_Donnee_Recue>0){
				
					Tentative = 0;
					while ((sizeof (struct struct_Info_Entete)!=Taille_Donnee_Recue)&&(Tentative!=10)){
						Tentative++;
						if (Waiting_Read_Socket(Reseau->Socket_Agent,TIMEOUT_SOCKET_AGENT) != SOCK_OK)  
							DEBUG_WARNING("No data : (Tentative : %d)", Tentative);
						Taille_Donnee_Recue_Part = recvfrom (Reseau->Socket_Agent, &pEntete[Taille_Donnee_Recue], sizeof (struct struct_Info_Entete)-Taille_Donnee_Recue, 0, NULL, 0);
						if (Taille_Donnee_Recue_Part == -1){
#ifdef __DEBUG_COM
							Log_Reception_Transmission(Reseau,g_strdup_printf("[%s] Tentative(%d) Taille_Donnee_Recue_Part == -1   %s  Socket (%d)\n",Liste_Communication[Entete.ID_Info].Debug, Tentative, strerror (errno),Reseau->Socket_Agent));
#endif
							DEBUG_WARNING("Taille_Donnee_Recue_Part == -1   %s  Socket (%d)", strerror (errno),Reseau->Socket_Agent);
							if (!(errno == EINTR || errno == EAGAIN))
								DEBUG_ERROR("%s Socket (%d)", strerror (errno),Reseau->Socket_Agent);
							usleep(400000);
						}
						else {
							if (Taille_Donnee_Recue_Part==0)
								DEBUG_WARNING("Taille_Donnee_Recue_Part == 0   %s  Socket (%d)", strerror (errno),Reseau->Socket_Agent);
							Taille_Donnee_Recue = Taille_Donnee_Recue + Taille_Donnee_Recue_Part;
						}
					}
					if (Liste_Communication[Entete.ID_Info].ID_Communication!=INFO_AGENT){
#ifdef __DEBUG_COM
						Log_Reception_Transmission(Reseau,g_strdup_printf("[%s] %d\n",Liste_Communication[Entete.ID_Info].Debug,Entete.Taille_Donnee));
#endif
					}
				
					if (sizeof (struct struct_Info_Entete) != Taille_Donnee_Recue)
						DEBUG_ERROR("[%s]  [%d]!=[%d]", Liste_Communication[Entete.ID_Info].Debug, sizeof (struct struct_Info_Entete), Taille_Donnee_Recue);
				
					if (Entete.Taille_Donnee != Liste_Communication[Entete.ID_Info].Taille_Structure)
						DEBUG_ERROR("[%s]  [%d]!=[%d]",  Liste_Communication[Entete.ID_Info].Debug,Liste_Communication[Entete.ID_Info].Taille_Structure, Entete.Taille_Donnee);
					if (Entete.Taille_Donnee > TAILLE_MAX_DONNEE_BRUT)
						DEBUG_ERROR("[%s]  Taille:[%d]", Liste_Communication[Entete.ID_Info].Debug, Entete.Taille_Donnee);
				
					Tentative = 0;
					Taille_Donnee_Recue = 0;
					do{
						Tentative++;
						if (Waiting_Read_Socket(Reseau->Socket_Agent,TIMEOUT_SOCKET_AGENT) != SOCK_OK)
							DEBUG_WARNING("No data : (Tentative : %d)", Tentative);
						Taille_Donnee_Recue_Part = recvfrom (Reseau->Socket_Agent, &Donnee_Brut[Taille_Donnee_Recue], Entete.Taille_Donnee-Taille_Donnee_Recue, 0, NULL, 0);
						if (Taille_Donnee_Recue_Part == -1){
#ifdef __DEBUG_COM
							Log_Reception_Transmission(Reseau,g_strdup_printf("[%s] Tentative(%d) Taille_Donnee_Recue_Part == -1   %s  Socket (%d)\n",Liste_Communication[Entete.ID_Info].Debug, Tentative, strerror (errno),Reseau->Socket_Agent));
#endif
							DEBUG_WARNING("Taille_Donnee_Recue_Part == -1   %s  Socket (%d)", strerror (errno),Reseau->Socket_Agent);
							if (!(errno == EINTR || errno == EAGAIN))
								DEBUG_ERROR("%s  Socket (%d)", strerror (errno),Reseau->Socket_Agent);
							usleep(400000);
						}
						else {
							if (Taille_Donnee_Recue_Part==0)
								DEBUG_WARNING("Taille_Donnee_Recue_Part == 0   %s  Socket (%d)", strerror (errno),Reseau->Socket_Agent);
							Taille_Donnee_Recue = Taille_Donnee_Recue + Taille_Donnee_Recue_Part;
						}
					}while ((Entete.Taille_Donnee!=Taille_Donnee_Recue)&&(Tentative!=10));
				
					if ((Taille_Donnee_Recue == -1)||(Taille_Donnee_Recue == 0))
						DEBUG_ERROR("[%s] Taille Recupere Entete : (%d)", strerror (errno),Taille_Donnee_Recue);
					if (Entete.Taille_Donnee!=Taille_Donnee_Recue)
							DEBUG_ERROR("Entete.Taille_Donnee!=Taille_Donnee_Recue [%d!=%d]   Réseau:[%s]  [%s] Tentative(%d)", Entete.Taille_Donnee,Taille_Donnee_Recue, Reseau->Nom_Reseau,Liste_Communication[Entete.ID_Info].Debug,Tentative);
				
					Ckecksum = Calculer_Ckecksum((gint *)Donnee_Brut,Taille_Donnee_Recue);
					if (Ckecksum!=Entete.Ckecksum)
						DEBUG_ERROR("[%s] Ckecksum!=Entete.Ckecksum [%08X!=%08X]    Nb Tentative : (%d)  Taille_Donnee(%d)  TailleRecu(%d)", Liste_Communication[Entete.ID_Info].Debug,Ckecksum, Entete.Ckecksum,Tentative,Entete.Taille_Donnee,Taille_Donnee_Recue);
					if (Liste_Communication[Entete.ID_Info].ID_Communication!=INFO_AGENT){
#ifdef __DEBUG_COM
						Log_Reception_Transmission(Reseau,g_strdup_printf("[%s] Ckecksum %08X\n",Liste_Communication[Entete.ID_Info].Debug,Ckecksum));
#endif
					}
				
					if (Liste_Communication[Entete.ID_Info].Gestion_Communication != NULL)
						(*Liste_Communication[Entete.ID_Info].Gestion_Communication) ((gpointer *) &Donnee_Brut);
					else
						DEBUG_WARNING("[%s] Pas action defini  Taille=[%d]",Liste_Communication[Entete.ID_Info].Debug,Taille_Donnee_Recue);
				}
			}
			while (Taille_Donnee_Recue>0);
		}
	}

#ifdef         __SCRIPT_ENABLE

	do {
		bzero (&Donnee, sizeof (struct struct_Info));
		if ((Taille_Donnee_Recue = msgrcv (File_Info, (void *) &Donnee, sizeof (struct struct_Info) - sizeof (long), Mon_Pid, IPC_NOWAIT)) > -1) {
			if (Liste_Communication[Donnee.ID_Info].Gestion_Communication != NULL)
				(*Liste_Communication[Donnee.ID_Info].Gestion_Communication) ((gpointer *) & Donnee.Donnee);
			else
				DEBUG_WARNING("[%s] Pas action defini",Liste_Communication[Entete.ID_Info].Debug);
		}
	}
	while (Taille_Donnee_Recue != -1);
#endif
	return TRUE;
}


void Communication_Initialisation (void)
{
#ifdef         __SCRIPT_ENABLE
	Mon_Pid = getpid ();
	DEBUG_INFO("AutoScan : pid(%d)", Mon_Pid);

	if (msgctl (msgget (KEY_FILE, 0), IPC_RMID, NULL) == -1)
		DEBUG_INFO("File KEY_FILE");

	if ((File_Info = msgget (KEY_FILE, IPC_CREAT | 0777)) == -1)
		debug_printf (D_INFO_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "msgget  : %s", strerror (errno));
#endif
#ifdef         __WINDOWS_ENABLE
	int ret;
	WSADATA wsaData;

	if ((ret = WSAStartup(MAKEWORD(1,1),&wsaData)) != 0)
		 DEBUG_ERROR("Init Network : Failed\n");
	DEBUG_WARNING("Init Network : OK\n");
#endif
}

int connection_Serveur (char *serveur, struct hostent *host, int port, int sock)
{
	struct sockaddr_in SocketAddr;
	memset (&SocketAddr, 0, sizeof (struct sockaddr_in));
	memcpy (&SocketAddr.sin_addr.s_addr, host->h_addr, host->h_length);
	SocketAddr.sin_family = AF_INET;
	SocketAddr.sin_port = htons (port);
	/*
	Plante sous 64 bits
	DEBUG_WARNING("[I] Connection au serveur [%s] en cours   (%s)\n", serveur,inet_ntoa (SocketAddr.sin_addr));*/
	if (connect (sock, (struct sockaddr *) &SocketAddr, sizeof (struct sockaddr)) < 0) {
		DEBUG_INFO("connect : [%s] socket (%d)", strerror (errno),sock);
#ifndef         __WINDOWS_ENABLE
		if (errno != EINPROGRESS) {
			DEBUG_WARNING("%s", strerror (errno));
			return FALSE;
		}
		return FALSE;
#else
		if (WSAGetLastError() != WSAEWOULDBLOCK) {
			DEBUG_WARNING("connect() failed with error %d   %d\n", WSAGetLastError(),SOCKET_ERROR);
			return FALSE;
		}
		DEBUG_INFO("Socket avec etat en progression : %d",WSAEWOULDBLOCK);
#endif
	
	}
	DEBUG_WARNING("Connection au serveur : %s:%i", serveur, port);
	return TRUE;
}


int Initialisation_TCP_Agent (gchar *Nom_Serveur_Agent,gint Num_Port)
{
	#define TIME_OUT_CONNECT 6
	#define TENTATIVE_CONNECT_AGENT 2
	struct hostent *host = NULL;
	int       NbOctet, TimeOut, Tentative_Connect_Agent;
	int       Socket_Agent;
	gboolean  Connection_Accepter;
	gchar     *Text = NULL;
	gchar	  Entete[TAILLE_MAX_VERSION_AGENT];
#ifndef         __WINDOWS_ENABLE
	fd_set fd_read,fd_write;
	socklen_t lon;
    struct timeval tv;
	int retval,valopt;
#else
 	fd_set ensemble;
    struct timeval tv;
	int retval;
#endif
	DEBUG_WARNING("[%s](%d)",Nom_Serveur_Agent,Num_Port);
	if ((Config_Path_Daemon != NULL) && (strcmp (Nom_Serveur_Agent, "127.0.0.1") == 0)) {
		Lance_Nouveau_Agent_Local ();
		sleep(2);
	}
	Socket_Agent_Init = -1;
	if ((host = gethostbyname (Nom_Serveur_Agent)) == NULL) {
		return -1;
	}
#ifndef         __WINDOWS_ENABLE
	Socket_Agent = socket (AF_INET, SOCK_STREAM, 0);
	ERROR_if (Socket_Agent == -1);
#else
	Socket_Agent = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
	ERROR_if (Socket_Agent == INVALID_SOCKET);
#endif

	Tentative_Connect_Agent = 0;
	Connection_Accepter = FALSE;

#ifndef         __WINDOWS_ENABLE
	NONBLOCK_SOCKET(Socket_Agent,SOCKET_NON_BLOQUANT);
	SIGNAL_SOCKET(Socket_Agent);
	KEEPALIVE_SOCKET(Socket_Agent);

		if (!connection_Serveur (Nom_Serveur_Agent, host, Num_Port, Socket_Agent)){
		
			TimeOut = 0;
			do {
				Text = g_strdup_printf ("Connecting (%s)(%d)   please wait (%d)", Nom_Serveur_Agent,Tentative_Connect_Agent,TIME_OUT_CONNECT-TimeOut);
				if (AutoRestore){
#ifndef         __MAEMO
					gtk_progress_bar_set_text (GTK_PROGRESS_BAR (progressbar_Demarrage), Text);
#else
					gtk_progress_bar_set_text_maemo(banner_maemo_Demarrage, Text);
#endif
				}
				else
					gtk_label_set_text((GtkLabel *)label_Localisation_Connecting, Text);
				MYFREE (Text);
			
				refresh();
			
			
			
				FD_ZERO(&fd_read);
				FD_SET(Socket_Agent, &fd_read);
				FD_ZERO(&fd_write);
				FD_SET(Socket_Agent, &fd_write);
			
   				tv.tv_sec = 1;
    			tv.tv_usec = 0;
 				retval = select(Socket_Agent + 1,&fd_read, &fd_write, NULL, &tv);
    			if (retval==2){
				
              		lon = sizeof(int);
              		if (getsockopt(Socket_Agent, SOL_SOCKET, SO_ERROR, (void*)(&valopt), &lon) < 0) {
						DEBUG_WARNING("Error in getsockopt() %d - %s\n", errno, strerror(errno));
              			return -1;
					}
					if (valopt) {
                 		DEBUG_WARNING( "Error in delayed connection() %d - %s", valopt, strerror(valopt));
	               		Text = g_strdup_printf ("[FAILED] Connecting (%s)  (%s)", Nom_Serveur_Agent, strerror(valopt));
						if (!AutoRestore)
							gtk_label_set_text((GtkLabel *)label_Localisation_Connecting, Text);
						refresh();
						MYFREE (Text);
						DEBUG_WARNING("Impossible de se connecter à l agent");
						return -1;
					}
	        		DEBUG_WARNING("Ecriture+Lecture maintenant  = %d",retval);
					Connection_Accepter = TRUE;
				}
    			else {
	        		DEBUG_WARNING("Pas de données depuis 1 secondes  retval=%d",retval);
					sleep(1);
				}
				TimeOut++;
			} while ((!Connection_Accepter) && (TimeOut <= TIME_OUT_CONNECT));
		}
		else
			Connection_Accepter = TRUE;
#else
	set_NonBlock(Socket_Agent,SOCKET_NON_BLOQUANT);
	do {
		if (!connection_Serveur (Nom_Serveur_Agent, host, Num_Port, Socket_Agent)){
		
			TimeOut = 0;
			do {
				Text = g_strdup_printf ("Connecting (%s)(%d)   please wait (%d)", Nom_Serveur_Agent,Tentative_Connect_Agent,TIME_OUT_CONNECT-TimeOut);
				if (AutoRestore){
					gtk_progress_bar_set_text (GTK_PROGRESS_BAR (progressbar_Demarrage), Text);
				}
				else
					gtk_label_set_text(label_Localisation_Connecting, Text);
				refresh();
				MYFREE (Text);
				FD_ZERO(&ensemble);
				FD_SET(Socket_Agent, &ensemble);
			
   				tv.tv_sec = 1;
    			tv.tv_usec = 0;
 				retval = select(Socket_Agent + 1, &ensemble, NULL, NULL, &tv);
    			if (retval){
	        		DEBUG_WARNING("Données disponibles maintenant\n");
					Connection_Accepter = TRUE;
				}
    			else
	        		DEBUG_WARNING("Pas de données depuis 1 secondes\n");
				DEBUG_INFO("Tentative Connection Agent : TimeOut n°[%d]", TimeOut);
				TimeOut++;
			} while ((!Connection_Accepter) && (TimeOut <= TIME_OUT_CONNECT));
		}
		Tentative_Connect_Agent++;
	} while ((!Connection_Accepter) && (Tentative_Connect_Agent <= TENTATIVE_CONNECT_AGENT));
#endif

	if (!Connection_Accepter) {
		Text = g_strdup_printf ("[FAILED] Connecting (%s)", Nom_Serveur_Agent);
		if (!AutoRestore)
			gtk_label_set_text((GtkLabel *)label_Localisation_Connecting, Text);
		refresh();
		MYFREE (Text);
		DEBUG_WARNING("Impossible de se connecter à l agent");
		close (Socket_Agent);
		return -1;
	}

	DEBUG_WARNING("Connecter a [%s] Socket :(%d)",Nom_Serveur_Agent,Socket_Agent);

	NbOctet = recvfrom (Socket_Agent, &Entete, sizeof (Entete), 0, NULL, 0);
	if (NbOctet==-1)
    	 DEBUG_ERROR("read  %s", strerror (errno));
	DEBUG_WARNING("Récuperation de l'entete de l'agent : [%s](%d)",Entete, NbOctet);

	if ((strcmp (Entete, VERSION_AGENT) != 0)){
		Text = g_strdup_printf ("[FAILED] Version check (%s)", Entete);
		if (!AutoRestore)
			gtk_label_set_text((GtkLabel *)label_Localisation_Connecting, Text);
		refresh();
		MYFREE (Text);
		DEBUG_WARNING("Agent incompatible");
		close (Socket_Agent);
		return -1;
	}
	NbOctet = send (Socket_Agent, VERSION_AUTOSCAN, sizeof (VERSION_AUTOSCAN), 0);
	if (NbOctet < 0)
		DEBUG_WARNING("send  : %s", strerror (errno));


	Socket_Agent_Init = Socket_Agent;
	Connecter_Agent = TRUE;
	DEBUG_WARNING("Connection opérationnel -- Connection Bloquante");
	Show_Info_Log = 0;
	return Socket_Agent;
}
