/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Fournisseur.h"
#include "Debug.h"
#include "Declaration_Constante.h"
#include "Mem.h"
#include "Configuration.h"
#include "Win32.h"

gchar    *Recherche_Fournisseur_Equipement (unsigned char *Mac_Adresse)
{
	gchar    *Fournisseur = NULL;

	Mac_Adresse[8] = 0;
	Fournisseur = g_hash_table_lookup(Hash_Fournisseur,Mac_Adresse);
	Mac_Adresse[8] = ':';
	if (Fournisseur)
		return Fournisseur;
	return FOURNISSEUR_INCONNU;
}


void Creer_Liste_Fournisseur (void)
{
	FILE     *Fichier_MacListe = NULL;
	unsigned char *MAC = NULL;
	gchar    *Constructeur = NULL;
	char      buf[512],*FileMac;

	STRDUP_PRINTF(FileMac,"%s/Mac",Config_Path_Config);
	if ((Fichier_MacListe = fopen (FileMac, "r")) == NULL)
		DEBUG_ERROR("%s : %s", FileMac,strerror (errno));
	MYFREE(FileMac);
	Hash_Fournisseur = g_hash_table_new((GHashFunc)g_str_hash,(GEqualFunc)g_str_equal);

	while (fgets (buf, sizeof (buf), Fichier_MacListe)) {
		MAC = NULL;
		MALLOC (MAC, sizeof (unsigned char) * (8+1));
		strncpy ((char *)MAC, buf, 8);
		MAC[8] = '\0';
		Constructeur = strdup (buf + 9);
		Constructeur[strlen (Constructeur) - 1] = 0;
		g_hash_table_insert(Hash_Fournisseur,MAC,Constructeur);
	}
	DEBUG_INFO("hash_table: Creation de la liste des Adresses MAC (%d adresses MAC trouvees)",g_hash_table_size(Hash_Fournisseur));
	fclose (Fichier_MacListe);
	return;
}
