/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifdef         __CONSOLE_ENABLE

#include <gtk/gtk.h>
#include <vte/vte.h>

#include "Root_Interface.h"
#include "Console.h"
#include "Modules.h"
#include "Debug.h"
#include "Objet.h"
#include "Mem.h"

void Degrise_Ligne_Console(struct Struct_Equipement *Equipement){
struct Struct_Modele_Objet *Objet = NULL;


	Objet = Equipement->Objet_Liste_Par_Type;
	Change_Couleur_Ligne_Liste (Equipement->Objet_Liste_Par_Ip, NULL, NULL, NULL,Recupere_Pointeur_Structure_Reseau(Objet->ID_Reseau));
	Change_Couleur_Ligne_Liste (Equipement->Objet_Liste_Par_Type, NULL, NULL, NULL,Recupere_Pointeur_Structure_Reseau(Objet->ID_Reseau));
}

void	on_Console_Fin(VteTerminal *vte,struct Struct_Equipement *Equipement) {

	if (Equipement_Selectionner != Equipement){
		if (Equipement->hbox_console_telnet !=NULL){
			gtk_widget_destroy (Equipement->hbox_console_telnet);
		
		}
		if (Equipement->hbox_console_ssh !=NULL){
			gtk_widget_destroy (Equipement->hbox_console_ssh);
		
		}
		Degrise_Ligne_Console(Equipement);
	}
	else {
	
		Equipement_Selectionner->combo_sauv = 0;
		gtk_combo_box_set_active (GTK_COMBO_BOX (combobox_liste_Modules), Equipement_Selectionner->combo_sauv);
	}
	Equipement->hbox_console_telnet	= NULL;
	Equipement->hbox_console_ssh = NULL;
}

GtkWidget *Creation_Console (gchar * Commande)
{
	GtkWidget *hbox = NULL;
	GtkWidget *term_widget = NULL;
	GtkWidget *scrolled_window_terminal = NULL;
	pid_t     Pid_Commande;
	char     *arguments[3];

	
	arguments[0] = Commande;
	if ((Equipement_Selectionner->User_SSH_Default) && (Reseau_Selectionner->Global_Ssh_User != NULL))
		STRDUP_PRINTF(arguments[1] ,"%s@%s",Reseau_Selectionner->Global_Ssh_User,Equipement_Selectionner->Adresse_Ip_Char);
	else
		if (Equipement_Selectionner->User_SSH != NULL) 
			STRDUP_PRINTF(arguments[1] ,"%s@%s",Equipement_Selectionner->User_SSH,Equipement_Selectionner->Adresse_Ip_Char);
		else
			arguments[1] = Equipement_Selectionner->Adresse_Ip_Char;
	arguments[2] = NULL;


	Change_Couleur_Ligne_Liste (Equipement_Selectionner->Objet_Liste_Par_Ip, 123 * 255, 141 * 255, 152 * 255,Reseau_Selectionner);
	Change_Couleur_Ligne_Liste (Equipement_Selectionner->Objet_Liste_Par_Type, 123 * 255, 141 * 255, 152 * 255,Reseau_Selectionner);

	hbox = gtk_hbox_new (FALSE, 0);
	gtk_box_set_spacing (GTK_BOX (hbox), 2);
	gtk_container_set_border_width (GTK_CONTAINER (hbox), 2);
	gtk_container_add (GTK_CONTAINER (viewport_Modules), hbox);
	gtk_widget_show (hbox);

	scrolled_window_terminal = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window_terminal), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_widget_show (scrolled_window_terminal);
	term_widget = (GtkWidget *) vte_terminal_new ();
	vte_terminal_set_emulation (term_widget, "xterm");
	vte_terminal_set_mouse_autohide (term_widget, TRUE);
	vte_terminal_reset (term_widget, TRUE, TRUE);


	Pid_Commande = vte_terminal_fork_command (term_widget, Commande, arguments, NULL, NULL, TRUE, TRUE, TRUE);
	gtk_widget_show (term_widget);
	gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scrolled_window_terminal), term_widget);
	gtk_box_pack_start (GTK_BOX (hbox), scrolled_window_terminal, TRUE, TRUE, 0);
	
	g_signal_connect(term_widget, "child-exited", G_CALLBACK(on_Console_Fin), Equipement_Selectionner);
	g_signal_connect(term_widget, "eof", G_CALLBACK(on_Console_Fin), Equipement_Selectionner);
	return hbox;
}

#endif
