/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gtk/gtk.h>
#include "Modules.h"
#include "Objet_Liste.h"
#include "Objet_Icone.h"
#include "Reseau.h"
#include "Objet.h"
#include "WakeUp_Interface.h"
#include "Snmp_Interface.h"
#include "Script_Interface.h"
#include "Root_Interface.h"
#include "Console.h"
#include "Vnc_Interface.h"
#include "Vnc.h"
#include "Equipement_Port.h"
#include "Settings_Port.h"
#include "Debug.h"
#include "Animation.h"
#include "Mem.h"


void Initialisation_Aucun_Module (void)
{





	/*scrolledwindow_Vide = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Vide);
	gtk_container_add (GTK_CONTAINER (viewport_Modules), scrolledwindow_Vide);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Vide), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	Liste_Vide = Create_Liste (FALSE, FALSE, FALSE,FALSE, FALSE);
	gtk_widget_show (Liste_Vide);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Vide), Liste_Vide);*/
}

void Initialisation_WakeUp (void)
{
	ERROR_if (Equipement_Selectionner == NULL);
	Destruction_Modules (FALSE);
	create_win_WakeUp();
	Equipement_Selectionner->Modules_Actuel = MODULES_WAKEUP;
}


void Module_Affiche_Port(){
	struct Struct_Port *Port = NULL;
	struct Struct_Modele_Objet *Objet = NULL;
	gchar    *Nom_Port = NULL;
	gint      i, Nb_Objet_Liste;
	

	Nb_Objet_Liste = g_list_length (Equipement_Selectionner->GList_Port);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Port = g_list_nth_data (Equipement_Selectionner->GList_Port, i);
		if ((Nom_Port = Nom_Du_Port (Port->Num_Port)) != NULL) {
		
			Objet = Ajouter_Nouvelle_Objet (PORTS, Nom_Port, (gpointer *) Port, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_MODULE);
		
			if ((Port->Etat_Port == FERMER)  || (Equipement_Raffraichir_Tout == Equipement_Selectionner)) {
				Affiche_Icone_Defaut_Griser_Objet_liste (Objet, Reseau_Selectionner);
				Change_Couleur_Gris_Texte_liste (Objet, Reseau_Selectionner);
			}
			Objet->Notification_En_Cours = Port->Notification_En_Cours;
			if (Port->Alert_notification)
				Active_Test_Etat_Objet (Objet, Reseau_Selectionner);
		}
	}
}


void Initialisation_Liste_ports (void)
{
	if (Reseau_Selectionner == NULL)
		return;
	ERROR_if (Equipement_Selectionner == NULL);
	Check_Equipement_Up(Equipement_Selectionner,Reseau_Selectionner);
	Destruction_Modules (FALSE);
	Equipement_Selectionner->Modules_Actuel = MODULES_LISTE_PORTS;

	treeview_Modules = Create_Icone (TRUE, TRUE, FALSE);
	Module_Affiche_Port();
}

	
void Initialisation_Vnc (void)
{
#ifdef   __VCN_ENABLE
	ERROR_if (Equipement_Selectionner == NULL);
	Check_Equipement_Up(Equipement_Selectionner,Reseau_Selectionner);

	free_gchar_if_no_null (Equipement_Selectionner->Vnc_Port);
	Equipement_Selectionner->Vnc_Port = g_strdup(Recuperation_Chaine_Attacher_Combo(combobox_liste_Modules));

	if 	((Equipement_Selectionner->Password_VNC_Default) 
			&& (Reseau_Selectionner->Global_Vnc_Password != NULL)){
	
		Initialisation_Vnc_Connect();	
	}
	else	{
	
		if (!Equipement_Selectionner->password_vnc_ok) {
			Destruction_Modules (FALSE);  
			create_win_Vnc_Connect ();
			Equipement_Selectionner->Modules_Actuel = MODULES_VNC;
		}
		else 
			Initialisation_Vnc_Connect();
	}
#endif
}


void Initialisation_Vnc_Connect (void)
{
#ifdef   __VCN_ENABLE
	gchar	*password = NULL;

	ERROR_if (Equipement_Selectionner == NULL);
	Check_Equipement_Up(Equipement_Selectionner,Reseau_Selectionner);
	Destruction_Modules (FALSE);
	if  ((Equipement_Selectionner->Password_VNC_Default) && (Reseau_Selectionner->Global_Vnc_Password != NULL)){
	
		Vnc_Console (NULL);		
	}
	else {
		if (!Equipement_Selectionner->password_vnc_ok)
			password = g_strdup (gtk_entry_get_text (GTK_ENTRY (entry_Vnc_Connect_Password)));
		else
			password = g_strdup (Equipement_Selectionner->password_vnc);
	
		Vnc_Console (password);
		free_gchar_if_no_null (password);	
	}
	Equipement_Selectionner->Modules_Actuel = MODULES_VNC_CONNECT;	
#endif
}


void Initialisation_Telnet (void)
{
#ifdef         __CONSOLE_ENABLE
	ERROR_if (Equipement_Selectionner == NULL);
	Check_Equipement_Up(Equipement_Selectionner,Reseau_Selectionner);
	Destruction_Modules (FALSE);
	if (Equipement_Selectionner->hbox_console_telnet != NULL){
		gtk_container_add (GTK_CONTAINER (viewport_Modules), Equipement_Selectionner->hbox_console_telnet);
		gtk_widget_show (Equipement_Selectionner->hbox_console_telnet);
	}
	else 
		Equipement_Selectionner->hbox_console_telnet = Creation_Console ("telnet");
	Equipement_Selectionner->Modules_Actuel = MODULES_TELNET;
	Equipement_TELNET_Connect_Actuel = Equipement_Selectionner;
#endif
}


void Initialisation_SSH (void)
{
#ifdef         __CONSOLE_ENABLE
	ERROR_if (Equipement_Selectionner == NULL);
	Check_Equipement_Up(Equipement_Selectionner,Reseau_Selectionner);
	Destruction_Modules (FALSE);
	if (Equipement_Selectionner->hbox_console_ssh != NULL){
		gtk_container_add (GTK_CONTAINER (viewport_Modules), Equipement_Selectionner->hbox_console_ssh);
		gtk_widget_show (Equipement_Selectionner->hbox_console_ssh);
	}
	else 
		Equipement_Selectionner->hbox_console_ssh  = Creation_Console ("ssh");
	Equipement_Selectionner->Modules_Actuel = MODULES_SSH;
	Equipement_SSH_Connect_Actuel = Equipement_Selectionner;
#endif
}


void Initialisation_Script (void)
{
#ifdef         __SCRIPT_ENABLE
	ERROR_if (Equipement_Selectionner == NULL);
	Check_Equipement_Up(Equipement_Selectionner,Reseau_Selectionner);
	Destruction_Modules (FALSE);
	create_win_Script ();
	Equipement_Selectionner->Modules_Actuel = MODULES_SCRIPTS;
#endif
}


void Initialisation_Snmp (void)
{
	ERROR_if (Equipement_Selectionner == NULL);
	if (Equipement_Selectionner->Modules_Actuel != MODULES_SNMP) {
		Destruction_Modules (FALSE);
		create_win_Snmp ();
		gtk_widget_set_sensitive (combobox_liste_Modules, FALSE);
		Equipement_Selectionner->Modules_Actuel = MODULES_SNMP;
	}
}

void Destruction_Modules (gboolean Changement_Equipement)
{
	if (Equipement_Selectionner == NULL)
		return;

	switch (Equipement_Selectionner->Modules_Actuel) {
	    case AUCUN_MODULES_SELECTIONNER:
		    break;
	    case MODULES_LISTE_PORTS:
			if (scrolledwindow_Icone_Liste==NULL)	
				DEBUG_ERROR("scrolledwindow_Icone_Liste==NULL");
			Efface_Icone_Program_Associe();
		    Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_MODULE);
		    gtk_widget_destroy (scrolledwindow_Icone_Liste);
		    break;
		case MODULES_VNC:
		#ifdef  __VCN_ENABLE
			if (scrolledwindow_Vnc_Connect==NULL)	
				DEBUG_ERROR("scrolledwindow_Vnc_Connect==NULL");
		    gtk_widget_destroy (scrolledwindow_Vnc_Connect);
		    break;
		#endif		
		case MODULES_VNC_CONNECT:
		#ifdef  __VCN_ENABLE
			if (scrolledwindow_Vnc==NULL)	
				DEBUG_ERROR("scrolledwindow_Vnc==NULL");
			gtk_widget_destroy (scrolledwindow_Vnc);
		    break;
		#endif			
	    case MODULES_TELNET:
		#ifdef         __CONSOLE_ENABLE
			if (!Changement_Equipement){
				if (Equipement_Selectionner->hbox_console_telnet==NULL)	
					DEBUG_ERROR("hbox_console_telnet==NULL");
				gtk_widget_destroy (Equipement_Selectionner->hbox_console_telnet);
				Degrise_Ligne_Console(Equipement_Selectionner);
			}	
			else{
				ERROR_if (Equipement_TELNET_Connect_Actuel == NULL);
				g_object_ref (Equipement_TELNET_Connect_Actuel->hbox_console_telnet);
				gtk_container_remove (GTK_CONTAINER (viewport_Modules), Equipement_TELNET_Connect_Actuel->hbox_console_telnet);
				Equipement_TELNET_Connect_Actuel = NULL;
			}			
		#endif
		    break;
	    case MODULES_SSH:
		#ifdef         __CONSOLE_ENABLE
			if (!Changement_Equipement){
				if (Equipement_Selectionner->hbox_console_ssh==NULL)	
					DEBUG_ERROR("hbox_console_ssh==NULL");
				gtk_widget_destroy (Equipement_Selectionner->hbox_console_ssh);
				Equipement_SSH_Connect_Actuel->hbox_console_ssh = NULL;
				Degrise_Ligne_Console(Equipement_Selectionner);
			}
			else{
				ERROR_if (Equipement_SSH_Connect_Actuel == NULL);
				g_object_ref (Equipement_SSH_Connect_Actuel->hbox_console_ssh);
				gtk_container_remove (GTK_CONTAINER (viewport_Modules), Equipement_SSH_Connect_Actuel->hbox_console_ssh);
				Equipement_SSH_Connect_Actuel = NULL;
			}			
		#endif
		    break;
	    case MODULES_SCRIPTS:
		#ifdef         __SCRIPT_ENABLE
			if (scrolledwindow_Script==NULL)	
				DEBUG_ERROR("scrolledwindow_Script==NULL");
		    gtk_widget_destroy (scrolledwindow_Script);
		#endif
		    break;
	    case MODULES_SNMP:
		    gtk_widget_set_sensitive (combobox_liste_Modules, TRUE);
			if (scrolledwindow_Snmp==NULL)	
				DEBUG_ERROR("scrolledwindow_Snmp==NULL");
		    gtk_widget_destroy (scrolledwindow_Snmp);
		    break;
		case MODULES_WAKEUP:
			if (scrolledwindow_WakeUp==NULL)	
				DEBUG_ERROR("scrolledwindow_WakeUp==NULL");
			gtk_widget_destroy (scrolledwindow_WakeUp);
			break;
	    default:
		    DEBUG_INFO("Erreur : Destruction_Modules modules %d Inconnu", Equipement_Selectionner->Modules_Actuel);
	}
	Equipement_Selectionner->combo_sauv = gtk_combo_box_get_active (GTK_COMBO_BOX (combobox_liste_Modules));
	Equipement_Selectionner->Modules_Actuel = AUCUN_MODULES_SELECTIONNER;
}


void Initialisation_Modules (void)
{
	/*GtkWidget *Liste_Vide = NULL;

	scrolledwindow_Vide = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Vide);
	gtk_container_add (GTK_CONTAINER (viewport_Modules), scrolledwindow_Vide);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Vide), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	Liste_Vide = Create_Liste (FALSE, FALSE, FALSE, FALSE, FALSE);
	gtk_widget_show (Liste_Vide);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Vide), Liste_Vide);*/
}
