/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gtk/gtk.h>
#include "Objet.h"
#include "Image.h"
#include "Objet_Liste.h"
#include "Declaration_Constante.h"
#include "Root_Interface.h"
#include "Objet_Gestion_Texte.h"
#include "Equipement_Port.h"
#include "Debug.h"
#include "Snmp.h"
#include "Mem.h"
#include "Win32.h"

extern struct Struct_Combo_Liste Liste_ComboTrueFalse[];

struct Struct_Modele_Objet Liste_Modele_Objet[] = {

	{LISTE_SERVEUR, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Server", NULL, NULL,TRUE, NULL,  "Type/Serveur.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_SWITCH, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Switch", NULL, NULL,TRUE, NULL,  "Type/switch.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_MULTIMEDIA, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Multimedia", NULL, NULL,TRUE, NULL,  "Type/tv.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_CONSOLE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Console", NULL, NULL,TRUE, NULL,  "Type/Console.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_WIFI, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Wifi", NULL, NULL, TRUE,NULL,  "Type/Wifi.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_PDA, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Pda", NULL, NULL,TRUE, NULL,  "Type/pda.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_IMPRIMANTE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Printer", NULL, NULL, TRUE,NULL,  "Type/printer.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_ROUTEUR, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Router", NULL, NULL, TRUE,NULL,  "Type/router.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_STATION, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Workstation", NULL, NULL, TRUE,NULL,  "Type/mycomputer.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_DISQUE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Disk", NULL, NULL, TRUE, NULL,  "Type/Disk.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_SECURITY_CAMERA, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Security Camera", NULL, NULL,TRUE, NULL,  "Type/Camcorder.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_UPS, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "UPS", NULL, NULL, TRUE,NULL,  "Type/ups.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_TELEPHONIE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Ip phone", NULL, NULL,TRUE, NULL,  "/Type/Phone.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_ROUTEUR_SWITCH, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Router-Switch", NULL, NULL,TRUE, NULL,  "Type/routerswitch.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_ROUTEUR_ADSL, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Router ADSL", NULL, NULL,TRUE, NULL,  "Type/Modem.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_MODEM, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Modem", NULL, NULL, TRUE,NULL,  "Type/Modem.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_FIREWALL, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Firewall", NULL, NULL, TRUE,NULL,  "Type/firewall.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_VPN, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Vpn", NULL, NULL, TRUE,NULL,  "Type/firewall.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_CAMERA, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Camera", NULL, NULL, TRUE,NULL,  "Type/camera.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_CELLULAR_PHONE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Cellular Phone", NULL, NULL, TRUE,NULL,  "Type/Cellular_Phones.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_MP3_PLAYER, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "MP3 Player", NULL, NULL,TRUE, NULL,  "Type/MP3_Player.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_TABLET, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Tablet", NULL, NULL,TRUE, NULL,  "Type/tablet.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_CAMCORDER, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Camcorder", NULL, NULL, TRUE,NULL,  "Type/Camcorder.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_POWERLINE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "PowerLine", NULL, NULL, TRUE,NULL,  "Type/Powerline.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_FAX, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "FAX", NULL, NULL,TRUE, NULL,  "Type/Fax.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_SECURITY_NETWORK, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Security Network", NULL, NULL,TRUE, NULL,  "Type/Fax.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_INDUSTRIAL_EQUIPMENT, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Industrial Equipment", NULL, NULL,TRUE, NULL,  "Type/Fax.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_FINGERPRINT_SCANNER, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Fingerprint Scanner", NULL, NULL,TRUE, NULL,  "Type/Fax.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},


	{LISTE_INCONNU, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Unknown", NULL, NULL, TRUE, NULL,  "Type/Inconnu.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_FIREWALLED, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Firewalled", NULL, NULL, TRUE, NULL,  "Type/firewall.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_MODELE_DOMAINE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Domaine???", NULL, NULL, TRUE, NULL,  "Type/Domaine.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{LISTE_MODELE_EQUIPEMENT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "Type/Default.png", &Copie_Icone_Equipement, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Equipement, &Action_Test_Click, &Action_Switch_Mode_Detaille, &Action_Raffraichir_Equipement, &Notification_Equipement, FALSE, NULL, NULL, NULL, NULL, FALSE, &Action_Test_Favoris, FALSE},
	{LISTE_MODELE_EQUIPEMENT_INCONNU, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "Type/Inconnu.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Equipement_Inconnu, &Action_Test_Click, &Action_Switch_Mode_Detaille, &Action_Raffraichir_Equipement, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, &Action_Test_Favoris, FALSE},
	{LISTE_MODELE_EQUIPEMENT_NOUVEAU, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "Type/Default.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Equipement_Inconnu, &Action_Test_Click, &Action_Switch_Mode_Detaille, &Action_Raffraichir_Equipement, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, &Action_Test_Favoris, FALSE},
	{LISTE_MODELE_EQUIPEMENT_PORT_FERMER, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL,TRUE, NULL,  "Type/blackbox.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Equipement_Inconnu, &Action_Test_Click, &Action_Switch_Mode_Detaille, &Action_Raffraichir_Equipement, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, &Action_Test_Favoris, FALSE},
	{LISTE_MODELE_EQUIPEMENT_FIREWALL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "Type/firewall.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Equipement_Inconnu, &Action_Test_Click, &Action_Switch_Mode_Detaille, &Action_Raffraichir_Equipement, &Notification_Equipement, FALSE, NULL, NULL, NULL, NULL, FALSE, &Action_Test_Favoris, FALSE},
	{LISTE_MODELE_EQUIPEMENT_AGENT_AUTOSCAN, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "Type/agent.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Equipement, &Action_Test_Click, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, &Action_Test_Favoris, FALSE},


	{INFO_ADRESSE_IP, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Ip Address : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_ADRESSE_MAC, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Mac Address : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_FOURNISSEUR, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Network card : %s", &Gestion_Texte_Fournisseur_Equipement, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_OS, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "System : %s", &Gestion_Texte_Syteme_Equipement, NULL, TRUE, NULL,  "System.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_OS_MD5, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "MD5 IPv4_old: %s", &Gestion_Texte_SytemeMD5_Equipement, NULL, TRUE, NULL,  "System.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_OS_MD5_W, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "MD5 IPv4: %s", &Gestion_Texte_SytemeMD5_W_Equipement, NULL, TRUE, NULL,  "System.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_OS_GROUP, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "System Group : %s", &Gestion_Texte_Syteme_Group_Equipement, NULL, TRUE, NULL,  "System.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},


	{INFO_NOM_DNS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Dns Name : %s", &Gestion_Texte_Dns_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_NOM_HOTE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Host Name : %s", &Gestion_Texte_HostName_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_PING_TIME, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Ping Time : %s", &Gestion_Texte_Ping_Time_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},


	{INFO_GATEWAY, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "This is probably a gateway for the LAN", NULL, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_ROUTAGE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "IPv4 Forwarding Enable", NULL, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_NOM_DOMAINE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Domain/WorkGroup : %s", &Gestion_Texte_Domaine_Equipement, NULL, TRUE, NULL,  "Domaine.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_NOM_UTILISATEUR, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "User : %s", &Gestion_Texte_Utilisateur_Equipement, NULL, TRUE, NULL,  "user.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INFO, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Info", NULL, NULL, TRUE, NULL,  "Information.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_PORTS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "TCP port : Open (%d/%d) Firewalled (%d/%d)", &Gestion_Texte_Port_Info_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_PORTS_OUVERT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "TCP port (Open) : %s", &Gestion_Texte_Port_Ouvert_Info_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_PORTS_FERMER, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "TCP port (Close) : %s", &Gestion_Texte_Port_Fermer_Info_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_PORTS_FIREWALLED, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "TCP port (firewall) : %s", &Gestion_Texte_Port_Firewall_Info_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_PORTS_UDP_OPEN_FILTERED, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "UDP port (open|filtered) : %s", &Gestion_Texte_Port_Udp_Info_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},


	{INFO_SNMP, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Snmp", NULL, NULL, TRUE, NULL,  "Snmp.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_SNMP_SYSTEM, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "System", NULL, NULL, TRUE, NULL,  "System.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_SYSTEM_NAME, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "System name : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "System.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_SYSTEM_DESCRIPTION, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Description : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "Notes.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_SYSTEM_CONTACT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Contact : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "user.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_SYSTEM_LOCATION, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Location : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "Localisation.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_SYSTEM_UPTIME, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Uptime : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "clock.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_SYSTEM_RAM, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Ram : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Memory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_SYSTEM_DEVICE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Device", NULL, NULL, TRUE, NULL,  "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_SYSTEM_LOGICAL_STORAGE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Logical storage", NULL, NULL, TRUE, NULL,  "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_SYSTEM_SERVICE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Service", NULL, NULL, TRUE, NULL,  "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_SNMP_NETWORK, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Network", NULL, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_ARP, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "ARP Table", NULL, NULL, TRUE, NULL,  "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_ROUTES, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Routes", NULL, NULL, TRUE, NULL,  "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_SNMP_NETWORK_INTERFACES, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Interfaces", NULL, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_INTERFACES_BASIC, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Basic Info", NULL, NULL, TRUE, NULL,  "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_INTERFACES_IN, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "In Statistic", NULL, NULL, TRUE, NULL,  "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_INTERFACES_OUT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Out Statistic", NULL, NULL, TRUE, NULL,  "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_SNMP_NETWORK_TCPIP, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "TCP/IP", NULL, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_NETWORK, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Networks", NULL, NULL, TRUE, NULL,  "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_TCP_CONNECTIONS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "TCP Connections", NULL, NULL, TRUE, NULL,  "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_UDP_SERVICES, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "UDP Services", NULL, NULL, TRUE, NULL,  "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_SNMP_NETWORK_TCPIP_IP, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "IP", NULL, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_SNMP_NETWORK_TCPIP_IP_INFO, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Info", NULL, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_FORWARDING, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Ip forwarding : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_TTL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Default TTL : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_REASS_TIMEOUT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Reassembly timeout : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_NEED_REASS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Needed to be reassembled : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_RE_ASSEM, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Re-assembled : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_REAS_FAIL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Reassembly failures : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_SUCCESS_FRAG, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Successfully fragmented : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_FRAG_FAIL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Fragmentation failures : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_CREAT_FRAG, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Created fragments : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_DISC_ROUT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Discarded routing entries : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Input datagrams", NULL, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT_ALL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "All : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT_FORWARDED, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Forwarded : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT_DELIVERED, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Delivered : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT_HEADER, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Header errors : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT_ADDRESS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Address errors : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT_PROTOCOL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Unknown protocols : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT_BUFFER, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Buffer errors : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_SNMP_NETWORK_TCPIP_IP_OUPUT, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Output datagrams", NULL, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_OUPUT_REQUESTED, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Requested : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_OUPUT_BUFFER, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Buffer errors : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_NETWORK_TCPIP_IP_OUPUT_ROUTED, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Not routed : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},



	{INFO_SNMP_MEM, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Mem", NULL, NULL, TRUE, NULL,  "Memory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_MEM_TOTAL_SWAP, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Total Swap : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Memory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_MEM_AVAILABLE_SWAP, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Available Swap  : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Memory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_MEM_TOTAL_REAL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Total Real : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Memory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_MEM_AVAILABLE_REAL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Available Real : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Memory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_MEM_TOTAL_FREE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Total Real : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Memory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_MEM_SHARED, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Shared : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Memory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_MEM_BUFFER, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Buffer : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Memory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_MEM_CACHED, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Cached: %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Memory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_MEM_SWAP_ERROR, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Swap Error : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Memory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_MEM_SWAP_ERROR_MSG, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Swap error Msg : [%s]", &Gestion_Texte_Default, NULL, TRUE, NULL,  "Memory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_MEM, 0, 0, OBJET_FILS, NULL, LISTE_PROGRESS, TRUE, FALSE, "Mem: %.1f%%free,  %.1f%%used,  %.1f%%cached", &Gestion_Texte_Mem_Equipement, NULL, TRUE, NULL,  "Memory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},


	{INFO_SNMP_CPU, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Cpu", NULL, NULL, TRUE, NULL,  "Processor.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_CPU_RAW_USER, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "User : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Processor.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_CPU_RAW_NICE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Nice : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Processor.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_CPU_RAW_SYSTEM, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "System : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Processor.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_CPU_RAW_IDLE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Idle : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Processor.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_CPU_RAW_WAIT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Wait : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Processor.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_CPU_RAW_KERNEL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Kernel : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Processor.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_CPU_RAW_INTERRUPT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Interrupt : %i", &Gestion_Integer_Default, NULL, TRUE, NULL,  "Processor.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_CPU, 0, 0, OBJET_FILS, NULL, LISTE_PROGRESS, TRUE, FALSE, "Cpu: %.1f%%us, %.1f%%sy, %.1f%%ni, %.1f%%id", &Gestion_Texte_Cpu_Equipement, NULL, TRUE, NULL,  "Processor.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_DISK, 0, 0, OBJET_FILS, NULL, LISTE_PROGRESS, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "Disk.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},




	{INFO_SNMP_SOFTWARE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Software", NULL, NULL, TRUE, NULL,  "Software.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_RUNNING_SOFTWARE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Running Software", NULL, NULL, TRUE, NULL,  "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_SNMP_BRIDGE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Brigde, Switch", NULL, NULL, TRUE, NULL,  "Switch.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_BRIDGE_FORWARDING_DATABASE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Forwarding database", NULL, NULL, TRUE, NULL,  "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SNMP_BRIDGE_STATIC_DATABASE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Static database", NULL, NULL, TRUE, NULL,  "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},



	{INFO_INVENTAIRE, 0, 0, OBJET_PARENT, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Inventory", NULL, NULL, TRUE, NULL,  "Inventory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INVENTAIRE_CONTACT, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Contact Person", NULL, NULL, TRUE, NULL,  "user.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INVENTAIRE_TEL_CONTACT, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Contact", NULL, NULL, TRUE,NULL,  "Phone.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INVENTAIRE_NUM_SERIE, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Serial Number", NULL, NULL, TRUE, NULL,  "UC.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INVENTAIRE_NUM_SERIE_ECRAN, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Serial Number (Display)", NULL, NULL, TRUE, NULL,  "Display.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INVENTAIRE_NUM_SERIE_IMPRIMANTE, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Serial Number (Printer)", NULL, NULL, TRUE, NULL,  "Printer.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INVENTAIRE_NUM_SERIE_OS, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Serial Number (OS)", NULL, NULL, TRUE,NULL,  "System.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INVENTAIRE_NUM_SERIE_SUITE_OFFICE, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Serial Number (Office Suite)", NULL, NULL, TRUE, NULL,  "soffice.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INVENTAIRE_PROCESSEUR, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Processor", NULL, NULL, TRUE,NULL,  "Processor.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INVENTAIRE_MEMOIRE, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "RAM (in MB)", NULL, NULL, TRUE, NULL,  "Memory.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INVENTAIRE_DISQUE, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Hard Drive Space (in gigabytes)", NULL, NULL, TRUE, NULL,  "Disk.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INVENTAIRE_NOTES, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Notes", NULL, NULL, TRUE, NULL,  "Notes.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INVENTAIRE_LOCALISATION, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Localisation", NULL, NULL, TRUE, NULL,  "Localisation.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_NETBIOS, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "NetBios names", NULL, NULL, TRUE, NULL,  "NetBios.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_NETBIOS_ENFANT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "NetBios.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_HISTORIQUE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "History", NULL, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_HISTORIQUE_ALERTE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "Error.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_HISTORIQUE_WARNING, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "Warning.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_HISTORIQUE_INFO, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_DERNIER_CHANGEMENT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Last State Change : %s", &Gestion_Texte_Dernier_Changement_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_TEMPS_SCAN_COMPLET, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Scanned in %d seconds", &Gestion_Texte_Temps_Scan_Complet_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_TEMPS_SCAN_PORT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Port TCP/IP: Scanned in %d seconds", &Gestion_Texte_Temps_Scan_Port_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_TEMPS_SCAN_PORT_UDP, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Port UDP: Scanned in %d seconds", &Gestion_Texte_Temps_Scan_Port_Udp_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_TEMPS_SCAN_SIGNATURE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Fingerprinting : Scanned in %d seconds", &Gestion_Texte_Temps_Scan_Signature_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_TEMPS_SCAN_SERVICE_FTP, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Ftp : Scanned in %d seconds", &Gestion_Texte_Temps_Scan_Service_FTP_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_TEMPS_SCAN_SERVICE_HTTP, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Http : Scanned in %d seconds", &Gestion_Texte_Temps_Scan_Service_HTTP_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_TEMPS_SCAN_SERVICE_IMAP, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Imap : Scanned in %d seconds", &Gestion_Texte_Temps_Scan_Service_IMAP_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_TEMPS_SCAN_SERVICE_SMTP, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Smtp : Scanned in %d seconds", &Gestion_Texte_Temps_Scan_Service_SMTP_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_TEMPS_SCAN_SERVICE_SSH, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Ssh : Scanned in %d seconds", &Gestion_Texte_Temps_Scan_Service_SSH_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_TEMPS_SCAN_SERVICE_TELNET, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Telnet : Scanned in %d seconds", &Gestion_Texte_Temps_Scan_Service_TELNET_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_TEMPS_SCAN_SNMP, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Snmp : Scanned in %d seconds", &Gestion_Texte_Temps_Scan_Snmp_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_TEMPS_SCAN_DNS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Dns : Scanned in %d seconds", &Gestion_Texte_Temps_Scan_Dns_Equipement, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},


	{INFO_CONTACT_ADMIN, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Admin Email", NULL,  NULL,TRUE, NULL,  "Email.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_CONFIG_NOTIFICATION, 0, 0, OBJET_FILS, NULL, LISTE_COMBO, TRUE, FALSE, "Notification", NULL,  NULL,TRUE, NULL,  "Email.png", NULL, NULL, NULL, 0, FALSE, &Edit_Boolean, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_ALIAS, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Alias", NULL, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Alias, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_DEFAULT_SSH_USER, 0, 0, OBJET_FILS, NULL, LISTE_COMBO, TRUE, FALSE, "Use the Default SSH User", NULL, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, &Edit_Boolean, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_SSH_USER, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "SSH User", NULL, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_DEFAULT_PASSWORD_VNC, 0, 0, OBJET_FILS, NULL, LISTE_COMBO, TRUE, FALSE, "Use the Default Vnc Password", NULL, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, &Edit_Boolean, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_PASSWORD_VNC, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Password VNC", NULL, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, TRUE},
	{INFO_VIEW_ONLY_VNC, 0, 0, OBJET_FILS, NULL, LISTE_COMBO, TRUE, FALSE, "VNC (view only)", NULL, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, &Edit_Boolean, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},


	{INFO_INTERFACE_AGENT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Interface : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_NAME_RESEAU, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Name : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_ETAT_RESEAU, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "State : %s", &Gestion_Texte_Etat_Reseau, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},

	{INFO_COMMUNAUTE_SNMP_AGENT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "SNMP Community Name : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_IP_AGENT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "IP AGENT : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_NB_EQUIPEMENT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Total number of found devices : %d", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_NB_EQUIPEMENT_SCAN, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Number of currently scanned devices : %d", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_NB_EQUIPEMENT_ATTENTE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Number of devices waiting for scan : %d", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_NB_THREAD, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Number of threads : %d", &Gestion_Integer_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INTERFACE_AGENT_VERSION, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Version : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INTERFACE_AGENT_CONFIG, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Config : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INTERFACE_AGENT_LOGS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Logs : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INTERFACE_AGENT_COMPIL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Compiled on %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_INTERFACE_AGENT_COMPIL_OPTION, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Options : %s", &Gestion_Texte_Default, NULL, TRUE, NULL,  "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},


	{INFO_GLOBAL_SSH_USER, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Default SSH User", NULL, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_GLOBAL_VNC_PASSWORD, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Default VNC Password", NULL, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, TRUE},
	{INFO_CONFIG_ALERT_INTRUSION, 0, 0, OBJET_FILS, NULL, LISTE_COMBO, TRUE, FALSE, "Alert Intrusion", NULL,  NULL,TRUE, NULL,  "Email.png", NULL, NULL, NULL, 0, FALSE, &Edit_Boolean, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_EMAIL_ALERT_INTRUSION, 0, 0, OBJET_FILS, NULL, LISTE_TEXT_EDITABLE, TRUE, FALSE, "Default Email Address", NULL, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_DEBUG_DAEMON, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},




/*	{PARTAGE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "Partage.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, &Double_Clic_Partage, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{PARTAGE_IMPRIMANTE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "unknown.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{PARTAGE_REPERTOIRE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "folder.png", NULL, NULL, NULL, 0, FALSE, NULL, &Termine_Renommer_Nom_Repertoire_Samba, NULL, &Double_Clic_Repertoire, &Affiche_Menu_Samba, &Rafraichir_Samba, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{FICHIER_PARTAGER, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "unknown.png", &Copie_Icone_Partage, NULL, NULL, 0, FALSE, NULL, &Termine_Renommer_Nom_Fichier_Samba, NULL, &Double_Clic_Fichier, &Affiche_Menu_Samba, &Rafraichir_Samba, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{PARTAGE_REPERTOIRE_SUPERIEUR, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "Retour.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, &Double_Clic_Repertoire, &Affiche_Menu_Samba, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
*/
	{PORTS, 0, 0, OBJET_FILS, NULL, ICONE, TRUE, FALSE, NULL, NULL, NULL, TRUE, NULL,  "kservices.png", &Copie_Icone_Port, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, &Notification_Port, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_TYPE_PARENT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Type : %s", &Gestion_Texte_Type_Parent, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
	{INFO_PARENT_NB_FILS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Total : %d", &Gestion_Texte_Parent_Nb_Fils, NULL, TRUE, NULL,  "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL, FALSE},
};


GtkWidget *Widget_Liste (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	switch (Objet->ID_Liste) {
	    case LISTE_MACHINE_PAR_TYPE:
		    return Reseau->Liste_Equipement_Type;
		case LISTE_MACHINE_PAR_IP:
		    return Reseau->Liste_Equipement_IP;
	    case LISTE_INFO:
		    return treeview_Info;
		case LISTE_CONFIG:
		    return treeview_Config;
		case LISTE_INFO_AUTRE:
			return treeview_Info_Autre;
		case LISTE_INFO_SNMP:
			return treeview_Info_Snmp;
		case LISTE_INFO_INVENTAIRE:
			return treeview_Info_Inventaire;
		case LISTE_INFO_HISTORIQUE:
			return treeview_Info_Historique;
		case LISTE_INFO_DEBUG_DAEMON:
			return treeview_Info_Debug_Daemon;
	    case LISTE_MODULE:
		    return treeview_Modules;
		case LISTE_NETWORK:
			return treeview_network;
	    default:
		    DEBUG_ERROR("Erreur : Widget Liste inconnu");
	}
	return NULL;
}


void Modifie_Etat_Bouton (struct Struct_Modele_Objet *Objet)
{
	ERROR_if (Objet == NULL);
	gtk_widget_set_sensitive (toggletoolbutton_Notification, FALSE);
	Modification_Toggle_En_Cours = TRUE;
	gtk_toggle_tool_button_set_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Notification), Objet->Notification_En_Cours);
	Modification_Toggle_En_Cours = FALSE;
	gtk_widget_set_sensitive (toggletoolbutton_Notification, (Objet->Action_Notification != NULL));
	gtk_widget_set_sensitive (button_Refresh, (Objet->Action_Rafraichissement != NULL));

	Reseau_Selectionner->ID_Derniere_Liste_Selectionner = Objet->ID_Liste;
}


GList    *GList_Liste_ID_Liste (struct Struct_Liste_Reseau *Reseau, guint ID_Liste)
{
	ERROR_if (Reseau == NULL);
	switch (ID_Liste) {
	    case LISTE_MACHINE_PAR_TYPE:
		    return Reseau->GList_Liste_Equipement;
		case LISTE_MACHINE_PAR_IP:
		    return Reseau->GList_Liste_Equipement;
	    case LISTE_INFO:
		    return Reseau->GList_Liste_Info;
		case LISTE_CONFIG:
			return Reseau->GList_Liste_Config;
		case LISTE_INFO_AUTRE:
		    return Reseau->GList_Liste_Info_Autre;
		case LISTE_INFO_SNMP:
			return Reseau->GList_Liste_Info_Snmp;
		case LISTE_INFO_INVENTAIRE:
		    return Reseau->GList_Liste_Info_Inventaire;
		case LISTE_INFO_HISTORIQUE:
		    return Reseau->GList_Liste_Info_Historique;
		case LISTE_INFO_DEBUG_DAEMON:
		    return Reseau->GList_Liste_Info_Debug_Daemon;
	    case LISTE_MODULE:
		    return Reseau->GList_Liste_Module;
	    default:
		    DEBUG_ERROR("Erreur : Glist Liste inconnu");
	}
	return NULL;
}


GList    *GList_Liste (struct Struct_Modele_Objet * Objet, struct Struct_Liste_Reseau * Reseau)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	return GList_Liste_ID_Liste (Reseau, Objet->ID_Liste);
}


void Recupere_Nouveau_Pointeur_Liste_ID_Liste (guint ID_Liste, struct Struct_Liste_Reseau *Reseau, GList * Nouveau_Pointeur_Glist)
{
	ERROR_if (Reseau == NULL);
	switch (ID_Liste) {
	    case LISTE_MACHINE_PAR_TYPE:
		    Reseau->GList_Liste_Equipement = Nouveau_Pointeur_Glist;
		    break;
		case LISTE_MACHINE_PAR_IP:
		    Reseau->GList_Liste_Equipement = Nouveau_Pointeur_Glist;
		    break;
	    case LISTE_INFO:
		    Reseau->GList_Liste_Info = Nouveau_Pointeur_Glist;
		    break;
		case LISTE_CONFIG:
		    Reseau->GList_Liste_Config = Nouveau_Pointeur_Glist;
		    break;
	    case LISTE_INFO_AUTRE:
		    Reseau->GList_Liste_Info_Autre = Nouveau_Pointeur_Glist;
		    break;
		case LISTE_INFO_SNMP:
			Reseau->GList_Liste_Info_Snmp = Nouveau_Pointeur_Glist;
		    break;
		case LISTE_INFO_INVENTAIRE:
		    Reseau->GList_Liste_Info_Inventaire = Nouveau_Pointeur_Glist;
		    break;
		case LISTE_INFO_HISTORIQUE:
		    Reseau->GList_Liste_Info_Historique = Nouveau_Pointeur_Glist;
		    break;
		case LISTE_INFO_DEBUG_DAEMON:
		    Reseau->GList_Liste_Info_Debug_Daemon = Nouveau_Pointeur_Glist;
		    break;
	    case LISTE_MODULE:
		    Reseau->GList_Liste_Module = Nouveau_Pointeur_Glist;
		    break;
	    default:
		    DEBUG_ERROR("Erreur : Recupere_Nouveau_Pointeur_Liste Liste inconnu = [%d]", ID_Liste);
	}
}


void Recupere_Nouveau_Pointeur_Liste (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau, GList * Nouveau_Pointeur_Glist)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Recupere_Nouveau_Pointeur_Liste_ID_Liste (Objet->ID_Liste, Reseau, Nouveau_Pointeur_Glist);
}


struct Struct_Modele_Objet *Recupere_Pointeur_Objet_Dans_Une_Liste (GList * GList, int rang)
{
	return g_list_nth_data (GList, rang);
}


guint Recupere_Rang_Objet_Dans_Une_Liste (GList * GList, struct Struct_Modele_Objet * Objet)
{
	ERROR_if (Objet == NULL);
	return g_list_position (GList, g_list_find (GList, Objet));
}


GList    *Supprime_Dans_Liste_Objets (GList * GList, struct Struct_Modele_Objet * Objet, gboolean Message_Erreur)
{
	ERROR_if (Objet == NULL);
	if (g_list_find (GList, Objet) != NULL) {
		return g_list_remove (GList, Objet);
	}
	if (Message_Erreur)
		DEBUG_WARNING("Tentative de suppression d'un objet(%d)|%s] dans une liste qui n'est pas present",Objet->ID_Modele_Objet,Objet->Texte_Defaut);
	return GList;
}


GList    *Ajouter_Dans_Liste_Objets (GList * GList, struct Struct_Modele_Objet * Objet)
{
	ERROR_if (Objet == NULL);
	if (g_list_find (GList, Objet) == NULL)
		return g_list_append (GList, Objet);

	DEBUG_WARNING("Warning : Tentative d'ajout d'un objet(%d)|%s] dans une liste qui est deja present",Objet->ID_Modele_Objet,Objet->Texte_Defaut);
	return GList;
}


void Affiche_Icone_Defaut_Griser_Objet_liste (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	GtkTreeModel *model = NULL;

	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	if ((Objet->Presentation == LISTE) || (Objet->Presentation == LISTE_PROGRESS)) {
		model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
		gtk_tree_store_set (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne, COL_ICON_LIST, Objet->icone_griser, -1);
	}
	else {
		model = gtk_icon_view_get_model (GTK_ICON_VIEW (Widget_Liste (Objet, Reseau)));
		gtk_list_store_set (GTK_LIST_STORE (model), &Objet->ID_Arbre_Ligne, COL_ICON_LIST, Objet->icone_griser, -1);
	}
}


void Affiche_Icone_Defaut_Objet_liste (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	GtkTreeModel *model = NULL;

	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	if ((Objet->Presentation == LISTE)|| (Objet->Presentation == LISTE_PROGRESS) || (Objet->Presentation == LISTE_COMBO) || (Objet->Presentation == LISTE_TEXT_EDITABLE)  ) {
		model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
		gtk_tree_store_set (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne, COL_ICON_LIST, Objet->icone, -1);
	}
	else {
		model = gtk_icon_view_get_model (GTK_ICON_VIEW (Widget_Liste (Objet, Reseau)));
		gtk_list_store_set (GTK_LIST_STORE (model), &Objet->ID_Arbre_Ligne, COL_ICON_LIST, Objet->icone, -1);
	}
}


void Active_Rachaichissment_Objet (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Reseau->GList_Rafraichissement = Ajouter_Dans_Liste_Objets (Reseau->GList_Rafraichissement, Objet);

}

void Active_Alerte_Objet (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Reseau->GList_Alerte = Ajouter_Dans_Liste_Objets (Reseau->GList_Alerte, Objet);
}

void Active_Test_Etat_Objet (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Reseau->GList_Test_Etat = Ajouter_Dans_Liste_Objets (Reseau->GList_Test_Etat, Objet);
}


void Desactive_Rachaichissment_Objet (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau, gboolean Message_Erreur)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Reseau->GList_Rafraichissement = Supprime_Dans_Liste_Objets (Reseau->GList_Rafraichissement, Objet, Message_Erreur);
	Affiche_Icone_Defaut_Objet_liste (Objet, Reseau);
}

void Desactive_Alerte_Objet (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau, gboolean Message_Erreur)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);

	Reseau->GList_Alerte = Supprime_Dans_Liste_Objets (Reseau->GList_Alerte, Objet, Message_Erreur);
}

void Desactive_Test_Etat_Objet (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau, gboolean Message_Erreur)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Reseau->GList_Test_Etat = Supprime_Dans_Liste_Objets (Reseau->GList_Test_Etat, Objet, Message_Erreur);
	Affiche_Icone_Defaut_Objet_liste (Objet, Reseau);
}


void Selectionne_Objet_Dans_Liste (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	GtkTreeViewColumn *column = NULL;
	GtkTreePath *path = NULL;
	GtkTreeModel *model = NULL;

	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
	column = gtk_tree_view_get_column (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)), 0);
	path = gtk_tree_model_get_path (model, &Objet->ID_Arbre_Ligne);
	gtk_tree_view_expand_to_path (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)), path);
	gtk_tree_view_set_cursor (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)), path, NULL, FALSE);
	gtk_tree_path_free (path);
}


void Afficher_Liste (GList * GList)
{
	struct Struct_Modele_Objet *Objet = NULL, *ObjetPere = NULL;
	guint     Nb_Objet_Liste, i, rangPere;

	if (GList != NULL) {
		Nb_Objet_Liste = g_list_length (GList);
		DEBUG_WARNING("Affiche Liste (%d)******************", Nb_Objet_Liste);
		for (i = 0; i < Nb_Objet_Liste; i++) {
			Objet = g_list_nth_data (GList, i);
			ObjetPere = (struct Struct_Modele_Objet *) Objet->Objet_Pere;
			rangPere = g_list_position (GList, g_list_find (GList, ObjetPere));
			DEBUG_WARNING("%d : [%d][%s][%d]  Pere:(%d)", i, Objet->ID_Modele_Objet, Objet->Texte_Defaut, Objet->Nb_Enfant, rangPere);
		}
		DEBUG_WARNING("Fin Liste *****************");
	}
}


void Supprime_Objet_Liste (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	struct Struct_Modele_Objet *ObjetPere = NULL;
	GtkTreeModel *model = NULL;
	guint     Nb_Objet_Liste, rangObjet;

	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Nb_Objet_Liste = g_list_length (GList_Liste (Objet, Reseau));
	if (Nb_Objet_Liste != 0) {
		Objet->Nb_Enfant--;
		rangObjet = g_list_position (GList_Liste (Objet, Reseau), g_list_find (GList_Liste (Objet, Reseau), Objet));
		if (rangObjet == -1)
			DEBUG_ERROR("Suppression Objet dans une liste non present");
		ObjetPere = (struct Struct_Modele_Objet *) Objet->Objet_Pere;
		if (Objet->Nb_Enfant <= 0) {
			Desactive_Rachaichissment_Objet (Objet, Reseau, FALSE);
			Desactive_Alerte_Objet (Objet, Reseau, FALSE);
			Desactive_Test_Etat_Objet (Objet, Reseau, FALSE);
			Recupere_Nouveau_Pointeur_Liste (Objet, Reseau, Supprime_Dans_Liste_Objets (GList_Liste (Objet, Reseau), Objet, TRUE));
			if ((Objet->Presentation == LISTE) || (Objet->Presentation == LISTE_PROGRESS) || (Objet->Presentation == LISTE_COMBO) || (Objet->Presentation == LISTE_TEXT_EDITABLE)) {
				model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
				gtk_tree_store_remove (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne);
			}
			else {
				model = gtk_icon_view_get_model (GTK_ICON_VIEW (Widget_Liste (Objet, Reseau)));
				gtk_list_store_remove (GTK_LIST_STORE (model), &Objet->ID_Arbre_Ligne);
			}
		
			if (!Objet->Texte_Default_Non_Modifier)
				if (Objet->Texte_Defaut != NULL)
					MYFREE (Objet->Texte_Defaut);
			if (!Objet->Chaine_Attacher_Non_Modifier)
				if (Objet->Chaine_Attacher != NULL)
					MYFREE (Objet->Chaine_Attacher);
		
			MYFREE (Objet);
		}
		if (ObjetPere != NULL)
			Supprime_Objet_Liste (ObjetPere, Reseau);
	}
	else
		DEBUG_ERROR("Erreur: Suppression Objet dans une liste vide");
}


void Supprime_Objet_Fils_Liste (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	if (Objet->Nb_Enfant == 0) {
		Supprime_Objet_Liste (Objet, Reseau);
	}
	else
		DEBUG_ERROR("Erreur : Tentative de suppression d'un objet parent");
}

void Efface_Toute_Objet_Liste (struct Struct_Liste_Reseau *Reseau, guint ID_Liste)
{
	struct Struct_Modele_Objet *Objet = NULL;
	guint     Nb_Objet_Liste, i;

	ERROR_if (Reseau == NULL);
	Nb_Objet_Liste = g_list_length (GList_Liste_ID_Liste (Reseau, ID_Liste));
	if (Nb_Objet_Liste != 0) {
		i = 0;
		while ((Objet = g_list_nth_data (GList_Liste_ID_Liste (Reseau, ID_Liste), i)) != NULL) {
			if (Objet == NULL)
				DEBUG_ERROR("Erreur : Liste chaines probleme pendant la suppression donnee == NULL");
			if ((Objet->ID_Type_Objet == OBJET_FILS) || ((Objet->ID_Type_Objet == OBJET_PARENT) && (Objet->Nb_Enfant == 0))) {
				Supprime_Objet_Fils_Liste (Objet, Reseau);
				i = 0;
			}
			else {
				i++;
			}
		}
	}
	if (g_list_length (GList_Liste_ID_Liste (Reseau, ID_Liste)) != 0)
		DEBUG_ERROR("Efface_Toute_Objet_Liste n'a pas supprimé toute la liste");
	if (ID_Liste == Reseau->ID_Derniere_Liste_Selectionner)
		gtk_widget_set_sensitive (button_Refresh, FALSE);
}


struct Struct_Modele_Objet *Recherche_Si_Objet_Deja_Afficher (struct Struct_Liste_Reseau *Reseau, int Modele_Objet, gchar * Texte, struct Struct_Modele_Objet *Parent, guint ID_Liste)
{
	struct Struct_Modele_Objet *Objet = NULL, *ObjetPere = NULL;
	guint     Nb_Objet_Liste, i;

	ERROR_if (Reseau == NULL);
	Nb_Objet_Liste = g_list_length (GList_Liste_ID_Liste (Reseau, ID_Liste));
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Objet = g_list_nth_data (GList_Liste_ID_Liste (Reseau, ID_Liste), i);
		ObjetPere = (struct Struct_Modele_Objet *) Objet->Objet_Pere;
	
		if (Texte != NULL) {
			if ((Objet->ID_Modele_Objet == Modele_Objet) && (strcmp (Objet->Texte_Defaut, Texte) == 0) && (Parent == ObjetPere))
				return Objet;
		}
		else {
			if ((Objet->ID_Modele_Objet == Modele_Objet) && (Parent == ObjetPere))
				return Objet;
		}
	}
	return NULL;
}


struct Struct_Modele_Objet *Ajouter_Objet_comme_modele (struct Struct_Liste_Reseau *Reseau, int Modele_Objet, gchar * Texte, guint ID_Liste, gpointer * Pointeur_Attacher)
{
	struct Struct_Modele_Objet *Objet = NULL;

	ERROR_if (Reseau == NULL);
	if (Liste_Modele_Objet[Modele_Objet].icone == NULL) {
		Liste_Modele_Objet[Modele_Objet].icone = Chargement_Image (Liste_Modele_Objet[Modele_Objet].Chemin_Icone, COULEUR);
		Liste_Modele_Objet[Modele_Objet].icone_griser = Chargement_Image (Liste_Modele_Objet[Modele_Objet].Chemin_Icone, NOIR_ET_BLANC);
	}

	MALLOC (Objet,sizeof (struct Struct_Modele_Objet));
	memcpy (Objet, &Liste_Modele_Objet[Modele_Objet], sizeof (struct Struct_Modele_Objet));
	Objet->Pointeur_Attacher = Pointeur_Attacher;
	if (Texte == NULL) {
		if (Objet->Gestion_Texte != NULL){
			Objet->Texte_Defaut = (*Objet->Gestion_Texte) ((gpointer *) Objet);
			Objet->Texte_Default_Non_Modifier = FALSE;
		}
	}
	else {
		Objet->Texte_Defaut = g_strdup (Texte);
		Objet->Texte_Default_Non_Modifier = FALSE;
	}
	if (ID_Liste!=LISTE_MACHINE_PAR_IP)
		Recupere_Nouveau_Pointeur_Liste_ID_Liste (ID_Liste, Reseau, Ajouter_Dans_Liste_Objets (GList_Liste_ID_Liste (Reseau, ID_Liste), Objet));

	return Objet;
}


struct Struct_Modele_Objet *Ajouter_Nouvelle_Objet (int Modele_Objet, gchar * Texte, gpointer * Pointeur_Attacher, gchar * Chaine_Attacher, gint Entier_Attacher,  int Modele_Objet_Parent, gchar * Texte_Parent, int Modele_Objet_Grand_Parent, int Modele_Objet_AGrand_Parent, int Modele_Objet_AAGrand_Parent, int Modele_Objet_AAAGrand_Parent, guint ID_Reseau, guint ID_Liste)
{
	struct Struct_Modele_Objet *Objet = NULL, *Parent = NULL, *Grand_parent = NULL;
	struct Struct_Liste_Reseau *Reseau = NULL;
	GtkTreeModel *model = NULL;
	GtkTreeIter Ligne;

	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau);

	if (Modele_Objet_Parent != PERE_RACINE) {
	
		if (Liste_Modele_Objet[Modele_Objet_Parent].ID_Type_Objet == OBJET_PARENT) {
		
			Parent = Ajouter_Nouvelle_Objet (Modele_Objet_Parent, Texte_Parent, NULL, NULL, 0, Modele_Objet_Grand_Parent, NULL, Modele_Objet_AGrand_Parent, Modele_Objet_AAGrand_Parent, Modele_Objet_AAAGrand_Parent, PERE_RACINE, ID_Reseau, ID_Liste);
		}
		else
			DEBUG_ERROR("[%d][%s] creation parent avec l'objet [%d] qui ne peut pas etre un parent   (Modele_Objet[Modele_Objet_Parent].ID_Type_Objet!=OBJET_PARENT)",Modele_Objet, Texte, Modele_Objet_Parent);
	}

	if ((Objet = Recherche_Si_Objet_Deja_Afficher (Reseau, Modele_Objet, Texte, Parent, ID_Liste)) == NULL) {
		Objet = Ajouter_Objet_comme_modele (Reseau, Modele_Objet, Texte, ID_Liste, Pointeur_Attacher);
		if (Chaine_Attacher != NULL){
			Objet->Chaine_Attacher = g_strdup (Chaine_Attacher);
			Objet->Chaine_Attacher_Non_Modifier = FALSE;
		}
	}
	else {
		if ((Parent != NULL) && (Objet->ID_Type_Objet == OBJET_FILS)) {
			Parent->Nb_Enfant--;
			Grand_parent = (struct Struct_Modele_Objet *) Parent->Objet_Pere;
			if (Grand_parent != NULL)
				Grand_parent->Nb_Enfant--;
		}
	}
	Objet->Objet_Pere = (gpointer *) Parent;
	if (Objet->ID_Type_Objet == OBJET_PARENT)
		Objet->Nb_Enfant++;
	if (Objet->Recupere_icone != NULL)
		(*Objet->Recupere_icone) ((gpointer *) Objet);

	if (!Objet->Afficher) {
		ERROR_if (Objet->icone == NULL);
	
		Objet->ID_Liste = ID_Liste;
		Objet->ID_Reseau = ID_Reseau;
		switch (Objet->Presentation){
			case LISTE :
				model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
				if (Parent != NULL)
					gtk_tree_store_append (GTK_TREE_STORE (model), &Ligne, &Parent->ID_Arbre_Ligne);
				else
					gtk_tree_store_append (GTK_TREE_STORE (model), &Ligne, NULL);
				Objet->ID_Arbre_Ligne = Ligne;
				gtk_tree_store_set (GTK_TREE_STORE (model), &Ligne, COL_TEXT_LIST, Objet->Texte_Defaut, COLUMN_EDITABLE_LIST, (Objet->Modification != NULL), POINTER_LIST, Objet, COL_IS_DIRECTORY_LIST, ((Objet->ID_Type_Objet) == OBJET_PARENT), COL_TEXT_LIST_VISIBLE, TRUE, LISTE_POURCENTAGE_VISIBLE, FALSE, -1);
				Affiche_Icone_Defaut_Objet_liste (Objet, Reseau);
				break;
			case ICONE :
				model = gtk_icon_view_get_model (GTK_ICON_VIEW (Widget_Liste (Objet, Reseau)));
				gtk_list_store_append (GTK_LIST_STORE (model), &Ligne);
				Objet->ID_Arbre_Ligne = Ligne;
				gtk_list_store_set (GTK_LIST_STORE (model), &Ligne, COL_ICON_LIST, Objet->icone, COL_TEXT_LIST, Objet->Texte_Defaut, POINTER_LIST, Objet, -1);
				break;
			case LISTE_PROGRESS :
				model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
				if (Parent != NULL)
					gtk_tree_store_append (GTK_TREE_STORE (model), &Ligne, &Parent->ID_Arbre_Ligne);
				else
					gtk_tree_store_append (GTK_TREE_STORE (model), &Ligne, NULL);
				Objet->ID_Arbre_Ligne = Ligne;
				gtk_tree_store_set (GTK_TREE_STORE (model), &Ligne, POINTER_LIST, Objet, COL_IS_DIRECTORY_LIST, ((Objet->ID_Type_Objet) == OBJET_PARENT), LISTE_POURCENTAGE_TEXTE, Objet->Texte_Defaut, LISTE_POURCENTAGE, Entier_Attacher,LISTE_POURCENTAGE_VISIBLE, TRUE,  COL_TEXT_LIST_VISIBLE, FALSE,-1);
				Affiche_Icone_Defaut_Objet_liste (Objet, Reseau);
				break;
			case LISTE_COMBO :
				model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
				if (Parent != NULL)
					gtk_tree_store_append (GTK_TREE_STORE (model), &Ligne, &Parent->ID_Arbre_Ligne);
				else
					gtk_tree_store_append (GTK_TREE_STORE (model), &Ligne, NULL);
				Objet->ID_Arbre_Ligne = Ligne;
			
			
			
				gtk_tree_store_set (GTK_TREE_STORE (model), &Ligne, COL_TEXT_LIST, Objet->Texte_Defaut, POINTER_LIST, Objet, COL_IS_DIRECTORY_LIST, ((Objet->ID_Type_Objet) == OBJET_PARENT), COL_TEXT_LIST_VISIBLE, TRUE,LISTE_POURCENTAGE_VISIBLE, FALSE, LISTE_COMBOLIST_VISIBLE,TRUE,LISTE_COMBOLIST, Liste_ComboTrueFalse[(int)*Objet->Pointeur_Attacher].Chaine, -1);
				Affiche_Icone_Defaut_Objet_liste (Objet, Reseau);
				break;
			case LISTE_TEXT_EDITABLE :
				model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
				if (Parent != NULL)
					gtk_tree_store_append (GTK_TREE_STORE (model), &Ligne, &Parent->ID_Arbre_Ligne);
				else
					gtk_tree_store_append (GTK_TREE_STORE (model), &Ligne, NULL);
				Objet->ID_Arbre_Ligne = Ligne;
				if (*Objet->Pointeur_Attacher == NULL)
					gtk_tree_store_set (GTK_TREE_STORE (model), &Ligne, COL_TEXT_LIST, Objet->Texte_Defaut, POINTER_LIST, Objet, COL_IS_DIRECTORY_LIST, ((Objet->ID_Type_Objet) == OBJET_PARENT), COL_TEXT_LIST_VISIBLE, TRUE, LISTE_POURCENTAGE_VISIBLE, FALSE,LISTE_TEXTE_EDITABLE_VISIBLE, TRUE,LISTE_TEXTE_EDITABLE_EDITABLE, TRUE,LISTE_TEXTE_EDITABLE,"-- UNDEFINED --", -1);
				else
					if (!Objet->TextPassword)
						gtk_tree_store_set (GTK_TREE_STORE (model), &Ligne, COL_TEXT_LIST, Objet->Texte_Defaut, POINTER_LIST, Objet, COL_IS_DIRECTORY_LIST, ((Objet->ID_Type_Objet) == OBJET_PARENT), COL_TEXT_LIST_VISIBLE, TRUE, LISTE_POURCENTAGE_VISIBLE, FALSE,LISTE_TEXTE_EDITABLE_VISIBLE, TRUE,LISTE_TEXTE_EDITABLE_EDITABLE, TRUE,LISTE_TEXTE_EDITABLE,*Objet->Pointeur_Attacher, -1);
					else
						gtk_tree_store_set (GTK_TREE_STORE (model), &Ligne, COL_TEXT_LIST, Objet->Texte_Defaut, POINTER_LIST, Objet, COL_IS_DIRECTORY_LIST, ((Objet->ID_Type_Objet) == OBJET_PARENT), COL_TEXT_LIST_VISIBLE, TRUE, LISTE_POURCENTAGE_VISIBLE, FALSE,LISTE_TEXTE_EDITABLE_VISIBLE, TRUE,LISTE_TEXTE_EDITABLE_EDITABLE, TRUE,LISTE_TEXTE_EDITABLE,"-- The Password is defined --", -1);
			
			
			
				Affiche_Icone_Defaut_Objet_liste (Objet, Reseau);
				break;
			default :
				DEBUG_ERROR("[%d][%s] creation objet [%d] Objet->Presentation Inconnu",Modele_Objet, Texte, Modele_Objet_Parent);
		}
		Objet->Afficher = TRUE;
	}
	return Objet;
}


void Force_Objet_Repertoire_Liste (struct Struct_Modele_Objet *Objet, guint ID_Reseau)
{
	struct Struct_Liste_Reseau *Reseau = NULL;
	GtkTreeModel *model = NULL;

	ERROR_if (Objet == NULL);
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau);
	if (Objet->Afficher) {
		if (Objet->Presentation == LISTE) {
		
			model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
			gtk_tree_store_set (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne, COL_IS_DIRECTORY_LIST, TRUE, -1);
		}
	}
}
