/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gtk/gtk.h>
#include "Objet.h"
#include "Reseau.h"
#include "Root_Interface.h"
#include "Wizard_Interface.h"
#include "Combo.h"
#include "Debug.h"
#include "Equipement_Port.h"
#include "Equipement_Historique.h"
#include "Modules.h"
#include "Commun.h"
#include "Objet_Liste.h"
#include "Animation.h"
#include "Snmp.h"
#include "Settings_Signature.h"
#include "Mem.h"
#include "Win32.h"

extern struct Struct_Modele_Objet Liste_Modele_Objet[];
extern struct Struct_Combo_Liste Liste_ComboTrueFalse[];

void Action_Test_Favoris (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;

	ERROR_if (pointer == NULL);
	Objet->Favoris = !Objet->Favoris;
}


void Action_Raffraichir_Equipement (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Liste_Reseau *Reseau = NULL;
	struct Struct_Equipement *Equipement = NULL;
	struct struct_Demande_Rafraichir_Equipement Message;

	ERROR_if (pointer == NULL);
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
	Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
	if (!Equipement->Rafraichir_Equipement) {
		Equipement->Rafraichir_Equipement = TRUE;
		Active_Rachaichissment_Objet (Objet, Reseau);
	
		bzero (&Message, sizeof (struct struct_Demande_Rafraichir_Equipement));
		Message.ID_Reseau = Objet->ID_Reseau;
		memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Communication_Envoie_Donnee (Reseau->Pid_Agent, DEMANDE_RAFRAICHIR_EQUIPEMENT, (gpointer *) & Message, sizeof (Message), Reseau);
	}
}


void Notification_Port (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Port *Port_Equipement = NULL;
	struct Struct_Liste_Reseau *Reseau = NULL;
	struct struct_Demande_Notication_Critique_Etat_Port Message;
	struct struct_Annulation_Notification_Etat_Port Message_Annulation;

	ERROR_if (pointer == NULL);
	Port_Equipement = (struct Struct_Port *) Objet->Pointeur_Attacher;
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
	if (gtk_toggle_tool_button_get_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Notification))) {
		Objet->Notification_En_Cours = TRUE;
		Port_Equipement->Notification_En_Cours = TRUE;
		bzero (&Message, sizeof (struct struct_Demande_Notication_Critique_Etat_Port));
		Message.ID_Reseau = Objet->ID_Reseau;
		memcpy (Message.ID_Equipement, Equipement_Selectionner->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Message.Num_Port = Port_Equipement->Num_Port;
		Communication_Envoie_Donnee (Reseau->Pid_Agent, DEMANDE_NOTIFICATION_CRITIQUE_ETAT_PORT, (gpointer *) & Message, sizeof (Message), Reseau);
	}
	else {

		if (Port_Equipement->Alert_notification)
			Reseau->GList_Test_Etat = Supprime_Dans_Liste_Objets (Reseau->GList_Test_Etat, Objet, TRUE);
		if (Port_Equipement->Etat_Port == OUVERT) {
			Affiche_Icone_Defaut_Objet_liste (Objet, Reseau);
			Change_Couleur_Noir_Texte_liste (Objet, Reseau);
		}
		else {
			Affiche_Icone_Defaut_Griser_Objet_liste (Objet, Reseau);
			Change_Couleur_Gris_Texte_liste (Objet, Reseau);
		}
		Objet->Notification_En_Cours = FALSE;
		Port_Equipement->Notification_En_Cours = FALSE;
		Port_Equipement->Alert_notification = FALSE;
		bzero (&Message_Annulation, sizeof (struct struct_Annulation_Notification_Etat_Port));
		Message_Annulation.ID_Reseau = Objet->ID_Reseau;
		memcpy (Message_Annulation.ID_Equipement, Equipement_Selectionner->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Message_Annulation.Num_Port = Port_Equipement->Num_Port;
		Communication_Envoie_Donnee (Reseau->Pid_Agent, ANNULATION_NOTIFICATION_ETAT_PORT, (gpointer *) & Message_Annulation, sizeof (Message_Annulation), Reseau);
	}
}


void Notification_Equipement (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Modele_Objet *Objet_Liste_Par_Ip,*Objet_Liste_Par_Type;
	struct Struct_Equipement *Equipement = NULL;
	struct Struct_Liste_Reseau *Reseau = NULL;
	GtkTreeModel *model = NULL;
	struct struct_Demande_Notication_Critique_Etat_Equipement Message;
	struct struct_Annulation_Notification_Etat_Equipement Message_Annulation;
	gint      Position_Glist;

	ERROR_if (pointer == NULL);
	Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
	if (Equipement->ID_Equipement[6] == 0) {
		Modification_Toggle_En_Cours = TRUE;
		gtk_toggle_tool_button_set_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Notification), FALSE);
		Modification_Toggle_En_Cours = FALSE;
		return;
	}

	Objet_Liste_Par_Ip = Equipement->Objet_Liste_Par_Ip;
	Objet_Liste_Par_Type = Equipement->Objet_Liste_Par_Type;

	if (gtk_toggle_tool_button_get_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Notification))) {
		Objet_Liste_Par_Ip->Notification_En_Cours = TRUE;
		Objet_Liste_Par_Type->Notification_En_Cours = TRUE;
		Equipement->Notification_En_Cours = TRUE;
		bzero (&Message, sizeof (struct struct_Demande_Notication_Critique_Etat_Equipement));
		Message.ID_Reseau = Objet->ID_Reseau;
		memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
		Communication_Envoie_Donnee (Reseau->Pid_Agent, DEMANDE_NOTIFICATION_CRITIQUE_ETAT_EQUIPEMENT, (gpointer *) & Message, sizeof (Message), Reseau);
		model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet_Liste_Par_Ip, Reseau)));
		gtk_tree_store_set (GTK_TREE_STORE (model), &Objet_Liste_Par_Ip->ID_Arbre_Ligne, NOTIFICATION, "YES", -1);
	}
	else {
		Objet_Liste_Par_Ip->Notification_En_Cours = FALSE;
		Objet_Liste_Par_Type->Notification_En_Cours = FALSE;
		Equipement->Notification_En_Cours = FALSE;
		Equipement->Alert_Notification_En_Cours = FALSE;
		bzero (&Message_Annulation, sizeof (struct struct_Annulation_Notification_Etat_Equipement));
		Message_Annulation.ID_Reseau = Objet->ID_Reseau;
		memcpy (Message_Annulation.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
		Communication_Envoie_Donnee (Reseau->Pid_Agent, ANNULATION_NOTIFICATION_ETAT_EQUIPEMENT, (gpointer *) & Message_Annulation, sizeof (Message_Annulation), Reseau);
		if ((Position_Glist = Recupere_Rang_Objet_Dans_Une_Liste (Reseau->GList_Test_Etat, Objet)) != -1)
			Reseau->GList_Test_Etat = Supprime_Dans_Liste_Objets (Reseau->GList_Test_Etat, Objet, TRUE);
		if (Equipement->Equipement_Allumer) {
			Affiche_Icone_Defaut_Objet_liste (Objet, Reseau);
			Change_Couleur_Noir_Texte_liste (Objet, Reseau);
		}
		else {
			Affiche_Icone_Defaut_Griser_Objet_liste (Objet, Reseau);
			Change_Couleur_Gris_Texte_liste (Objet, Reseau);
		}
		model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet_Liste_Par_Ip, Reseau)));
		gtk_tree_store_set (GTK_TREE_STORE (model), &Objet_Liste_Par_Ip->ID_Arbre_Ligne, NOTIFICATION, "", -1);
	}
}


void Action_Test_Notification (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;

	ERROR_if (pointer == NULL);
	Objet->Notification_En_Cours = !Objet->Notification_En_Cours;
}


void Action_Test_Click (gpointer * pointer)
{
	struct Struct_Liste_Reseau *Reseau = NULL;

	ERROR_if (pointer == NULL);
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
}


void Action_Selection_Equipement_Inconnu (gpointer * pointer)
{
	ERROR_if (pointer == NULL);
	Action_Selection_Equipement (pointer);


	/*Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
	if ((Equipement->Nb_Port_Ouvert != 0) || (Equipement->Nb_Port_Fermer != 0)){
		Wizard_Interface_Add_Fingerprinting_Page1();
		gtk_widget_show (window_wizard);
	}*/
}

void Action_Selection_Type_OU_Domaine (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;

	ERROR_if (pointer == NULL);
	if (Equipement_Selectionner!=NULL){
	
	
		Destruction_Modules(TRUE);
	

	
		Equipement_Selectionner = NULL;
		gtk_notebook_set_show_tabs (GTK_NOTEBOOK (notebook_Info), FALSE);
		gtk_notebook_set_page(GTK_NOTEBOOK (notebook_Info),0);
		gtk_widget_set_sensitive (combobox_liste_Modules, FALSE);
		gtk_widget_set_sensitive (button_Refresh, FALSE);
		gtk_widget_hide (vbox_Milieu);
	
	
	
	}
	Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO);
	Objet_Equipement_Selectionner = Objet;
	Ajouter_Nouvelle_Objet (INFO_TYPE_PARENT, NULL, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
	Ajouter_Nouvelle_Objet (INFO_PARENT_NB_FILS, NULL, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
}

void Action_Selection_Equipement (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Liste_Reseau *Reseau = NULL;
	struct Struct_Equipement *Equipement = NULL;
	struct Struct_Signature *Signature = NULL;
	struct Struct_Historique *Historique = NULL;
	struct Struct_Modele_Objet *Objet_Text = NULL;
	gfloat user,system,nice,idle;
	gfloat free,total,used,cached;
	gint      i, Nb_Objet_Liste;
	gchar     Texte_Registration_Netbios[100];
	gchar     *Chaine_Historique = NULL;

	ERROR_if (pointer == NULL);


	if (Equipement_Selectionner!=(struct Struct_Equipement *) Objet->Pointeur_Attacher)
		Destruction_Modules(TRUE);

	Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
	Equipement_Selectionner = Equipement;

	if (Objet_Equipement_Selectionner != Objet) {
		Objet_Equipement_Selectionner = Objet;
		Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
		if (Reseau->Etat_Connection != ETAT_CONNECTED)
			return;
		gtk_widget_show (notebook_Info);
		gtk_widget_show (vbox_Milieu);
		if (Equipement->ID_Equipement[6] != 0){
			gtk_widget_set_sensitive (combobox_liste_Modules, !Equipement->Post_Affichage);
			gtk_widget_set_sensitive (button_Refresh, FALSE);
			gtk_widget_set_sensitive (button_Erase, FALSE);
		}
		else {
			gtk_widget_set_sensitive (combobox_liste_Modules, TRUE);
			gtk_widget_set_sensitive (button_Refresh, FALSE);
			gtk_widget_set_sensitive (button_Erase, TRUE);
		}

		if ((Equipement->Intrus) && (!Equipement->Post_Affichage)){
			Equipement->Intrus = FALSE;
			Reseau->GList_Alerte = Supprime_Dans_Liste_Objets (Reseau->GList_Alerte, Equipement->Objet_Liste_Par_Type, TRUE);
			Reseau->GList_Alerte = Supprime_Dans_Liste_Objets (Reseau->GList_Alerte, Equipement->Objet_Liste_Par_Ip, TRUE);
		
			Affiche_Icone_Defaut_Objet_liste (Equipement->Objet_Liste_Par_Type, Reseau);
			Change_Couleur_Noir_Texte_liste (Equipement->Objet_Liste_Par_Type, Reseau);
			Change_Bold_Texte_Liste (Equipement->Objet_Liste_Par_Type, FALSE, Reseau);
		
			Affiche_Icone_Defaut_Objet_liste (Equipement->Objet_Liste_Par_Ip, Reseau);
			Change_Couleur_Noir_Texte_liste (Equipement->Objet_Liste_Par_Ip, Reseau);
			Change_Bold_Texte_Liste (Equipement->Objet_Liste_Par_Ip, FALSE, Reseau);
		}
	
		Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO);
		Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_CONFIG);
		Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO_AUTRE);
		Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO_SNMP);
		Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO_INVENTAIRE);
		Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO_HISTORIQUE);
	
		gtk_notebook_set_page(GTK_NOTEBOOK (notebook_Info),Page_Notebook_Info);
	
		gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_BASE));
		gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_CONFIG));
		gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_HISTORIQUE));
		gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_INVENTAIRE));
		gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_AUTRE));
	
		gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_SNMP));
		gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_SOFT));
		gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_TCP));
		gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_ROUTE));
		gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_ARP));
		gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_PERIPHERIQUE));
		gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_SERVICE));
		gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_INTERFACE));
	
		gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_DEBUG_DAEMON));
	
	
		gtk_widget_set_sensitive ((GtkWidget *)image_notebook_Info_Software,FALSE);
		gtk_widget_set_sensitive ((GtkWidget *)image_notebook_Info_Tcp,FALSE);
		gtk_widget_set_sensitive ((GtkWidget *)image_notebook_Info_Route,FALSE);
		gtk_widget_set_sensitive ((GtkWidget *)image_notebook_Info_Arp,FALSE);
		gtk_widget_set_sensitive ((GtkWidget *)image_notebook_Info_Peripherique,FALSE);
		gtk_widget_set_sensitive ((GtkWidget *)image_notebook_Info_Service,FALSE);
		gtk_widget_set_sensitive ((GtkWidget *)image_notebook_Info_Interface,FALSE);
	
	
		gtk_widget_set_sensitive (treeview_Info_Software,FALSE);
		gtk_widget_set_sensitive (treeview_Info_Tcp,FALSE);
		gtk_widget_set_sensitive (treeview_Info_Route,FALSE);
		gtk_widget_set_sensitive (treeview_Info_Arp,FALSE);
		gtk_widget_set_sensitive (treeview_Info_Peripherique,FALSE);
		gtk_widget_set_sensitive (treeview_Info_Service,FALSE);
		gtk_widget_set_sensitive (treeview_Info_Interface,FALSE);
	
		gtk_notebook_set_show_tabs (GTK_NOTEBOOK (notebook_Info), TRUE);

		Objet_Text = Ajouter_Nouvelle_Objet (INFO_ADRESSE_IP, NULL, (gpointer *) Equipement->Adresse_Ip_Char, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		if (!Equipement->Equipement_Allumer) {
			Affiche_Icone_Defaut_Griser_Objet_liste (Objet_Text, Reseau);
			Change_Couleur_Gris_Texte_liste (Objet_Text, Reseau);
		}
		Objet_Text = Ajouter_Nouvelle_Objet (INFO_ADRESSE_MAC, NULL, (gpointer *) Equipement->Adresse_MAC_Char, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		if (!Equipement->Equipement_Allumer) {
			Affiche_Icone_Defaut_Griser_Objet_liste (Objet_Text, Reseau);
			Change_Couleur_Gris_Texte_liste (Objet_Text, Reseau);
		}

		if (!Equipement->Post_Affichage){
		gtk_widget_show (vbox_Milieu);
		gtk_notebook_set_show_tabs (GTK_NOTEBOOK (notebook_Info), TRUE);

		Objet_Text = Ajouter_Nouvelle_Objet (INFO_FOURNISSEUR, NULL, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		if (!Equipement->Equipement_Allumer) {
			Affiche_Icone_Defaut_Griser_Objet_liste (Objet_Text, Reseau);
			Change_Couleur_Gris_Texte_liste (Objet_Text, Reseau);
		}

		Objet_Text = Ajouter_Nouvelle_Objet (INFO_OS_MD5_W, NULL, NULL, NULL, 0, INFO_OS, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);

		Signature = (struct Struct_Signature *) Equipement->Signature;
		if (Signature != NULL) {
			if (Signature->Signature_Pere != NULL)
				Objet_Text = Ajouter_Nouvelle_Objet (INFO_OS_GROUP, NULL, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		}

		if (Equipement->Nom_DNS_Complet != NULL)
			Ajouter_Nouvelle_Objet (INFO_NOM_DNS, NULL, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);

		if (Equipement->GateWay)
			Ajouter_Nouvelle_Objet (INFO_GATEWAY, NULL, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		if (Equipement->Routage)
			Ajouter_Nouvelle_Objet (INFO_ROUTAGE, NULL, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);

	
		if (Equipement->Snmp_Ouvert){
			if (strlen (Equipement->Snmp.Uptime) != 0)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_UPTIME, NULL, (gpointer *) & Equipement->Snmp.Uptime, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			if ((Equipement->Snmp.Cpu_Raw_User+Equipement->Snmp.Cpu_Raw_Nice+Equipement->Snmp.Cpu_Raw_System) > 0){
				user = Equipement->Snmp.Cpu_Raw_User;
    			nice =  Equipement->Snmp.Cpu_Raw_Nice;
				system = Equipement->Snmp.Cpu_Raw_System;
				idle = Equipement->Snmp.Cpu_Raw_Idle;
				total = user + nice + system + idle;
			
			}
			if ((Equipement->Snmp.Mem_Total_Real) != -1){
				free =  Equipement->Snmp.Mem_Available_Real;
				total = Equipement->Snmp.Mem_Total_Real;
				cached = Equipement->Snmp.Mem_Cached;
				used =  total - free - cached;
			
			}
		}

		Ajouter_Nouvelle_Objet (INFO_PORTS, NULL, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
		Ajouter_Nouvelle_Objet (INFO_PORTS_OUVERT, NULL, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
		Ajouter_Nouvelle_Objet (INFO_PORTS_FERMER, NULL, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
		Ajouter_Nouvelle_Objet (INFO_PORTS_FIREWALLED, NULL, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);

		if (!Equipement->Agent_AutoScan)
			Ajouter_Nouvelle_Objet (INFO_PORTS_UDP_OPEN_FILTERED, NULL, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);


	
		Ajouter_Nouvelle_Objet (INFO_CONTACT_ADMIN, NULL, (gpointer *) &Equipement->Contact_Admin, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_CONFIG);
	
	
		if (!Equipement->Agent_AutoScan)
			Ajouter_Nouvelle_Objet (INFO_ALIAS, NULL, (gpointer *) &Equipement->Alias, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_CONFIG);
		Ajouter_Nouvelle_Objet (INFO_DEFAULT_SSH_USER, NULL, (gpointer *) &Equipement->User_SSH_Default, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_CONFIG);
		Ajouter_Nouvelle_Objet (INFO_SSH_USER, NULL, (gpointer *) &Equipement->User_SSH, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_CONFIG);
		Ajouter_Nouvelle_Objet (INFO_DEFAULT_PASSWORD_VNC, NULL, (gpointer *) &Equipement->Password_VNC_Default, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_CONFIG);
		Ajouter_Nouvelle_Objet (INFO_PASSWORD_VNC, NULL, (gpointer *) &Equipement->password_vnc, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_CONFIG);
		Ajouter_Nouvelle_Objet (INFO_VIEW_ONLY_VNC, NULL, (gpointer *) &Equipement->View_Only_VNC, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_CONFIG);


#ifndef         __WINDOWS_ENABLE
		Ajouter_Nouvelle_Objet (INFO_DERNIER_CHANGEMENT, NULL, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
#endif
		if (Equipement->Temps_Scan_Port!=-1)
			Ajouter_Nouvelle_Objet (INFO_TEMPS_SCAN_PORT, NULL, NULL, NULL, 0, INFO_TEMPS_SCAN_COMPLET, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
		if (Equipement->Temps_Scan_Port_Udp!=-1)
			Ajouter_Nouvelle_Objet (INFO_TEMPS_SCAN_PORT_UDP, NULL, NULL, NULL, 0, INFO_TEMPS_SCAN_COMPLET, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
		if (Equipement->Temps_Scan_Signature!=-1)
			Ajouter_Nouvelle_Objet (INFO_TEMPS_SCAN_SIGNATURE, NULL, NULL, NULL, 0, INFO_TEMPS_SCAN_COMPLET, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
		if (Equipement->Temps_Scan_Service_Ftp!=-1)
			Ajouter_Nouvelle_Objet (INFO_TEMPS_SCAN_SERVICE_FTP, NULL, NULL, NULL, 0, INFO_TEMPS_SCAN_COMPLET, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
		if (Equipement->Temps_Scan_Service_Http!=-1)
			Ajouter_Nouvelle_Objet (INFO_TEMPS_SCAN_SERVICE_HTTP, NULL, NULL, NULL, 0, INFO_TEMPS_SCAN_COMPLET, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
		if (Equipement->Temps_Scan_Service_Imap!=-1)
			Ajouter_Nouvelle_Objet (INFO_TEMPS_SCAN_SERVICE_IMAP, NULL, NULL, NULL, 0, INFO_TEMPS_SCAN_COMPLET, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
		if (Equipement->Temps_Scan_Service_Smtp!=-1)
			Ajouter_Nouvelle_Objet (INFO_TEMPS_SCAN_SERVICE_SMTP, NULL, NULL, NULL,0,  INFO_TEMPS_SCAN_COMPLET, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
		if (Equipement->Temps_Scan_Service_Ssh!=-1)
			Ajouter_Nouvelle_Objet (INFO_TEMPS_SCAN_SERVICE_SSH, NULL, NULL, NULL, 0, INFO_TEMPS_SCAN_COMPLET, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
		if (Equipement->Temps_Scan_Service_Telnet!=-1)
			Ajouter_Nouvelle_Objet (INFO_TEMPS_SCAN_SERVICE_TELNET, NULL, NULL, NULL, 0, INFO_TEMPS_SCAN_COMPLET, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
		if (Equipement->Temps_Scan_Snmp!=-1)
			Ajouter_Nouvelle_Objet (INFO_TEMPS_SCAN_SNMP, NULL, NULL, NULL, 0, INFO_TEMPS_SCAN_COMPLET, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
		if (Equipement->Temps_Resolv_DNS!=-1)
			Ajouter_Nouvelle_Objet (INFO_TEMPS_SCAN_DNS, NULL, NULL, NULL, 0, INFO_TEMPS_SCAN_COMPLET, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);


		if (strlen ((char *) Equipement->Smb.HostName) != 0)
			Ajouter_Nouvelle_Objet (INFO_NOM_HOTE, NULL, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
		if (strlen ((char *) Equipement->Smb.DomainName) != 0) {
			Ajouter_Nouvelle_Objet (INFO_NOM_UTILISATEUR, NULL, NULL, NULL, 0, INFO_NOM_DOMAINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
			i = 0;
			while ((i < NUM_MAX_REGISTRATION) && (Equipement->Smb.Smb_Registration[i].Type != 0)) {
				sprintf (Texte_Registration_Netbios, "%s <%02X>", Equipement->Smb.Smb_Registration[i].Name, Equipement->Smb.Smb_Registration[i].Numero);
				if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_GROUP)
					strcat (Texte_Registration_Netbios, "GROUP ");
				if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_UNIQUE)
					strcat (Texte_Registration_Netbios, "UNIQUE ");
				switch (Equipement->Smb.Smb_Registration[i].Numero) {
				    case 0x00:
					    if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_UNIQUE)
						    strcat (Texte_Registration_Netbios, " Workstation Service");
					    else
						    strcat (Texte_Registration_Netbios, " Domain Name");
					    break;
				    case 0x01:
					    if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_UNIQUE)
						    strcat (Texte_Registration_Netbios, " Messenger Service");
					    else
						    strcat (Texte_Registration_Netbios, " Master Browser");
					    break;
				    case 0x03:
					    strcat (Texte_Registration_Netbios, " Messenger Service");
					    break;
				    case 0x06:
					    strcat (Texte_Registration_Netbios, " RAS Server Service");
					    break;
				    case 0x1b:
					    strcat (Texte_Registration_Netbios, " Domain Master Browser");
					    break;
				    case 0x1c:
					    strcat (Texte_Registration_Netbios, " Domain Controllers");
					    break;
				    case 0x1d:
					    strcat (Texte_Registration_Netbios, " Master Browser");
					    break;
				    case 0x1e:
					    if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_GROUP)
						    strcat (Texte_Registration_Netbios, " Browser Service Elections");
					    break;
				    case 0x1F:
					    strcat (Texte_Registration_Netbios, " NetDDE Service");
					    break;
				    case 0x20:
					    strcat (Texte_Registration_Netbios, " File Server Service");
					    break;
				    case 0x21:
					    strcat (Texte_Registration_Netbios, " RAS Client Service");
					    break;
				    case 0x22:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange Interchange(MSMail Connector)");
					    break;
				    case 0x23:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange Store");
					    break;
				    case 0x24:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange Directory");
					    break;
				    case 0x30:
					    strcat (Texte_Registration_Netbios, " Modem Sharing Server Service");
					    break;
				    case 0x31:
					    strcat (Texte_Registration_Netbios, " Modem Sharing Client Service");
					    break;
				    case 0x42:
					    strcat (Texte_Registration_Netbios, " Mcaffee Anti-Virus");
					    break;
				    case 0x43:
					    strcat (Texte_Registration_Netbios, " SMS Clients Remote Control");
					    break;
				    case 0x44:
					    strcat (Texte_Registration_Netbios, " SMS Administrators Remote Control Tool");
					    break;
				    case 0x45:
					    strcat (Texte_Registration_Netbios, " SMS Clients Remote Chat");
					    break;
				    case 0x46:
					    strcat (Texte_Registration_Netbios, " SMS Clients Remote Transfer");
					    break;
				    case 0x4C:
					    strcat (Texte_Registration_Netbios, " DEC Pathworks TCPIP service on Windows NT");
					    break;
				    case 0x52:
					    strcat (Texte_Registration_Netbios, " DEC Pathworks TCPIP service on Windows NT");
					    break;
				    case 0x6a:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange IMC");
					    break;
				    case 0x87:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange MTA");
					    break;
				    case 0xbe:
					    strcat (Texte_Registration_Netbios, " Network Monitor Agent");
					    break;
				    case 0xbf:
					    strcat (Texte_Registration_Netbios, " Network Monitor Application");
					    break;
				    default:
					    strcat (Texte_Registration_Netbios, " Unknown");
					    break;
				}
				Ajouter_Nouvelle_Objet (INFO_NETBIOS_ENFANT, Texte_Registration_Netbios, NULL, NULL, 0, INFO_NETBIOS, NULL, INFO_NOM_DOMAINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_AUTRE);
				i++;
			}
		}

	
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_CONTACT, NULL, (gpointer *) & Equipement->Contact, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_INVENTAIRE);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_TEL_CONTACT, NULL, (gpointer *) & Equipement->Tel_Contact, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_INVENTAIRE);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_LOCALISATION, NULL, (gpointer *) & Equipement->Localisation, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_INVENTAIRE);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE, NULL, (gpointer *) & Equipement->Num_Serie, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_INVENTAIRE);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE_ECRAN, NULL, (gpointer *) & Equipement->Num_Serie_Ecran, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_INVENTAIRE);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE_IMPRIMANTE, NULL, (gpointer *) & Equipement->Num_Serie_Imprimante, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_INVENTAIRE);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE_OS, NULL, (gpointer *) & Equipement->Num_Serie_OS, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_INVENTAIRE);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE_SUITE_OFFICE, NULL, (gpointer *) & Equipement->Num_Serie_Office_Suite, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_INVENTAIRE);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_PROCESSEUR, NULL, (gpointer *) & Equipement->Processeur, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_INVENTAIRE);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_MEMOIRE, NULL, (gpointer *) & Equipement->Memoire, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_INVENTAIRE);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_DISQUE, NULL, (gpointer *) & Equipement->Disque, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_INVENTAIRE);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NOTES, NULL, (gpointer *) & Equipement->Notes, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_INVENTAIRE);



	
		if (Equipement->Snmp_Ouvert) {
			gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_SNMP));
		
			if (strlen (Equipement->Snmp.System_Name) != 0)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_NAME, NULL, (gpointer *) & Equipement->Snmp.System_Name, NULL, 0, PERE_RACINE, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (strlen (Equipement->Snmp.Description) != 0)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_DESCRIPTION, NULL, (gpointer *) & Equipement->Snmp.Description, NULL, 0, PERE_RACINE, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (strlen (Equipement->Snmp.Contact) != 0)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_CONTACT, NULL, (gpointer *) & Equipement->Snmp.Contact, NULL, 0, PERE_RACINE, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (strlen (Equipement->Snmp.Location) != 0)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_LOCATION, NULL, (gpointer *) & Equipement->Snmp.Location, NULL, 0, PERE_RACINE, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (strlen (Equipement->Snmp.Uptime) != 0)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_UPTIME, NULL, (gpointer *) & Equipement->Snmp.Uptime, NULL, 0, PERE_RACINE, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Ram != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_RAM, NULL, (gpointer *) Equipement->Snmp.Ram, NULL, 0, PERE_RACINE, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
		
			if (strlen (Equipement->Snmp.Ip_Forwarding) != 0)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_FORWARDING, NULL, (gpointer *) & Equipement->Snmp.Ip_Forwarding, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Default_TTL != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_TTL, NULL, (gpointer *) Equipement->Snmp.Default_TTL, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Reassembly_Timeout != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_REASS_TIMEOUT, NULL, (gpointer *) Equipement->Snmp.Reassembly_Timeout, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Need_To_Be_Reassembled != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_NEED_REASS, NULL, (gpointer *) Equipement->Snmp.Need_To_Be_Reassembled, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Reassembled != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_RE_ASSEM, NULL, (gpointer *) Equipement->Snmp.Reassembled, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Reassembly_Failures != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_REAS_FAIL, NULL, (gpointer *) Equipement->Snmp.Reassembly_Failures, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Successfully_Fragmented != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_SUCCESS_FRAG, NULL, (gpointer *) Equipement->Snmp.Successfully_Fragmented, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Fragmentation_Failures != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_FRAG_FAIL, NULL, (gpointer *) Equipement->Snmp.Fragmentation_Failures, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Created_Fragments != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_CREAT_FRAG, NULL, (gpointer *) Equipement->Snmp.Created_Fragments, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Discarded_Routing_Entries != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_DISC_ROUT, NULL, (gpointer *) Equipement->Snmp.Discarded_Routing_Entries, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
		
			if (Equipement->Snmp.All != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INPUT_ALL, NULL, (gpointer *) Equipement->Snmp.All, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Forwarded != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INPUT_FORWARDED, NULL, (gpointer *) Equipement->Snmp.Forwarded, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Delivered != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INPUT_DELIVERED, NULL, (gpointer *) Equipement->Snmp.Delivered, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Header_Errors != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INPUT_HEADER, NULL, (gpointer *) Equipement->Snmp.Header_Errors, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Address_Errors != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INPUT_ADDRESS, NULL, (gpointer *) Equipement->Snmp.Address_Errors, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Unknown_Protocol != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INPUT_PROTOCOL, NULL, (gpointer *) Equipement->Snmp.Unknown_Protocol, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Input_Buffer_Errors != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INPUT_BUFFER, NULL, (gpointer *) Equipement->Snmp.Input_Buffer_Errors, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_INPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
		
			if (Equipement->Snmp.Requested != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_OUPUT_REQUESTED, NULL, (gpointer *) Equipement->Snmp.Requested, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_OUPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Output_Buffer_Errors != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_OUPUT_BUFFER, NULL, (gpointer *) Equipement->Snmp.Output_Buffer_Errors, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_OUPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Not_Routed != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_OUPUT_ROUTED, NULL, (gpointer *) Equipement->Snmp.Not_Routed, NULL, 0, INFO_SNMP_NETWORK_TCPIP_IP_OUPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);

		
			if (Equipement->Snmp.Mem_Total_Swap != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_MEM_TOTAL_SWAP, NULL, (gpointer *) Equipement->Snmp.Mem_Total_Swap, NULL, 0, INFO_SNMP_MEM, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Mem_Available_Swap != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_MEM_AVAILABLE_SWAP, NULL, (gpointer *) Equipement->Snmp.Mem_Available_Swap, NULL, 0, INFO_SNMP_MEM, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Mem_Total_Real != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_MEM_TOTAL_REAL, NULL, (gpointer *) Equipement->Snmp.Mem_Total_Real, NULL, 0, INFO_SNMP_MEM, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Mem_Available_Real != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_MEM_AVAILABLE_REAL, NULL, (gpointer *) Equipement->Snmp.Mem_Available_Real, NULL, 0, INFO_SNMP_MEM, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Mem_Total_Free != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_MEM_TOTAL_FREE, NULL, (gpointer *) Equipement->Snmp.Mem_Total_Free, NULL, 0, INFO_SNMP_MEM, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Mem_Shared != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_MEM_SHARED, NULL, (gpointer *) Equipement->Snmp.Mem_Shared, NULL, 0, INFO_SNMP_MEM, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Mem_Buffer != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_MEM_BUFFER, NULL, (gpointer *) Equipement->Snmp.Mem_Buffer, NULL, 0, INFO_SNMP_MEM, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Mem_Cached != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_MEM_CACHED, NULL, (gpointer *) Equipement->Snmp.Mem_Cached, NULL, 0, INFO_SNMP_MEM, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Mem_Swap_Error != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_MEM_SWAP_ERROR, NULL, (gpointer *) Equipement->Snmp.Mem_Swap_Error, NULL, 0, INFO_SNMP_MEM, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (strlen(Equipement->Snmp.Mem_Swap_Error_Message) != 0)
				Ajouter_Nouvelle_Objet (INFO_SNMP_MEM_SWAP_ERROR_MSG, NULL, (gpointer *) Equipement->Snmp.Mem_Swap_Error_Message, NULL, 0, INFO_SNMP_MEM, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
		
			if (Equipement->Snmp.Cpu_Raw_User != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_CPU_RAW_USER, NULL, (gpointer *) Equipement->Snmp.Cpu_Raw_User, NULL, 0, INFO_SNMP_CPU, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Cpu_Raw_Nice != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_CPU_RAW_NICE, NULL, (gpointer *) Equipement->Snmp.Cpu_Raw_Nice, NULL, 0, INFO_SNMP_CPU, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Cpu_Raw_System != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_CPU_RAW_SYSTEM, NULL, (gpointer *) Equipement->Snmp.Cpu_Raw_System, NULL, 0, INFO_SNMP_CPU, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Cpu_Raw_Idle != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_CPU_RAW_IDLE, NULL, (gpointer *) Equipement->Snmp.Cpu_Raw_Idle, NULL, 0, INFO_SNMP_CPU, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Cpu_Raw_Wait != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_CPU_RAW_WAIT, NULL, (gpointer *) Equipement->Snmp.Cpu_Raw_Wait, NULL, 0, INFO_SNMP_CPU, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Cpu_Raw_Kernel != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_CPU_RAW_KERNEL, NULL, (gpointer *) Equipement->Snmp.Cpu_Raw_Kernel, NULL, 0, INFO_SNMP_CPU, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
			if (Equipement->Snmp.Cpu_Raw_Interrupt != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_CPU_RAW_INTERRUPT, NULL, (gpointer *) Equipement->Snmp.Cpu_Raw_Interrupt, NULL, 0, INFO_SNMP_CPU, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_SNMP);
		}

		if (Equipement->Glist_Snmp[SNMP_SOFTWARE] != NULL){
			Affiche_Liste_Snmp(SNMP_SOFTWARE,treeview_Info_Software);
			gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_SOFT));
		}
		if (Equipement->Glist_Snmp[SNMP_NETWORK_TCPIP_TCP_CONNECTIONS] != NULL){
			Affiche_Liste_Snmp(SNMP_NETWORK_TCPIP_TCP_CONNECTIONS,treeview_Info_Tcp);
			gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_TCP));
		}
		if (Equipement->Glist_Snmp[SNMP_NETWORK_ROUTES] != NULL){
			Affiche_Liste_Snmp(SNMP_NETWORK_ROUTES,treeview_Info_Route);
			gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_ROUTE));
		}
		if (Equipement->Glist_Snmp[SNMP_NETWORK_ARP] != NULL){
			Affiche_Liste_Snmp(SNMP_NETWORK_ARP,treeview_Info_Arp);
			gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_ARP));
		}
		if (Equipement->Glist_Snmp[SNMP_SYSTEM_DEVICE] != NULL){
			Affiche_Liste_Snmp(SNMP_SYSTEM_DEVICE,treeview_Info_Peripherique);
			gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_PERIPHERIQUE));
		}
		if (Equipement->Glist_Snmp[SNMP_SYSTEM_SERVICE] != NULL){
			Affiche_Liste_Snmp(SNMP_SYSTEM_SERVICE,treeview_Info_Service);
			gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_SERVICE));
		}
		if (Equipement->Glist_Snmp[SNMP_NETWORK_INTERFACES_BASIC] != NULL){
			Affiche_Liste_Snmp(SNMP_NETWORK_INTERFACES_BASIC,treeview_Info_Interface);
			gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_INTERFACE));
		}
	
		Nb_Objet_Liste = g_list_length (Equipement->GList_Historique);
		for (i = 0; i < Nb_Objet_Liste; i++) {
			Historique = g_list_nth_data (Equipement->GList_Historique, i);
/*#ifndef         __WINDOWS_ENABLE
			ctime_r (&Historique->Date, Date);
#else
			strcpy(Date,"....");  
#endif
			Date[strlen (Date) - 1] = '\0';
*/
			Chaine_Historique = Historique->Historique;//g_strdup_printf ("%s - %s", Date, Historique->Historique);
			switch (Historique->Niveau_Historique) {
			    case HISTORIQUE_INFO:
				    Ajouter_Nouvelle_Objet (INFO_HISTORIQUE_INFO, Chaine_Historique, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_HISTORIQUE);
				    break;
			    case HISTORIQUE_WARNING:
				    Ajouter_Nouvelle_Objet (INFO_HISTORIQUE_WARNING, Chaine_Historique, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_HISTORIQUE);
				    break;
			    case HISTORIQUE_ALERTE:
				    Ajouter_Nouvelle_Objet (INFO_HISTORIQUE_ALERTE, Chaine_Historique, NULL, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO_HISTORIQUE);
				    break;
			    default:
				    DEBUG_ERROR("Type Historique Inconnu");
			}
		
		}

	
	
	
	
		if ((!Equipement->Rafraichir_Equipement) && (!Equipement->Post_Affichage) && (!Equipement->Agent_AutoScan) && (Equipement->ID_Equipement[6] != 0))
			Demande_Agent_Raffraichir_Tout_Equipement(Objet,Equipement,Reseau);
		if (Equipement->Agent_AutoScan)
				Demande_Stop_Agent_Raffraichir_Tout_Equipement(Reseau);
		if (Reseau->Etat_Connection != ETAT_CONNECTED)
			return;
		}
		else{
			gtk_widget_hide (vbox_Milieu);
			gtk_notebook_set_show_tabs(GTK_NOTEBOOK (notebook_Info), FALSE);
		}
	
		Efface_Combo (combobox_liste_Modules);
		creation_combo_milieu ();
	}
}



void Modification_Texte (gpointer * pointer, gchar * NewTexte,GtkTreeModel *model)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;

	ERROR_if (pointer == NULL);
	ERROR_if (NewTexte == NULL);
	DEBUG_INFO("Edit_Texte_Liste_Machine");
	if (Objet->Pointeur_Attacher == NULL)
		return;	

	MYFREE (*Objet->Pointeur_Attacher);
	if (strlen(NewTexte)>0) {
		*Objet->Pointeur_Attacher = g_strdup (NewTexte);
		if (!Objet->TextPassword)
			gtk_tree_store_set (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne, LISTE_TEXTE_EDITABLE, *Objet->Pointeur_Attacher, -1);
		else
			gtk_tree_store_set (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne, LISTE_TEXTE_EDITABLE, "-- The Password is defined --", -1);
	}
	else {
		*Objet->Pointeur_Attacher = NULL;
		gtk_tree_store_set (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne, LISTE_TEXTE_EDITABLE,"-- UNDEFINED --", -1);
	}

}

void Edit_Texte_Alias (gpointer * pointer, gchar * NewTexte,GtkTreeModel *model)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Equipement *Equipement = NULL;

	ERROR_if (pointer == NULL);
	Modification_Texte (Objet, NewTexte,model);
	Deplace_Equipement (Objet_Equipement_Selectionner, Reseau_Selectionner);
	Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	if (!Equipement->Equipement_Allumer) {
		Affiche_Icone_Defaut_Griser_Objet_liste (Objet_Equipement_Selectionner, Reseau_Selectionner);
		Change_Couleur_Gris_Texte_liste (Objet_Equipement_Selectionner, Reseau_Selectionner);
	}
}

void Edit_Texte_Liste_Machine (gpointer * pointer, gchar * NewTexte,GtkTreeModel *model)
{
	Modification_Texte (pointer, NewTexte,model);

}

void Edit_Boolean (gpointer * pointer, gchar * NewTexte,GtkTreeModel *model)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;

	ERROR_if (pointer == NULL);
	ERROR_if (NewTexte == NULL);
	if (Objet->Pointeur_Attacher == NULL)
		return;	

	if (strcmp(NewTexte,Liste_ComboTrueFalse[0].Chaine)==0)
		*Objet->Pointeur_Attacher = FALSE;
	else
		*Objet->Pointeur_Attacher = TRUE;
	gtk_tree_store_set (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne, LISTE_COMBOLIST, NewTexte, -1);
}

void Action_Click_Droit (gpointer * pointer, GdkEventButton * bev)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Liste_Reseau *Reseau = NULL;

	ERROR_if (pointer == NULL);
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
	Desactive_Rachaichissment_Objet (Objet, Reseau, TRUE);

}


void Efface_Toutes_Info_Equipement(){


	Destruction_Modules(TRUE);

	Equipement_Selectionner = NULL;
	Objet_Equipement_Selectionner = NULL;
	gtk_widget_set_sensitive (combobox_liste_Modules, FALSE);
	gtk_widget_set_sensitive (button_Refresh, FALSE);
	Modification_Toggle_En_Cours = TRUE;
	gtk_toggle_tool_button_set_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Notification), FALSE);
	gtk_widget_set_sensitive (toggletoolbutton_Notification, FALSE);
	Modification_Toggle_En_Cours = FALSE;
	Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO);
	Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO_AUTRE);
	Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO_SNMP);
	Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO_INVENTAIRE);
	Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO_HISTORIQUE);
	Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO_DEBUG_DAEMON);
	gtk_notebook_set_show_tabs (GTK_NOTEBOOK (notebook_Info), FALSE);
	gtk_notebook_set_page(GTK_NOTEBOOK (notebook_Info),0);

	gtk_widget_hide (vbox_Milieu);
}


void Switch_Liste_IP(){
	if (Reseau_Selectionner==NULL)
		return; 
	Efface_Toutes_Info_Equipement();
	if (Reseau_Selectionner->Mode_Liste_Detaille) {
		g_object_ref (Reseau_Selectionner->Liste_Equipement_IP);
		gtk_container_remove (GTK_CONTAINER (scrollwin_liste_equipement), Reseau_Selectionner->Liste_Equipement_IP);
		gtk_container_add (GTK_CONTAINER (scrollwin_liste_equipement), Reseau_Selectionner->Liste_Equipement_Type);
		gtk_widget_show (Reseau_Selectionner->Liste_Equipement_Type);
	}
	else {
		g_object_ref (Reseau_Selectionner->Liste_Equipement_Type);
		gtk_container_remove (GTK_CONTAINER (scrollwin_liste_equipement), Reseau_Selectionner->Liste_Equipement_Type);
		gtk_container_add (GTK_CONTAINER (scrollwin_liste_equipement), Reseau_Selectionner->Liste_Equipement_IP);
		gtk_widget_show (Reseau_Selectionner->Liste_Equipement_IP);
	}
	Reseau_Selectionner->Mode_Liste_Detaille = !Reseau_Selectionner->Mode_Liste_Detaille;
}



void Action_Switch_Mode_Detaille (gpointer * pointer, GdkEventButton * bev)
{
	ERROR_if (pointer == NULL);
	Switch_Liste_IP();
}
