/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gtk/gtk.h>
#include "Objet.h"
#include "Objet_Liste.h"
#include "Objet_Icone.h"
#include "Root_Interface.h"
#include "Declaration_Constante.h"
#include "Image.h"
#include "Settings_Port.h"
#include "Debug.h"
#include "Configuration.h"
#include "Equipement_Port.h"
#include "Mem.h"

void clicked_Bouton_Port_programme(GtkToolButton * toolbutton, gpointer user_data)
{	
	ERROR_if (user_data == NULL);
#ifdef         __SCRIPT_ENABLE
	struct Struct_Liste_Port *Port = (struct Struct_Liste_Port *) user_data;
	Execute_Programme_Externe (Port->Path, Port->Param,Equipement_Selectionner);
#endif
}

gboolean Selectionne_Icone (GtkWidget * widget, GdkEventButton * event, gpointer user_data)
{
	struct Struct_Modele_Objet *Objet = NULL;
	struct Struct_Port *Port = NULL;
	GtkTreeModel *model = NULL;
	GtkTreePath *path = NULL;
	gchar    *text = NULL,*Description  = NULL;
	gchar     Date[30];
	GtkTreeIter iter;
	gint      x, y;

	if (event->type == GDK_BUTTON_PRESS) {
		GdkEventButton *bev = (GdkEventButton *) event;

		model = gtk_icon_view_get_model (GTK_ICON_VIEW (widget));
		gdk_window_get_pointer (event->window, &x, &y, NULL);
		if ((path = gtk_icon_view_get_path_at_pos (GTK_ICON_VIEW (widget), x, y)) == NULL) {
			gtk_widget_hide (hbox_Icone_Liste_Port);
			return FALSE;
		}
		gtk_tree_model_get_iter (model, &iter, path);
		gtk_tree_model_get (model, &iter, POINTER_LIST, &Objet, -1);
		Objet_Selectionner = Objet;
		Modifie_Etat_Bouton (Objet);
		switch (bev->button) {
		    case 1:
				gtk_widget_show (hbox_Icone_Liste_Port);
				Port = (struct Struct_Port *) Objet->Pointeur_Attacher;
				text = g_strdup_printf ("Port : %d", Port->Num_Port);
				gtk_label_set_text (GTK_LABEL (label_Icone_Port_Info_Port), text);
				MYFREE (text);
				Description = Description_Du_Port(Port->Num_Port);
				if (Description == NULL)
					Description = "-----";
				text = g_strdup_printf ("Description :  %s", Description);
				gtk_label_set_text (GTK_LABEL (label_Icone_Port_Info_Description), text);
				MYFREE (text);
				
				Date[0] = '\0';
  				#ifndef         __WINDOWS_ENABLE   
				ctime_r ((const time_t *)&Port->Derniere_Modification_Etat_Port, Date);
				Date[strlen (Date) - 1] = '\0';
				#else   
				#endif     
				text = g_strdup_printf ("Last state change:  %s", Date);
				gtk_label_set_text (GTK_LABEL (label_Icone_Port_Info_Last_Change), text);
				MYFREE (text);
				Afficher_Icone_Program_Associe(Port->Num_Port);
			    break;
		    case 2:
			    break;
		    case 3:
			    break;
		}
	}
	return FALSE;
}

gint sort_func_Port_Liste (GtkTreeModel * model, GtkTreeIter * a, GtkTreeIter * b, gpointer user_data)
{
	struct Struct_Modele_Objet *ObjetA = NULL,*ObjetB = NULL;
	struct Struct_Port *PortA = NULL,*PortB = NULL;
	int       ret;

	gtk_tree_model_get (model, a, POINTER_LIST, &ObjetA, -1);
	gtk_tree_model_get (model, b, POINTER_LIST, &ObjetB, -1);
	PortA = (struct Struct_Port *) ObjetA->Pointeur_Attacher;
	PortB = (struct Struct_Port *) ObjetB->Pointeur_Attacher;

	if (PortA->Num_Port < PortB->Num_Port)
		ret = -1;
	else
		ret = 1;
	return ret;
}


GtkWidget *Create_Icone (gboolean TRIER, gboolean Bulle, gboolean DragDrop)
{
	GtkTreeModel *model = NULL;
	GtkWidget *view = NULL;
	GtkListStore *store = NULL;

	scrolledwindow_Icone_Liste = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Icone_Liste);
	gtk_container_add (GTK_CONTAINER (viewport_Modules), scrolledwindow_Icone_Liste);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Icone_Liste), GTK_POLICY_NEVER, GTK_POLICY_NEVER);

	viewport_Icone_Liste = gtk_viewport_new (NULL, NULL);
  	gtk_widget_show (viewport_Icone_Liste);
  	gtk_container_add (GTK_CONTAINER (scrolledwindow_Icone_Liste), viewport_Icone_Liste);

	vbox_Icone_Liste = gtk_vbox_new (FALSE, 0);
  	gtk_widget_show (vbox_Icone_Liste);
  	gtk_container_add (GTK_CONTAINER (viewport_Icone_Liste), vbox_Icone_Liste);

  	scrolledwindow_Icone_Liste_Port = gtk_scrolled_window_new (NULL, NULL);
  	gtk_widget_show (scrolledwindow_Icone_Liste_Port);
  	gtk_box_pack_start (GTK_BOX (vbox_Icone_Liste), scrolledwindow_Icone_Liste_Port, TRUE, TRUE, 0);
  	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Icone_Liste_Port), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	

	store = gtk_list_store_new (NUM_COLS_LIST_ICON, GDK_TYPE_PIXBUF, G_TYPE_STRING, G_TYPE_BOOLEAN, G_TYPE_POINTER, GDK_TYPE_COLOR, G_TYPE_INT, G_TYPE_BOOLEAN,GDK_TYPE_COLOR);
	if (TRIER) {
		gtk_tree_sortable_set_default_sort_func (GTK_TREE_SORTABLE (store), sort_func_Port_Liste, NULL, NULL);
		gtk_tree_sortable_set_sort_column_id (GTK_TREE_SORTABLE (store), GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID, GTK_SORT_ASCENDING);
	}
	model = GTK_TREE_MODEL (store);
	view = gtk_icon_view_new_with_model (model);
	gtk_icon_view_set_item_width (GTK_ICON_VIEW (view), Config_IconList_Icon_Width);
	gtk_widget_show (view);
	g_object_unref (model);	
	gtk_icon_view_set_text_column (GTK_ICON_VIEW (view), COL_TEXT_LIST);
	gtk_icon_view_set_pixbuf_column (GTK_ICON_VIEW (view), COL_ICON_LIST);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Icone_Liste_Port), view);
	
	

	hbox_Icone_Liste_Port = gtk_hbox_new (FALSE, 0);
  	gtk_box_pack_start (GTK_BOX (vbox_Icone_Liste), hbox_Icone_Liste_Port, FALSE, TRUE, 0);

  	vbox_Icone_Liste_Port_Info = gtk_vbox_new (FALSE, 0);
  	gtk_widget_show (vbox_Icone_Liste_Port_Info);
  	gtk_box_pack_start (GTK_BOX (hbox_Icone_Liste_Port), vbox_Icone_Liste_Port_Info, TRUE, TRUE, 0);

  	label_Icone_Port_Info_Port = gtk_label_new ("Port : --");
  	gtk_widget_show (label_Icone_Port_Info_Port);
	gtk_label_set_justify((GtkLabel *)label_Icone_Port_Info_Port,GTK_JUSTIFY_LEFT);
  	gtk_box_pack_start (GTK_BOX (vbox_Icone_Liste_Port_Info), label_Icone_Port_Info_Port, FALSE, FALSE, 0);

  	label_Icone_Port_Info_Description = gtk_label_new ("Description : -----------------------");
  	gtk_widget_show (label_Icone_Port_Info_Description);
	gtk_label_set_justify((GtkLabel *)label_Icone_Port_Info_Description,GTK_JUSTIFY_LEFT);
  	gtk_box_pack_start (GTK_BOX (vbox_Icone_Liste_Port_Info), label_Icone_Port_Info_Description, FALSE, FALSE, 0);

  	label_Icone_Port_Info_Last_Change = gtk_label_new ("Last state change: -----------------");
  	gtk_widget_show (label_Icone_Port_Info_Last_Change);
	gtk_label_set_justify((GtkLabel *)label_Icone_Port_Info_Last_Change,GTK_JUSTIFY_LEFT);
  	gtk_box_pack_start (GTK_BOX (vbox_Icone_Liste_Port_Info), label_Icone_Port_Info_Last_Change, FALSE, FALSE, 0);


  	toolbar_Icone_Liste_Port_Bouton = gtk_toolbar_new ();
  	gtk_widget_show (toolbar_Icone_Liste_Port_Bouton);
  	gtk_box_pack_start (GTK_BOX (hbox_Icone_Liste_Port), toolbar_Icone_Liste_Port_Bouton, FALSE, FALSE, 0);
  	gtk_toolbar_set_style (GTK_TOOLBAR (toolbar_Icone_Liste_Port_Bouton), GTK_TOOLBAR_BOTH);
  	gtk_toolbar_set_tooltips (GTK_TOOLBAR (toolbar_Icone_Liste_Port_Bouton), FALSE);
  	gtk_toolbar_set_show_arrow (GTK_TOOLBAR (toolbar_Icone_Liste_Port_Bouton), FALSE);
  	

	g_signal_connect ((gpointer) view, "button-press-event", G_CALLBACK (Selectionne_Icone), view);
	return view;
}
