/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifndef         __SEMAPHORE
#define         __SEMAPHORE

#include <sys/types.h>
#include "Declaration_Constante.h"

#ifdef         __SEMAPHORE_ENABLE
	#include 	"/usr/include/semaphore.h"
#endif

#ifdef         __MUTEX_ENABLE
	typedef struct {
	    pthread_mutex_t mutex;
	    pthread_cond_t cond;
	    int value;
	} sem_t;
#endif

#ifndef         __WINDOWS_ENABLE	
sem_t     Semaphore_Debug;
sem_t     Semaphore_Thread;
sem_t     Semaphore_Etat_Thread;
sem_t     Semaphore_Log_File;
sem_t     Semaphore_Mem;
sem_t     Semaphore_Fonction_Externe;
sem_t     Semaphore_Control_Usage_Socket;

void      Attendre_Semaphore (sem_t * sem);
void      Liberation_Semaphore (sem_t * sem);
void      Initialisation_Semaphore (void);
int       Valeur_Semaphore (sem_t * sem);
#else 
#include <windows.h>		
 
HANDLE    Semaphore_Nouveau_Equipement;	
HANDLE    Semaphore_Thread_Scan;	
HANDLE    Semaphore_Compteur;
int       Compteur_Nouveau_Equipement;	
int       Compteur_Thread_Scan;	
HANDLE    Semaphore_Debug;	
HANDLE    Semaphore_Thread; 
HANDLE    Semaphore_Etat_Thread; 
HANDLE    Semaphore_Log_File;  
HANDLE    Semaphore_Mem;
HANDLE    Semaphore_Fonction_Externe;
HANDLE    Semaphore_Control_Usage_Socket;

 
void      Attendre_Semaphore (HANDLE sem);	
void      Liberation_Semaphore (HANDLE sem);	
void      Initialisation_Semaphore (void);	
int       Valeur_Semaphore (HANDLE * sem);	
#endif 



#ifndef         __WINDOWS_ENABLE	
#define PROTECT_CODE(sem)	G_STMT_START{ Attendre_Semaphore (&sem); }G_STMT_END
#else 
#define PROTECT_CODE(sem)	G_STMT_START{ Attendre_Semaphore (sem); }G_STMT_END 
#endif 


#ifndef         __WINDOWS_ENABLE	
#define DEPROTECT_CODE(sem)	G_STMT_START{ Liberation_Semaphore (&sem); }G_STMT_END
#else 
#define DEPROTECT_CODE(sem)	G_STMT_START{ Liberation_Semaphore (sem); }G_STMT_END 
#endif 

#endif
