/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifndef         __CONFIGURATION
#define        __CONFIGURATION

#include <glib.h>
#include "config.h"

#define   DEFAULT_CONFIG  "%s/.autoscan-network/Config/autoscan-network.xml"
#define   DEFAULT_CONFIG_STATIC  "config/autoscan-network.xml"
#ifndef  __DARWIN_ENABLE
#define   DEFAULT_CONFIG_START  "/usr/share/apps/autoscan-network/autoscan-network.xml"
#else
#define   DEFAULT_CONFIG_START  "/opt/AutoScan-Network/usr/share/apps/autoscan-network/autoscan-network.xml"
#endif
#define   CONFIG_NAME  "config-autoscan-network"

char 		*Config_Path_Logs;
char 		*Config_Path_Icon;
gboolean Config_Copy_Config;
char 		*Config_Path_Config;
gboolean Config_First_Start;
char 		*Config_Path_Daemon;
gint			 Config_Level_Debug;
gboolean Config_Start_Minimized;
gboolean Config_Minimized_Tray_Icon;
char      	 *Config_Server_Smtp;
gint 		 Config_Audio_Device;
char 		 *Config_Directory_Sound_Alert;
gint 		 Config_Root_Position_X;
gint 		 Config_Root_Position_Y;
gint 		 Config_Root_Size_X;
gint 		 Config_Root_Size_Y;
gint 		 Config_Setting_Size_X;
gint 		 Config_Setting_Size_Y;
gint 		 Config_IconList_Icon_Width;
gint 		 Config_V_Paned_Position;
gint 		 Config_H_Paned_Position;
gboolean Config_Tree_View_Set_Hover_Expand;
gboolean Config_Tree_View_Set_Rules_Hint;
gint 		 Config_Thread_Max;
gboolean Config_Normal_Mode;
gboolean Config_Ip_Dynamic;
char      	 *Config_Wizard_Name_Network;
char      	 *Config_Wizard_Icon_Network;
char      	 *Config_Wizard_Restore_Folder;
char      	 *Config_Wizard_Connect_Ip_address;
gint 		 Config_Wizard_Connect_Port;
char      	 *Config_Wizard_Connect_User;
char      	 *Config_Wizard_Connect_Password;

void Write_Config(void);
void Read_Config(void);
#endif
