/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Restoration_Agent.h"
#include "Equipement.h"
#include "Equipement_Port.h"
#include "Equipement_Historique.h"
#include "Reseau.h"
#include "Debug.h"
#include "Objet.h"
#include "Commun.h"
#include "Initialisation_Com.h"
#include "Settings.h"
#include "Configuration.h"
#include "Declaration_Constante.h"
#include "Mem.h"
#include "Xml.h"
#include "Win32.h"

void Lit_Donnee_Xml_Restoration_Agent (xmlNodePtr xmlnodecurrent, gboolean Ip_Dynamic)
{
	gchar   *Address_IP = NULL, *Address_MAC = NULL;
	xmlNodePtr xml_Enfant = NULL;
	xmlNodePtr xmlnode = NULL;
	struct Struct_Subnet *Subnet = NULL;
	struct struct_Restauration_Machine Message;
	gint      Nb_Port_Ajouter;
	gint      Nb_Objet_Liste, i;

	ERROR_if (xmlnodecurrent == NULL);

	if (xmlnodecurrent->name && g_strcasecmp ((char *)xmlnodecurrent->name, "Subnet") == 0) {
		if (Subnet_Restauration != NULL) {
			Nb_Objet_Liste = g_list_length (Subnet_Restauration);
			for (i = 0; i < Nb_Objet_Liste; i++) {
				Subnet = g_list_nth_data (Subnet_Restauration, 0);
				G_LIST_REMOVE (Subnet_Restauration, Subnet);
				MYFREE (Subnet);
			}
		}
		xml_Enfant = xmlnodecurrent->children;
		while ((xml_Enfant != NULL) && (xml_Enfant->type != XML_ELEMENT_NODE))
			xml_Enfant = xml_Enfant->next;
		while (xml_Enfant) {
			if (!xml_Enfant->name || g_strcasecmp ((char *)xml_Enfant->name, "Subnet") != 0)
				return;
			MALLOC (Subnet, sizeof (struct Struct_Subnet));
		
			xmlnode = xml_Enfant;
			XML_READ_INT(Subnet->Masque,"Masque",1);
			XML_READ_INT(Subnet->A,"A",192);
			XML_READ_INT(Subnet->B,"B",168);
			XML_READ_INT(Subnet->C,"C",0);
			G_LIST_APPEND (Subnet_Restauration, Subnet);
		
			xml_Enfant = xml_Enfant->next;
			while ((xml_Enfant != NULL) && (xml_Enfant->type != XML_ELEMENT_NODE))
				xml_Enfant = xml_Enfant->next;
		}
		return;
	}


	if (!xmlnodecurrent->name || g_strcasecmp ((char *)xmlnodecurrent->name, "Equipment") != 0) {
		return;
	}


	bzero (&Message, sizeof (struct struct_Restauration_Machine));

	xmlnode = xmlnodecurrent;

	XML_READ_STRING(Address_IP,"Address_IP","");
	strcpy ((char *)Message.Adresse_Ip_Char, Address_IP);
	MYFREE (Address_IP);

	XML_READ_STRING(Address_MAC,"Address_MAC","");
	strcpy ((char *)Message.Adresse_MAC_Char, Address_MAC);
	MYFREE (Address_MAC);
	DEBUG_INFO("Restoration  : %s - %s",Message.Adresse_Ip_Char,Message.Adresse_MAC_Char);
	XML_READ_BOOL(Message.mss,"Mss",FALSE);


	xmlnodecurrent = xmlnodecurrent->children;
	while ((xmlnodecurrent != NULL) && (xmlnodecurrent->type != XML_ELEMENT_NODE))
		xmlnodecurrent = xmlnodecurrent->next;
	if (xmlnodecurrent) {
		while (xmlnodecurrent->name && g_strcasecmp ((char *)xmlnodecurrent->name, "Ports") != 0) {
			xmlnodecurrent = xmlnodecurrent->next;
			while ((xmlnodecurrent != NULL) && (xmlnodecurrent->type != XML_ELEMENT_NODE))
				xmlnodecurrent = xmlnodecurrent->next;
		}
		if (!xmlnodecurrent->name || g_strcasecmp ((char *)xmlnodecurrent->name, "Ports") != 0)
			return;
		xmlnodecurrent = xmlnodecurrent->children;
		while ((xmlnodecurrent != NULL) && (xmlnodecurrent->type != XML_ELEMENT_NODE))
			xmlnodecurrent = xmlnodecurrent->next;
		while (xmlnodecurrent->name && g_strcasecmp ((char *)xmlnodecurrent->name, "Open") != 0) {
			xmlnodecurrent = xmlnodecurrent->next;
			while ((xmlnodecurrent != NULL) && (xmlnodecurrent->type != XML_ELEMENT_NODE))
				xmlnodecurrent = xmlnodecurrent->next;
		}
		if (!xmlnodecurrent->name || g_strcasecmp ((char *)xmlnodecurrent->name, "Open") != 0)
			return;
		xmlnodecurrent = xmlnodecurrent->children;
		while ((xmlnodecurrent != NULL) && (xmlnodecurrent->type != XML_ELEMENT_NODE))
			xmlnodecurrent = xmlnodecurrent->next;

		Nb_Port_Ajouter = 0;
		while (xmlnodecurrent) {
			if (!xmlnodecurrent->name || g_strcasecmp ((char *)xmlnodecurrent->name, "Port") != 0)
				return;
		
			xmlnode = xmlnodecurrent;
			XML_READ_INT(Message.Port[Nb_Port_Ajouter].Num_Port,"Num",0);
		
			Nb_Port_Ajouter++;
		
			xmlnodecurrent = xmlnodecurrent->next;
			while ((xmlnodecurrent != NULL) && (xmlnodecurrent->type != XML_ELEMENT_NODE))
				xmlnodecurrent = xmlnodecurrent->next;
		}
	}
	Message.Ip_Dynamic = Ip_Dynamic;
	Communication_Envoie_Donnee (Pid_Agent_Initialisation, RESTAURATION_MACHINE, (gpointer *) & Message, sizeof (Message), NULL);
}


void Lit_Xml_Restoration_Agent (xmlDocPtr doc, gboolean Ip_Dynamic)
{
	xmlNodePtr node = NULL;
	xmlNode  *root_element = NULL;

	ERROR_if (doc == NULL);
	root_element = xmlDocGetRootElement (doc);
	for (node = root_element->children; node != NULL; node = node->next) {
		if (node->type == XML_ELEMENT_NODE)
			Lit_Donnee_Xml_Restoration_Agent (node, Ip_Dynamic);
	}
	DEBUG_WARNING("Restoration_Agent : OK");
}


gboolean Restoration_Agent (char *fname)
{
	xmlDocPtr doc = NULL;
	xmlNodePtr xmlnode = NULL;
	gboolean  Ip_Dynamic;

	if ((xmlnode = OpenXml(fname, "autoscan-network", &doc)) == NULL)
		return FALSE;

	XML_READ_STRING(Nom_Reseau_Restauration,"Network","No Name");
	XML_READ_STRING(Interface_Restauration,"Interface","eth0");
	XML_READ_STRING(Icon_Restauration,"Icon","drop.png");
	XML_READ_STRING(Communaute_Snmp_Restauration,"Communaute_Snmp","public");
	XML_READ_BOOL(Intrusion_Alert_Restauration ,"Intrusion_Alert",FALSE);
	XML_READ_BOOL(Ip_Dynamic,"Ip_Dynamic",FALSE);

	DEBUG_WARNING("Restauration %s-%s-%s-%s-%i", Nom_Reseau_Restauration, Interface_Restauration, Icon_Restauration, Communaute_Snmp_Restauration, Intrusion_Alert_Restauration);
	Lit_Xml_Restoration_Agent (doc, Ip_Dynamic);
	xmlFreeDoc (doc);
	return TRUE;
}



gboolean Lecture_Fichier_Restoration_Agent (char *fname)
{
	xmlDocPtr doc = NULL;
	xmlNodePtr xmlnode = NULL;

	if ((xmlnode = OpenXml(fname, "autoscan-network", &doc)) == NULL)
		return FALSE;

	XML_READ_STRING(Nom_Reseau_Fichier_Xml,"Network","No Name");
	XML_READ_STRING(Dns_Fichier_Xml,"Ip_Agent","127.0.0.1");
	XML_READ_INT(Port_Fichier_Xml,"Port_Agent",4555);

	XML_CLOSE (doc);
	return TRUE;
}


void Initialisation_Variable_Restoration_Agent (void)
{
	Nom_Reseau_Restauration = NULL;
	Interface_Restauration = NULL;
	Icon_Restauration = NULL;
	Communaute_Snmp_Restauration = NULL;
	Intrusion_Alert_Restauration = FALSE;
	Subnet_Restauration = NULL;

	Nom_Reseau_Fichier_Xml = NULL;
	Dns_Fichier_Xml = NULL;
}
