/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Files.h"
#include "Debug.h"


#ifndef         __WINDOWS_ENABLE
void Create_Dir(gchar *Chemin,mode_t mode){
	DIR      *dir = NULL;

	dir = opendir (Chemin);
	if (dir == NULL) {
	
		if (mkdir (Chemin, mode) != 0) {
			printf("ERROR : Creating folder: %s: %s\n", Chemin, strerror (errno));
			exit (1);
		}
		dir = opendir (Chemin);
		if (dir == NULL) {
			printf("ERROR : %s not found\n", Chemin);
			exit (-1);
		}
	}
	closedir (dir);
}
#endif

gboolean File_Exist(gchar *file,gboolean LogOk){
	ERROR_if (file == NULL);
	if (!g_file_test(file,G_FILE_TEST_EXISTS)){
		if (LogOk)
			DEBUG_WARNING("[Warning] : Loading file [%s] failed", file);
		else
			printf("[Warning] : Loading file [%s] failed\n", file);
		return FALSE;
	}
	return TRUE;
}


gboolean Copy_File (gchar * Source, gchar * Destination)
{
	FILE     *fsource = NULL, *fdestination = NULL;
	gchar     buffer[255];

	ERROR_if (Source == NULL);
	ERROR_if (Destination == NULL);
	DEBUG_WARNING("Copy file (%s)(%s)",Source,Destination);
	fsource = fopen (Source, "r");
	if (fsource == NULL) {
		DEBUG_WARNING("Reading file: %s: %s", Source, strerror (errno));
		return FALSE;
	}

	fdestination = fopen (Destination, "w");
	if (fdestination == NULL) {
		DEBUG_WARNING("Creating file: %s: %s", Destination, strerror (errno));
		fclose (fsource);
		return FALSE;
	}
	while (fgets (buffer, sizeof (buffer), fsource) != NULL) {
		if (fputs (buffer, fdestination) == EOF)
			break;
	}
	fclose (fsource);
	fclose (fdestination);
	return TRUE;
}

#ifndef         __WINDOWS_ENABLE
void mk_directory (gchar *Chemin, gint droit)
{
	DIR      *dir = NULL;

	ERROR_if (Chemin == NULL);
	ERROR_if (droit == 0);
	dir = opendir (Chemin);
	if (dir == NULL) {
		if (mkdir (Chemin, droit) != 0) {
			DEBUG_WARNING("Creating folder: %s: %s", Chemin, strerror (errno));
			exit (1);
		}
		dir = opendir (Chemin);
		if (dir == NULL) {
			printf("ERROR : %s not found", Chemin);
			exit (-1);
		}
	}
	closedir (dir);
}
#endif
